/* A Bison parser, made by GNU Bison 2.0.  */

/* Skeleton parser for GLR parsing with Bison,
   Copyright (C) 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* This is the parser code for GLR (Generalized LR) parser. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <setjmp.h>

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "glr.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 1



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     prec_lower_than_error = 258,
     prec_if = 259,
     p_else = 260,
     p_and = 261,
     p_array = 262,
     p_begin = 263,
     p_case = 264,
     p_div = 265,
     p_do = 266,
     p_downto = 267,
     p_end = 268,
     p_file = 269,
     p_for = 270,
     p_function = 271,
     p_goto = 272,
     p_if = 273,
     p_in = 274,
     p_label = 275,
     p_mod = 276,
     p_nil = 277,
     p_not = 278,
     p_of = 279,
     p_or = 280,
     p_packed = 281,
     p_procedure = 282,
     p_to = 283,
     p_program = 284,
     p_record = 285,
     p_repeat = 286,
     p_set = 287,
     p_then = 288,
     p_type = 289,
     p_until = 290,
     p_var = 291,
     p_while = 292,
     p_with = 293,
     p_absolute = 294,
     p_abstract = 295,
     p_and_then = 296,
     p_as = 297,
     p_asm = 298,
     p_attribute = 299,
     p_bindable = 300,
     p_const = 301,
     p_constructor = 302,
     p_destructor = 303,
     p_external = 304,
     p_far = 305,
     p_finalization = 306,
     p_forward = 307,
     p_implementation = 308,
     p_import = 309,
     p_inherited = 310,
     p_initialization = 311,
     p_is = 312,
     p_near = 313,
     p_object = 314,
     p_only = 315,
     p_operator = 316,
     p_otherwise = 317,
     p_or_else = 318,
     p_pow = 319,
     p_qualified = 320,
     p_restricted = 321,
     p_shl = 322,
     p_shr = 323,
     p_unit = 324,
     p_uses = 325,
     p_value = 326,
     p_virtual = 327,
     p_xor = 328,
     p_asmname = 329,
     p_c = 330,
     p_c_language = 331,
     p_Addr = 332,
     p_Assigned = 333,
     p_Dispose = 334,
     p_Exit = 335,
     p_FormatString = 336,
     p_New = 337,
     p_Return = 338,
     LEX_INTCONST = 339,
     LEX_INTCONST_BASE = 340,
     LEX_STRCONST = 341,
     LEX_REALCONST = 342,
     LEX_BUILTIN_PROCEDURE = 343,
     LEX_BUILTIN_PROCEDURE_WRITE = 344,
     LEX_BUILTIN_FUNCTION = 345,
     LEX_ID = 346,
     LEX_CARET_WHITE = 347,
     LEX_CARET_LETTER = 348,
     LEX_ASSIGN = 349,
     LEX_RENAME = 350,
     LEX_RANGE = 351,
     LEX_ELLIPSIS = 352,
     LEX_CONST_EQUAL = 353,
     LEX_SYMDIFF = 354,
     LEX_NE = 355,
     LEX_GE = 356,
     LEX_LE = 357,
     LEX_POWER = 358,
     LEX_BPPLUS = 359,
     LEX_BPMINUS = 360,
     LEX_CEIL_PLUS = 361,
     LEX_CEIL_MINUS = 362,
     LEX_FLOOR_PLUS = 363,
     LEX_FLOOR_MINUS = 364,
     LEX_CEIL_MULT = 365,
     LEX_CEIL_DIV = 366,
     LEX_FLOOR_MULT = 367,
     LEX_FLOOR_DIV = 368
   };
#endif
#define prec_lower_than_error 258
#define prec_if 259
#define p_else 260
#define p_and 261
#define p_array 262
#define p_begin 263
#define p_case 264
#define p_div 265
#define p_do 266
#define p_downto 267
#define p_end 268
#define p_file 269
#define p_for 270
#define p_function 271
#define p_goto 272
#define p_if 273
#define p_in 274
#define p_label 275
#define p_mod 276
#define p_nil 277
#define p_not 278
#define p_of 279
#define p_or 280
#define p_packed 281
#define p_procedure 282
#define p_to 283
#define p_program 284
#define p_record 285
#define p_repeat 286
#define p_set 287
#define p_then 288
#define p_type 289
#define p_until 290
#define p_var 291
#define p_while 292
#define p_with 293
#define p_absolute 294
#define p_abstract 295
#define p_and_then 296
#define p_as 297
#define p_asm 298
#define p_attribute 299
#define p_bindable 300
#define p_const 301
#define p_constructor 302
#define p_destructor 303
#define p_external 304
#define p_far 305
#define p_finalization 306
#define p_forward 307
#define p_implementation 308
#define p_import 309
#define p_inherited 310
#define p_initialization 311
#define p_is 312
#define p_near 313
#define p_object 314
#define p_only 315
#define p_operator 316
#define p_otherwise 317
#define p_or_else 318
#define p_pow 319
#define p_qualified 320
#define p_restricted 321
#define p_shl 322
#define p_shr 323
#define p_unit 324
#define p_uses 325
#define p_value 326
#define p_virtual 327
#define p_xor 328
#define p_asmname 329
#define p_c 330
#define p_c_language 331
#define p_Addr 332
#define p_Assigned 333
#define p_Dispose 334
#define p_Exit 335
#define p_FormatString 336
#define p_New 337
#define p_Return 338
#define LEX_INTCONST 339
#define LEX_INTCONST_BASE 340
#define LEX_STRCONST 341
#define LEX_REALCONST 342
#define LEX_BUILTIN_PROCEDURE 343
#define LEX_BUILTIN_PROCEDURE_WRITE 344
#define LEX_BUILTIN_FUNCTION 345
#define LEX_ID 346
#define LEX_CARET_WHITE 347
#define LEX_CARET_LETTER 348
#define LEX_ASSIGN 349
#define LEX_RENAME 350
#define LEX_RANGE 351
#define LEX_ELLIPSIS 352
#define LEX_CONST_EQUAL 353
#define LEX_SYMDIFF 354
#define LEX_NE 355
#define LEX_GE 356
#define LEX_LE 357
#define LEX_POWER 358
#define LEX_BPPLUS 359
#define LEX_BPMINUS 360
#define LEX_CEIL_PLUS 361
#define LEX_CEIL_MINUS 362
#define LEX_FLOOR_PLUS 363
#define LEX_FLOOR_MINUS 364
#define LEX_CEIL_MULT 365
#define LEX_CEIL_DIV 366
#define LEX_FLOOR_MULT 367
#define LEX_FLOOR_DIV 368




/* Copy the first part of user declarations.  */
#line 63 "parse.y"

#include "gpc.h"

/* A few keywords of some dialects can be parsed as regular identifiers
   and checked from the parser actions => fewer special tokens. */
#define ASSERT_ID(id, location, pseudo_keyword) \
  do if (!IDENTIFIER_IS_BUILT_IN (id, pseudo_keyword) || !PD_ACTIVE (IDENTIFIER_BUILT_IN_VALUE (id))) \
    { yyerror_id (id, &location); YYERROR; } while (0)

enum { od_none, od_uses, od_label, od_const, od_type, od_var, od_routine };
static int check_decl_order (int, int);

extern int main_yyparse (void);
#define yyparse main_yyparse

union yyGLRStackItem;
static void locations (YYLTYPE *, const union yyGLRStackItem *, int);
#define YYLLOC_DEFAULT(DEST, SRC, N) locations (&DEST, SRC, N)
#ifndef GCC_3_4
#define LOCATION_NOTE(LOC) if (current_function_decl) emit_line_note ((LOC).first_file, (LOC).first_line)
#else
#define LOCATION_NOTE(LOC) if (current_function_decl) \
  { \
    location_t loc_aux; \
    loc_aux.file = (LOC).first_file; \
    loc_aux.line = (LOC).first_line; \
    emit_line_note (loc_aux); \
  }
#endif
#define COPYLOC(D, S) /* @@ ? (* (YYLTYPE *) memcpy (&(D), &(S), sizeof (YYLTYPE))) */ (S)

#define YYASSERT gcc_assert
#define YYMALLOC (void *) xmalloc
#define YYREALLOC (void *) xrealloc


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 108 "parse.y"
typedef union YYSTYPE {
  enum tree_code code;
  long itype;
  tree ttype;
} YYSTYPE;
/* Line 186 of glr.c.  */
#line 337 "parse.c"
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif

#if ! defined (YYLTYPE) && ! defined (YYLTYPE_IS_DECLARED)
typedef struct YYLTYPE
{

  int first_line;
  int first_column;
  int last_line;
  int last_column;

} YYLTYPE;
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif

/* Default (constant) value used for initialization for null
   right-hand sides.  Unlike the standard yacc.c template,
   here we set the default value of $$ to a zeroed-out value.
   Since the default value is undefined, this behavior is
   technically correct. */
static YYSTYPE yyval_default;

/* Copy the second part of user declarations.  */


/* Line 217 of glr.c.  */
#line 367 "parse.c"

#ifndef YYFREE
# define YYFREE free
#endif
#ifndef YYMALLOC
# define YYMALLOC malloc
#endif
#ifndef YYREALLOC
# define YYREALLOC realloc
#endif

#ifdef __cplusplus
   typedef bool yybool;
#else
   typedef unsigned char yybool;
#endif
#define yytrue 1
#define yyfalse 0

/*-----------------.
| GCC extensions.  |
`-----------------*/

#ifndef __attribute__
/* This feature is available in gcc versions 2.5 and later.  */
# if !defined (__GNUC__) || __GNUC__ < 2 || \
(__GNUC__ == 2 && __GNUC_MINOR__ < 5) || __STRICT_ANSI__
#  define __attribute__(Spec) /* empty */
# endif
#endif

#ifndef YYASSERT
# define YYASSERT(condition) ((void) ((condition) || (abort (), 0)))
#endif

#ifndef ATTRIBUTE_UNUSED
# define ATTRIBUTE_UNUSED __attribute__ ((__unused__))
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  66
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   8070

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  133
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  279
/* YYNRULES -- Number of rules. */
#define YYNRULES  768
/* YYNRULES -- Number of states. */
#define YYNSTATES  1279
/* YYMAXRHS -- Maximum number of symbols on right-hand side of rule. */
#define YYMAXRHS 12
/* YYMAXLEFT -- Maximum number of symbols to the left of a handle
   accessed by $0, $-1, etc., in any rule. */
#define YYMAXLEFT 0

/* YYTRANSLATE(X) -- Bison symbol number corresponding to X.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   368

#define YYTRANSLATE(YYX)						\
  ((YYX <= 0) ? YYEOF :							\
   (unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   132,     2,
     115,   116,   126,   124,   117,   125,   123,   127,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   118,   114,
     128,   129,   130,     2,   121,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   119,     2,   120,   122,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   131,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     4,     6,     7,     8,    17,    19,    20,
      21,    34,    36,    38,    39,    43,    44,    45,    55,    56,
      63,    64,    65,    74,    75,    83,    84,    92,    93,    94,
     101,   102,   107,   108,   112,   114,   115,   120,   122,   123,
     127,   129,   130,   133,   135,   137,   138,   145,   146,   153,
     154,   159,   164,   168,   170,   174,   176,   179,   181,   185,
     187,   191,   195,   199,   203,   205,   210,   212,   214,   218,
     220,   224,   228,   231,   235,   239,   240,   243,   244,   248,
     250,   254,   258,   263,   265,   267,   269,   273,   278,   280,
     284,   286,   290,   294,   297,   299,   302,   303,   306,   308,
     310,   311,   314,   315,   318,   322,   324,   325,   328,   330,
     332,   334,   335,   338,   340,   341,   344,   346,   350,   352,
     356,   360,   363,   365,   368,   369,   372,   375,   376,   381,
     384,   386,   390,   392,   396,   400,   403,   405,   407,   409,
     412,   414,   419,   428,   430,   433,   434,   443,   445,   447,
     451,   453,   456,   457,   463,   465,   469,   472,   474,   476,
     477,   481,   484,   486,   490,   492,   496,   500,   503,   509,
     510,   517,   521,   522,   532,   536,   540,   542,   546,   550,
     554,   557,   561,   563,   566,   567,   570,   572,   575,   577,
     580,   583,   585,   587,   589,   591,   593,   596,   600,   604,
     606,   610,   612,   616,   620,   627,   629,   634,   638,   642,
     646,   648,   650,   654,   656,   660,   664,   667,   669,   671,
     673,   674,   677,   685,   687,   690,   692,   696,   700,   704,
     707,   712,   713,   719,   723,   727,   729,   731,   733,   737,
     741,   743,   746,   752,   754,   756,   758,   762,   766,   768,
     772,   776,   780,   783,   787,   792,   795,   798,   801,   805,
     807,   809,   811,   814,   818,   820,   824,   828,   830,   832,
     834,   837,   839,   841,   844,   848,   853,   857,   863,   867,
     871,   873,   876,   878,   880,   882,   885,   888,   890,   892,
     894,   898,   902,   903,   904,   914,   916,   918,   922,   928,
     934,   940,   948,   954,   960,   962,   964,   968,   971,   975,
     976,   983,   990,   997,  1001,  1004,  1007,  1009,  1013,  1017,
    1022,  1024,  1028,  1030,  1032,  1034,  1038,  1043,  1050,  1052,
    1054,  1056,  1058,  1060,  1063,  1065,  1067,  1070,  1074,  1078,
    1084,  1088,  1090,  1094,  1098,  1102,  1106,  1111,  1116,  1120,
    1124,  1130,  1132,  1135,  1137,  1139,  1142,  1144,  1145,  1147,
    1149,  1150,  1153,  1155,  1157,  1159,  1163,  1165,  1167,  1174,
    1182,  1184,  1188,  1192,  1196,  1202,  1206,  1208,  1210,  1216,
    1218,  1222,  1223,  1225,  1226,  1227,  1233,  1235,  1237,  1238,
    1239,  1242,  1244,  1247,  1249,  1251,  1253,  1254,  1259,  1261,
    1264,  1266,  1271,  1276,  1278,  1285,  1287,  1288,  1295,  1296,
    1297,  1306,  1307,  1308,  1309,  1319,  1320,  1321,  1330,  1331,
    1343,  1344,  1354,  1357,  1360,  1362,  1366,  1368,  1372,  1376,
    1378,  1382,  1383,  1391,  1392,  1397,  1399,  1401,  1402,  1405,
    1407,  1411,  1413,  1417,  1421,  1422,  1429,  1431,  1435,  1439,
    1443,  1446,  1448,  1452,  1456,  1460,  1462,  1464,  1466,  1468,
    1471,  1473,  1475,  1478,  1480,  1485,  1490,  1497,  1505,  1511,
    1519,  1529,  1541,  1542,  1544,  1546,  1548,  1550,  1554,  1559,
    1561,  1565,  1567,  1569,  1573,  1575,  1578,  1582,  1586,  1587,
    1592,  1594,  1598,  1602,  1603,  1608,  1610,  1614,  1618,  1622,
    1626,  1630,  1633,  1636,  1638,  1640,  1642,  1644,  1646,  1648,
    1650,  1652,  1654,  1656,  1658,  1660,  1663,  1665,  1667,  1670,
    1672,  1674,  1676,  1678,  1680,  1682,  1684,  1686,  1688,  1690,
    1692,  1694,  1696,  1698,  1700,  1702,  1704,  1706,  1708,  1710,
    1712,  1716,  1719,  1721,  1723,  1725,  1729,  1733,  1736,  1741,
    1746,  1750,  1756,  1759,  1764,  1770,  1775,  1780,  1787,  1795,
    1797,  1802,  1807,  1808,  1810,  1814,  1816,  1820,  1822,  1826,
    1830,  1834,  1836,  1840,  1846,  1848,  1851,  1855,  1859,  1861,
    1863,  1865,  1869,  1873,  1875,  1882,  1887,  1892,  1896,  1898,
    1901,  1905,  1909,  1913,  1915,  1919,  1923,  1925,  1927,  1931,
    1933,  1935,  1939,  1941,  1945,  1949,  1951,  1953,  1957,  1960,
    1964,  1966,  1970,  1974,  1978,  1980,  1984,  1986,  1988,  1990,
    1992,  1994,  1996,  1998,  2000,  2002,  2004,  2006,  2008,  2010,
    2012,  2014,  2016,  2018,  2020,  2022,  2024,  2026,  2028,  2030,
    2032,  2034,  2037,  2039,  2041,  2043,  2046,  2048,  2050,  2052,
    2054,  2056,  2058,  2060,  2062,  2064,  2066,  2068,  2070,  2072,
    2074,  2076,  2078,  2080,  2082,  2084,  2086,  2088,  2090,  2092,
    2094,  2096,  2098,  2100,  2102,  2104,  2106,  2108,  2110,  2112,
    2114,  2116,  2118,  2120,  2122,  2124,  2126,  2128,  2130,  2132,
    2134,  2136,  2140,  2144,  2148,  2151,  2153,  2157,  2159,  2163,
    2165,  2167,  2169,  2171,  2173,  2175,  2177,  2179,  2181,  2183,
    2185,  2187,  2189,  2191,  2193,  2195,  2197,  2199,  2201,  2203,
    2205,  2207,  2209,  2211,  2213,  2215,  2217,  2219,  2221,  2223,
    2225,  2227,  2229,  2231,  2233,  2235,  2237,  2239,  2241,  2243,
    2245,  2247,  2249,  2251,  2253,  2255,  2257,  2259,  2261,  2263,
    2265,  2267,  2269,  2270,  2271,  2272,  2274,  2276,  2278,  2279,
    2281,  2283,  2285,  2287,  2289,  2291,  2293,  2295,  2296
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short int yyrhs[] =
{
     134,     0,    -1,    -1,   135,    -1,    -1,    -1,   167,   170,
     136,   177,   187,   137,   294,   409,    -1,   138,    -1,    -1,
      -1,    69,   395,   114,   170,    91,   139,   177,   192,   140,
     155,    13,   409,    -1,   145,    -1,   150,    -1,    -1,   145,
     141,   150,    -1,    -1,    -1,   405,   395,   168,   142,   148,
     114,   143,   152,   409,    -1,    -1,   405,   395,   168,   144,
     152,   409,    -1,    -1,    -1,   405,   395,    91,   146,   168,
     147,   148,   409,    -1,    -1,    91,   149,   171,   114,   177,
     192,    13,    -1,    -1,   405,   395,    53,   114,   151,   152,
     409,    -1,    -1,    -1,   153,   179,   194,   154,   162,    13,
      -1,    -1,    53,   179,   187,   156,    -1,    -1,     8,   157,
     161,    -1,   159,    -1,    -1,   159,    51,   158,   295,    -1,
     162,    -1,    -1,    56,   160,   161,    -1,   295,    -1,    -1,
     163,   165,    -1,   163,    -1,   165,    -1,    -1,    28,     8,
      11,   164,   299,   114,    -1,    -1,    28,    13,    11,   166,
     299,   114,    -1,    -1,    29,   395,   169,   114,    -1,    29,
       1,   169,   114,    -1,   169,   114,   170,    -1,   410,    -1,
     115,   391,   116,    -1,   410,    -1,   272,   114,    -1,   172,
      -1,   171,   114,   172,    -1,     1,    -1,   171,     1,   172,
      -1,   171,   114,     1,    -1,   395,   408,   173,    -1,   115,
     175,   116,    -1,   174,    -1,   174,   115,   175,   116,    -1,
      91,    -1,   176,    -1,   175,   117,   176,    -1,     1,    -1,
     175,     1,   176,    -1,   175,   117,     1,    -1,   394,   186,
      -1,   394,    96,   394,    -1,   404,   394,   186,    -1,    -1,
     178,   179,    -1,    -1,    54,   180,   114,    -1,   181,    -1,
     180,   114,   181,    -1,   180,     1,   181,    -1,   395,   182,
     183,   200,    -1,   410,    -1,    65,    -1,   410,    -1,   115,
     184,   116,    -1,    60,   115,   184,   116,    -1,   185,    -1,
     184,   117,   185,    -1,     1,    -1,   184,     1,   185,    -1,
     184,   117,     1,    -1,   395,   186,    -1,   410,    -1,    95,
     395,    -1,    -1,   187,   188,    -1,   197,    -1,   190,    -1,
      -1,   189,   190,    -1,    -1,   191,   201,    -1,    20,   205,
     114,    -1,   261,    -1,    -1,   192,   193,    -1,   197,    -1,
     201,    -1,   260,    -1,    -1,   194,   195,    -1,   197,    -1,
      -1,   196,   201,    -1,   261,    -1,    70,   198,   114,    -1,
     199,    -1,   198,   117,   199,    -1,   198,     1,   199,    -1,
     395,   200,    -1,   410,    -1,    19,   339,    -1,    -1,   202,
     203,    -1,    46,   207,    -1,    -1,    34,   204,   219,   114,
      -1,    36,   209,    -1,   206,    -1,   205,   117,   206,    -1,
       1,    -1,   205,     1,   206,    -1,   205,   117,     1,    -1,
     205,     1,    -1,   390,    -1,   395,    -1,   208,    -1,   207,
     208,    -1,     1,    -1,   395,   408,   338,   114,    -1,   395,
     402,   118,   226,    98,   369,   215,   114,    -1,   210,    -1,
     209,   210,    -1,    -1,   393,   402,   118,   226,   211,   217,
     212,   114,    -1,     1,    -1,   410,    -1,   212,   114,   213,
      -1,   216,    -1,    49,   347,    -1,    -1,    49,   347,    91,
     214,   339,    -1,   410,    -1,   215,   114,   216,    -1,    74,
     339,    -1,   272,    -1,   258,    -1,    -1,    39,   218,   339,
      -1,    39,     1,    -1,   220,    -1,   219,   114,   220,    -1,
       1,    -1,   219,     1,   220,    -1,   219,   114,     1,    -1,
     219,     1,    -1,   395,   402,   408,   226,   258,    -1,    -1,
     395,   223,   408,   221,   226,   258,    -1,   395,   223,     1,
      -1,    -1,   395,   402,   408,   222,   254,    59,   253,   255,
      13,    -1,   115,   224,   116,    -1,   115,     1,   116,    -1,
     225,    -1,   224,   114,   225,    -1,   224,     1,   225,    -1,
     224,   114,     1,    -1,   224,     1,    -1,   391,   118,   353,
      -1,   227,    -1,   226,   272,    -1,    -1,   228,   229,    -1,
     230,    -1,    45,   230,    -1,   352,    -1,    66,   352,    -1,
     353,   231,    -1,   287,    -1,   246,    -1,   250,    -1,   252,
      -1,   233,    -1,   403,   233,    -1,   115,   232,   116,    -1,
     119,   339,   120,    -1,   339,    -1,   232,   117,   339,    -1,
       1,    -1,   232,     1,   339,    -1,   232,   117,     1,    -1,
       7,   119,   235,   120,    24,   227,    -1,   362,    -1,    14,
     234,    24,   227,    -1,    32,    24,   227,    -1,    30,   237,
      13,    -1,    30,     1,    13,    -1,   411,    -1,   410,    -1,
     119,   236,   120,    -1,   236,    -1,   235,   117,   236,    -1,
     235,     1,   236,    -1,   235,     1,    -1,     1,    -1,   246,
      -1,   353,    -1,    -1,   239,   406,    -1,   238,     9,   242,
      24,   243,   406,   241,    -1,   410,    -1,   239,   114,    -1,
     240,    -1,   239,   114,   240,    -1,   239,     1,   240,    -1,
     239,   114,     1,    -1,   239,     1,    -1,   391,   118,   227,
     258,    -1,    -1,   322,   115,   237,   116,   406,    -1,   395,
     118,   353,    -1,   395,   118,   245,    -1,   398,    -1,   245,
      -1,   244,    -1,   243,   114,   244,    -1,   243,     1,   244,
      -1,     1,    -1,   243,     1,    -1,   327,   118,   115,   237,
     116,    -1,   246,    -1,   247,    -1,   249,    -1,   115,   248,
     116,    -1,   115,     1,   116,    -1,   395,    -1,   248,   117,
     395,    -1,   248,     1,   395,    -1,   248,   117,     1,    -1,
     248,     1,    -1,   339,    96,   339,    -1,   403,   339,    96,
     339,    -1,   121,   251,    -1,   122,   251,    -1,    92,   251,
      -1,   407,    46,   251,    -1,   395,    -1,   252,    -1,   362,
      -1,    27,   278,    -1,    16,   278,   281,    -1,   410,    -1,
     115,   353,   116,    -1,   115,     1,   116,    -1,   410,    -1,
      40,    -1,   256,    -1,   256,   257,    -1,     1,    -1,   410,
      -1,   256,    91,    -1,   256,   257,   114,    -1,   391,   118,
     227,   258,    -1,    27,   395,   278,    -1,    16,   395,   278,
     282,   281,    -1,    47,   395,   278,    -1,    48,   395,   278,
      -1,    72,    -1,    72,   339,    -1,    40,    -1,   272,    -1,
     410,    -1,   259,   369,    -1,   259,     1,    -1,    71,    -1,
      94,    -1,    98,    -1,   265,   114,   267,    -1,   264,   114,
     268,    -1,    -1,    -1,   264,   114,   271,   262,   179,   189,
     263,   294,   114,    -1,   265,    -1,   266,    -1,    27,   395,
     278,    -1,    16,   395,   278,   282,   281,    -1,    61,   276,
     278,   277,   281,    -1,    27,   395,   123,   395,   278,    -1,
      16,   395,   123,   395,   278,   282,   281,    -1,    47,   395,
     123,   395,   278,    -1,    48,   395,   123,   395,   278,    -1,
     271,    -1,   268,    -1,   271,   269,   271,    -1,    52,   114,
      -1,    49,   347,   114,    -1,    -1,    49,   347,    91,   270,
     339,   114,    -1,    49,   347,   114,    74,   339,   114,    -1,
      74,   339,   114,    49,   347,   114,    -1,    74,   339,   114,
      -1,    75,   114,    -1,    76,   114,    -1,   410,    -1,   271,
     272,   114,    -1,   271,   275,   114,    -1,    44,   115,   273,
     116,    -1,   274,    -1,   273,   117,   274,    -1,   410,    -1,
      46,    -1,   395,    -1,   395,   408,   339,    -1,   395,   115,
     339,   116,    -1,   395,   115,   398,   117,   339,   116,    -1,
      50,    -1,    58,    -1,   395,    -1,   386,    -1,   395,    -1,
     408,   395,    -1,   410,    -1,   410,    -1,   115,   116,    -1,
     115,   279,   116,    -1,   115,    97,   116,    -1,   115,   279,
     114,    97,   116,    -1,   115,     1,   116,    -1,   280,    -1,
     279,   114,   280,    -1,   279,     1,   280,    -1,   279,   114,
       1,    -1,   391,   118,   286,    -1,   404,   391,   118,   286,
      -1,   284,    36,   391,   285,    -1,    46,   391,   285,    -1,
      27,   395,   278,    -1,    16,   395,   278,   282,   281,    -1,
     300,    -1,   118,   352,    -1,   411,    -1,   410,    -1,   283,
     395,    -1,   408,    -1,    -1,   410,    -1,   404,    -1,    -1,
     118,   286,    -1,   288,    -1,   287,    -1,   292,    -1,    34,
      24,   339,    -1,   293,    -1,   289,    -1,     7,   119,   290,
     120,    24,   288,    -1,   403,     7,   119,   291,   120,    24,
     353,    -1,   291,    -1,   290,   114,   291,    -1,   290,     1,
     291,    -1,   290,   114,     1,    -1,   395,    96,   395,   118,
     353,    -1,     7,    24,   293,    -1,   353,    -1,   362,    -1,
       8,   400,   295,   401,    13,    -1,   296,    -1,   295,   114,
     296,    -1,    -1,   301,    -1,    -1,    -1,    36,   297,   210,
     298,   296,    -1,   300,    -1,   301,    -1,    -1,    -1,   302,
     303,    -1,   316,    -1,   316,   304,    -1,   304,    -1,   294,
      -1,   330,    -1,    -1,   330,   305,   331,   339,    -1,    83,
      -1,    83,   339,    -1,    80,    -1,    80,   115,    29,   116,
      -1,    80,   115,   398,   116,    -1,   332,    -1,    38,   317,
      11,   400,   299,   401,    -1,   319,    -1,    -1,   319,     5,
     306,   400,   299,   401,    -1,    -1,    -1,     9,   339,    24,
     307,   323,   308,   321,    13,    -1,    -1,    -1,    -1,    31,
     309,   400,   295,    35,   310,   339,   311,   401,    -1,    -1,
      -1,    37,   312,   400,   339,   313,    11,   299,   401,    -1,
      -1,    15,   355,   331,   339,   329,   339,   314,    11,   400,
     299,   401,    -1,    -1,    15,   355,    19,   339,   315,    11,
     400,   299,   401,    -1,    17,   389,    -1,   389,   118,    -1,
     318,    -1,   317,   117,   318,    -1,     1,    -1,   317,     1,
     318,    -1,   317,   117,     1,    -1,   339,    -1,   339,   118,
     395,    -1,    -1,    18,   339,    33,   320,   400,   299,   401,
      -1,    -1,   322,   400,   295,   401,    -1,     5,    -1,    62,
      -1,    -1,   324,   406,    -1,   325,    -1,   324,   114,   325,
      -1,     1,    -1,   324,     1,   325,    -1,   324,   114,     1,
      -1,    -1,   327,   118,   326,   400,   299,   401,    -1,   328,
      -1,   327,   117,   328,    -1,   327,   117,     1,    -1,   327,
       1,   328,    -1,   327,     1,    -1,   338,    -1,   338,    96,
     338,    -1,   338,     1,   338,    -1,   338,    96,     1,    -1,
      28,    -1,    12,    -1,     1,    -1,   355,    -1,   121,   355,
      -1,    94,    -1,   408,    -1,   385,   357,    -1,    89,    -1,
      89,   115,   360,   116,    -1,    79,   115,   339,   116,    -1,
      79,   115,   339,   117,   359,   116,    -1,    79,   115,   339,
     117,   395,   357,   116,    -1,    43,   333,   115,   349,   116,
      -1,    43,   333,   115,   349,   118,   334,   116,    -1,    43,
     333,   115,   349,   118,   334,   118,   334,   116,    -1,    43,
     333,   115,   349,   118,   334,   118,   334,   118,   337,   116,
      -1,    -1,    91,    -1,   410,    -1,   335,    -1,   336,    -1,
     335,   117,   336,    -1,   348,   115,   339,   116,    -1,   348,
      -1,   337,   117,   348,    -1,   339,    -1,   340,    -1,   340,
     380,   340,    -1,   342,    -1,   378,   342,    -1,   340,   381,
     342,    -1,   340,   387,   342,    -1,    -1,   340,   383,   341,
     342,    -1,   344,    -1,   342,   382,   344,    -1,   342,   388,
     344,    -1,    -1,   342,   384,   343,   344,    -1,   345,    -1,
     344,   398,   345,    -1,   345,    64,   345,    -1,   345,   103,
     345,    -1,   344,    57,   353,    -1,   344,    42,   353,    -1,
     379,   345,    -1,   121,   345,    -1,   348,    -1,   346,    -1,
      22,    -1,   375,    -1,   355,    -1,    84,    -1,    85,    -1,
      87,    -1,   410,    -1,   348,    -1,   349,    -1,   350,    -1,
     349,   350,    -1,    86,    -1,    92,    -1,   122,   351,    -1,
      93,    -1,   117,    -1,   123,    -1,   118,    -1,   114,    -1,
     115,    -1,   116,    -1,   119,    -1,   120,    -1,   124,    -1,
     125,    -1,   126,    -1,   127,    -1,   128,    -1,   129,    -1,
     130,    -1,   121,    -1,   122,    -1,   353,    -1,   354,    -1,
     398,    -1,   398,   123,   398,    -1,    90,   357,    -1,   356,
      -1,   397,    -1,   362,    -1,   115,   339,   116,    -1,   355,
     123,   395,    -1,   355,   407,    -1,   355,   119,   373,   120,
      -1,   355,   119,   363,   120,    -1,   356,   115,   116,    -1,
     356,   115,   358,   359,   116,    -1,    55,   395,    -1,    81,
     115,   360,   116,    -1,    78,   115,   358,   339,   116,    -1,
      77,   115,   355,   116,    -1,    82,   115,   355,   116,    -1,
      82,   115,   355,   117,   359,   116,    -1,    82,   115,   355,
     117,   395,   357,   116,    -1,   410,    -1,   115,   358,   359,
     116,    -1,   115,   358,   355,   116,    -1,    -1,   339,    -1,
     359,   117,   339,    -1,     1,    -1,   359,   117,     1,    -1,
     361,    -1,   360,   117,   361,    -1,   360,     1,   361,    -1,
     360,   117,     1,    -1,   339,    -1,   339,   118,   339,    -1,
     339,   118,   339,   118,   339,    -1,    14,    -1,   364,   406,
      -1,   364,   114,   366,    -1,   364,   406,   368,    -1,   366,
      -1,   368,    -1,   365,    -1,   364,   114,   365,    -1,   373,
     118,   369,    -1,   369,    -1,     9,   395,   118,   339,    24,
     367,    -1,     9,   339,    24,   367,    -1,   119,   363,   120,
     406,    -1,    62,   369,   406,    -1,   339,    -1,   115,   116,
      -1,   115,   370,   116,    -1,   119,   363,   120,    -1,   119,
       1,   120,    -1,   372,    -1,   370,   371,   372,    -1,   370,
       1,   372,    -1,   114,    -1,   117,    -1,   374,   118,   369,
      -1,   369,    -1,   374,    -1,   373,   117,   374,    -1,     1,
      -1,   373,     1,   374,    -1,   373,   117,     1,    -1,   395,
      -1,   339,    -1,   339,    96,   339,    -1,   119,   120,    -1,
     119,   376,   120,    -1,   377,    -1,   376,   117,   377,    -1,
     376,     1,   377,    -1,   376,   117,     1,    -1,   339,    -1,
     339,    96,   339,    -1,   124,    -1,   125,    -1,   104,    -1,
     105,    -1,    23,    -1,   100,    -1,   102,    -1,   101,    -1,
     129,    -1,   128,    -1,   130,    -1,    19,    -1,   124,    -1,
     104,    -1,   125,    -1,   105,    -1,    73,    -1,    99,    -1,
     126,    -1,   127,    -1,    10,    -1,    21,    -1,    67,    -1,
      68,    -1,    25,    -1,    25,     5,    -1,    63,    -1,   131,
      -1,     6,    -1,     6,    33,    -1,    41,    -1,   132,    -1,
      88,    -1,     6,    -1,    25,    -1,    23,    -1,    73,    -1,
      67,    -1,    68,    -1,   124,    -1,   104,    -1,   125,    -1,
     105,    -1,   126,    -1,   127,    -1,    10,    -1,    21,    -1,
     103,    -1,    19,    -1,   128,    -1,   408,    -1,   130,    -1,
     100,    -1,   101,    -1,   102,    -1,     6,    -1,   132,    -1,
      25,    -1,   131,    -1,    99,    -1,   388,    -1,   387,    -1,
     106,    -1,   107,    -1,   108,    -1,   109,    -1,   110,    -1,
     111,    -1,   112,    -1,   113,    -1,   390,    -1,   398,    -1,
      84,    -1,   392,    -1,   395,    -1,   392,   117,   395,    -1,
     392,     1,   395,    -1,   392,   117,     1,    -1,   392,     1,
      -1,   395,    -1,   393,   117,   395,    -1,   395,    -1,   395,
     123,   395,    -1,   396,    -1,   398,    -1,    88,    -1,    89,
      -1,    90,    -1,    83,    -1,    80,    -1,    77,    -1,    78,
      -1,    82,    -1,    79,    -1,    81,    -1,    39,    -1,    40,
      -1,    41,    -1,    42,    -1,    43,    -1,    74,    -1,    44,
      -1,    45,    -1,    75,    -1,    76,    -1,    47,    -1,    48,
      -1,    49,    -1,    51,    -1,    53,    -1,    54,    -1,    55,
      -1,    56,    -1,    57,    -1,    59,    -1,    60,    -1,    61,
      -1,    63,    -1,    62,    -1,    64,    -1,    65,    -1,    66,
      -1,    67,    -1,    68,    -1,    69,    -1,    70,    -1,    71,
      -1,    72,    -1,    73,    -1,   398,    -1,    91,    -1,   399,
      -1,    50,    -1,    52,    -1,    58,    -1,    93,    -1,    -1,
      -1,    -1,    26,    -1,    91,    -1,    91,    -1,    -1,   114,
      -1,   122,    -1,    92,    -1,   121,    -1,   129,    -1,    98,
      -1,   123,    -1,     1,    -1,    -1,     1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   210,   210,   211,   223,   225,   222,   228,   234,   236,
     233,   239,   240,   242,   241,   250,   252,   249,   258,   257,
     264,   266,   263,   273,   272,   280,   279,   285,   287,   285,
     292,   293,   298,   297,   300,   302,   301,   305,   310,   309,
     315,   319,   321,   322,   323,   328,   327,   335,   334,   342,
     343,   345,   350,   355,   356,   361,   362,   366,   367,   369,
     371,   373,   378,   383,   385,   386,   391,   396,   397,   399,
     401,   403,   408,   410,   412,   417,   417,   421,   423,   427,
     428,   429,   434,   439,   440,   444,   445,   447,   452,   453,
     455,   457,   459,   464,   469,   470,   476,   477,   482,   483,
     488,   489,   494,   494,   497,   499,   505,   506,   511,   512,
     513,   519,   520,   525,   526,   526,   529,   534,   539,   540,
     541,   546,   551,   552,   557,   557,   573,   576,   575,   579,
     586,   588,   590,   592,   594,   596,   600,   601,   606,   607,
     608,   612,   614,   623,   624,   629,   628,   653,   658,   659,
     664,   665,   668,   667,   674,   675,   680,   682,   687,   689,
     688,   696,   701,   702,   704,   705,   707,   709,   713,   724,
     723,   735,   738,   737,   744,   746,   751,   752,   754,   756,
     758,   762,   767,   768,   774,   774,   790,   791,   796,   797,
     799,   801,   802,   803,   804,   806,   807,   812,   814,   822,
     825,   827,   829,   831,   836,   838,   839,   841,   843,   845,
     847,   851,   852,   857,   858,   860,   862,   864,   869,   871,
     877,   878,   880,   885,   886,   890,   891,   893,   895,   897,
     901,   907,   908,   913,   915,   917,   919,   924,   925,   927,
     929,   931,   935,   940,   945,   946,   950,   952,   957,   959,
     961,   963,   965,   969,   971,   980,   982,   984,   986,   991,
     993,   999,  1003,  1005,  1010,  1011,  1013,  1018,  1019,  1023,
    1024,  1026,  1031,  1032,  1034,  1039,  1041,  1043,  1045,  1047,
    1049,  1051,  1053,  1055,  1059,  1060,  1062,  1067,  1068,  1070,
    1077,  1088,  1091,  1093,  1090,  1102,  1103,  1107,  1109,  1111,
    1121,  1123,  1125,  1127,  1132,  1133,  1137,  1142,  1144,  1147,
    1146,  1150,  1152,  1154,  1156,  1158,  1163,  1164,  1166,  1171,
    1176,  1177,  1182,  1183,  1185,  1187,  1189,  1191,  1196,  1197,
    1201,  1202,  1206,  1207,  1209,  1214,  1215,  1217,  1219,  1221,
    1223,  1228,  1229,  1231,  1233,  1237,  1239,  1241,  1243,  1245,
    1247,  1252,  1254,  1256,  1260,  1261,  1266,  1268,  1272,  1273,
    1278,  1279,  1284,  1285,  1286,  1290,  1295,  1296,  1300,  1302,
    1311,  1312,  1314,  1316,  1320,  1325,  1330,  1331,  1337,  1342,
    1343,  1347,  1349,  1351,  1353,  1350,  1358,  1360,  1365,  1369,
    1369,  1375,  1376,  1377,  1384,  1385,  1388,  1387,  1391,  1393,
    1395,  1397,  1399,  1401,  1402,  1404,  1407,  1406,  1415,  1417,
    1414,  1436,  1438,  1440,  1435,  1444,  1446,  1443,  1450,  1449,
    1454,  1453,  1457,  1462,  1467,  1468,  1470,  1472,  1474,  1479,
    1481,  1487,  1486,  1497,  1504,  1509,  1511,  1516,  1517,  1522,
    1523,  1525,  1527,  1529,  1535,  1534,  1541,  1542,  1544,  1546,
    1548,  1552,  1554,  1556,  1558,  1563,  1565,  1567,  1572,  1573,
    1578,  1579,  1584,  1586,  1588,  1590,  1592,  1594,  1596,  1598,
    1600,  1602,  1608,  1609,  1614,  1615,  1619,  1620,  1625,  1630,
    1632,  1639,  1652,  1654,  1659,  1660,  1662,  1664,  1667,  1666,
    1673,  1674,  1676,  1679,  1678,  1685,  1686,  1688,  1690,  1692,
    1694,  1699,  1701,  1703,  1704,  1705,  1707,  1708,  1713,  1714,
    1715,  1719,  1720,  1724,  1729,  1731,  1736,  1737,  1738,  1743,
    1744,  1744,  1744,  1744,  1744,  1744,  1744,  1744,  1745,  1745,
    1745,  1745,  1745,  1745,  1745,  1745,  1745,  1749,  1761,  1775,
    1776,  1781,  1783,  1787,  1788,  1790,  1792,  1794,  1796,  1798,
    1800,  1802,  1804,  1806,  1808,  1810,  1812,  1814,  1816,  1821,
    1822,  1824,  1833,  1837,  1839,  1841,  1843,  1848,  1849,  1851,
    1853,  1859,  1861,  1863,  1868,  1873,  1874,  1876,  1878,  1879,
    1883,  1884,  1889,  1891,  1896,  1898,  1903,  1908,  1913,  1915,
    1917,  1919,  1921,  1926,  1927,  1929,  1934,  1935,  1940,  1942,
    1947,  1948,  1950,  1952,  1954,  1959,  1961,  1963,  1968,  1970,
    1975,  1976,  1978,  1980,  1985,  1987,  1994,  1995,  1999,  2000,
    2001,  2005,  2006,  2007,  2008,  2009,  2010,  2011,  2015,  2016,
    2017,  2018,  2019,  2020,  2024,  2025,  2026,  2027,  2028,  2029,
    2033,  2034,  2035,  2036,  2040,  2041,  2042,  2043,  2047,  2050,
    2051,  2052,  2053,  2054,  2055,  2061,  2062,  2063,  2064,  2065,
    2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,  2087,  2088,
    2089,  2090,  2094,  2095,  2096,  2097,  2103,  2104,  2108,  2113,
    2118,  2120,  2122,  2128,  2130,  2134,  2136,  2141,  2142,  2147,
    2152,  2153,  2154,  2155,  2156,  2157,  2158,  2159,  2160,  2161,
    2162,  2163,  2164,  2165,  2166,  2167,  2168,  2169,  2170,  2171,
    2172,  2173,  2174,  2175,  2176,  2177,  2178,  2179,  2180,  2181,
    2182,  2183,  2184,  2185,  2186,  2187,  2188,  2189,  2190,  2191,
    2192,  2193,  2194,  2195,  2196,  2200,  2205,  2206,  2207,  2208,
    2209,  2213,  2221,  2226,  2231,  2235,  2240,  2245,  2251,  2252,
    2257,  2258,  2259,  2263,  2264,  2268,  2269,  2275,  2279
};
#endif

#if (YYDEBUG) || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "prec_lower_than_error", "prec_if",
  "p_else", "p_and", "p_array", "p_begin", "p_case", "p_div", "p_do",
  "p_downto", "p_end", "p_file", "p_for", "p_function", "p_goto", "p_if",
  "p_in", "p_label", "p_mod", "p_nil", "p_not", "p_of", "p_or", "p_packed",
  "p_procedure", "p_to", "p_program", "p_record", "p_repeat", "p_set",
  "p_then", "p_type", "p_until", "p_var", "p_while", "p_with",
  "p_absolute", "p_abstract", "p_and_then", "p_as", "p_asm", "p_attribute",
  "p_bindable", "p_const", "p_constructor", "p_destructor", "p_external",
  "p_far", "p_finalization", "p_forward", "p_implementation", "p_import",
  "p_inherited", "p_initialization", "p_is", "p_near", "p_object",
  "p_only", "p_operator", "p_otherwise", "p_or_else", "p_pow",
  "p_qualified", "p_restricted", "p_shl", "p_shr", "p_unit", "p_uses",
  "p_value", "p_virtual", "p_xor", "p_asmname", "p_c", "p_c_language",
  "p_Addr", "p_Assigned", "p_Dispose", "p_Exit", "p_FormatString", "p_New",
  "p_Return", "LEX_INTCONST", "LEX_INTCONST_BASE", "LEX_STRCONST",
  "LEX_REALCONST", "LEX_BUILTIN_PROCEDURE", "LEX_BUILTIN_PROCEDURE_WRITE",
  "LEX_BUILTIN_FUNCTION", "LEX_ID", "LEX_CARET_WHITE", "LEX_CARET_LETTER",
  "LEX_ASSIGN", "LEX_RENAME", "LEX_RANGE", "LEX_ELLIPSIS",
  "LEX_CONST_EQUAL", "LEX_SYMDIFF", "LEX_NE", "LEX_GE", "LEX_LE",
  "LEX_POWER", "LEX_BPPLUS", "LEX_BPMINUS", "LEX_CEIL_PLUS",
  "LEX_CEIL_MINUS", "LEX_FLOOR_PLUS", "LEX_FLOOR_MINUS", "LEX_CEIL_MULT",
  "LEX_CEIL_DIV", "LEX_FLOOR_MULT", "LEX_FLOOR_DIV", "';'", "'('", "')'",
  "','", "':'", "'['", "']'", "'@'", "'^'", "'.'", "'+'", "'-'", "'*'",
  "'/'", "'<'", "'='", "'>'", "'|'", "'&'", "$accept", "program_component",
  "program_component_1", "@1", "@2", "module_declaration", "@3", "@4",
  "@5", "@6", "@7", "@8", "interface_module", "@9", "@10",
  "module_interface", "@11", "implementatation_module", "@12",
  "module_block", "@13", "@14", "optional_unit_implementation",
  "optional_unit_init_and_final_part", "@15", "@16", "unit_initialization",
  "@17", "rest_of_unit_constructor", "optional_init_and_final_part",
  "module_constructor", "@18", "module_destructor", "@19",
  "optional_program_heading", "optional_module_parameters",
  "optional_par_id_list", "optional_module_attributes", "export_part_list",
  "export_part", "export_list_or_all", "export_all", "export_list",
  "export_list_item", "optional_import_part", "@20",
  "optional_import_part1", "import_specification_list",
  "import_specification", "optional_qualified",
  "optional_import_qualifier", "import_clause_list", "import_clause",
  "optional_rename", "declarations_and_uses", "declaration_or_uses",
  "any_declaration_part", "any_decl", "@21", "interface_decl_part",
  "interface_decl", "implementation_decls", "implementation_decl", "@22",
  "uses_part", "uses_list", "uses_specification", "optional_unit_filename",
  "simple_decl", "@23", "simple_decl_1", "@24", "label_list", "new_label",
  "constant_definition_list", "constant_definition",
  "variable_declaration_list", "variable_declaration", "@25",
  "optional_variable_directive_list", "variable_directive", "@26",
  "optional_variable_directive_list_no_external",
  "variable_directive_no_external", "absolute_or_value_specification",
  "@27", "type_definition_list", "type_definition", "@28", "@29",
  "formal_schema_discriminants", "discriminant_specification_list",
  "discriminant_specification", "type_denoter_with_attributes",
  "type_denoter", "@30", "type_denoter_1", "type_denoter_0",
  "actual_schema_discriminants", "discriminant_expression_list",
  "unpacked_structured_type", "direct_access_index_type",
  "array_index_list", "ordinal_index_type", "record_field_list",
  "optional_fixed_part", "fixed_part", "record_section", "rest_of_variant",
  "variant_selector", "variant_list", "variant",
  "new_ordinal_type_non_iso", "new_ordinal_type", "enumerated_type",
  "enum_list", "subrange_type", "new_pointer_type", "pointer_domain_type",
  "new_procedural_type", "object_parent", "optional_abstract",
  "object_field_list", "object_field_list_1", "object_section",
  "optional_value_specification", "var_init", "routine_interface_decl",
  "routine_declaration", "@31", "@32", "routine_or_method_heading",
  "routine_heading", "method_heading",
  "optional_routine_interface_directive_list", "remote_directive_list",
  "remote_directive", "@33", "optional_routine_directive_list",
  "attributes", "attribute_list", "attrib", "bp_directive",
  "operator_identifier", "operator_result_def",
  "optional_formal_parameter_list", "formal_parameter_list",
  "formal_parameter", "resulttype", "optional_result_def",
  "optional_result_equals", "optional_protected",
  "optional_parameter_form", "parameter_form", "type_inquiry",
  "typename_or_conformant_array", "conformant_array",
  "index_type_specification_list", "index_type_specification",
  "open_array", "typename_or_untyped_file", "compound_statement",
  "statement_sequence", "optional_statement_vd", "@34", "@35",
  "optional_statement", "empty_lte", "statement", "@36", "statement_1",
  "unlabelled_statement", "@37", "@38", "@39", "@40", "@41", "@42", "@43",
  "@44", "@45", "@46", "@47", "set_label", "with_list", "with_variable",
  "if_then", "@48", "optional_case_completer", "otherwise",
  "optional_case_element_list", "case_element_list", "case_element", "@49",
  "case_constant_list", "one_case_constant", "for_direction",
  "start_of_assignment_or_call", "assign", "builtin_procedure_statement",
  "asm_qualifier", "asm_operands", "nonempty_asm_operands", "asm_operand",
  "asm_clobbers", "static_expression", "expression", "simple_expression",
  "@50", "term", "@51", "factor", "primary", "unsigned_number",
  "optional_combined_string", "combined_string", "string_constants",
  "string_constant", "caret_chars", "typename_or_string255", "typename",
  "typename_1", "variable_or_routine_access",
  "variable_or_routine_access_no_builtin_function",
  "builtin_actual_parameter_list", "disable_function_calls",
  "actual_parameter_list", "write_actual_parameter_list",
  "write_actual_parameter", "untyped_file", "structured_constructor_list",
  "field_value_list", "field_value", "variant_part_value",
  "variant_part_value0", "array_value_completer", "component_value",
  "bp_constructor_list", "initializer_separator", "bp_field_value",
  "index_expression_list", "index_expression_item", "set_constructor",
  "set_constructor_element_list", "member_designator", "sign",
  "unary_operator", "relational_operator", "adding_operator",
  "multiplying_operator", "or_operator", "and_operator", "builtin_proc",
  "operator_symbol", "pxsc_adding_operator", "pxsc_multiplying_operator",
  "label", "num_label", "id_list", "id_list1", "id_list_limited",
  "new_quid", "new_identifier", "new_identifier_1", "identifier", "id",
  "caret_letter", "pushlevel", "poplevel", "enable_lce", "packed",
  "i_protected", "module", "optional_semicolon", "pointer_char", "equals",
  "dot_or_error", "null", "err", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned short int yyr1[] =
{
       0,   133,   134,   134,   136,   137,   135,   135,   139,   140,
     138,   138,   138,   141,   138,   142,   143,   138,   144,   138,
     146,   147,   145,   149,   148,   151,   150,   153,   154,   152,
     155,   155,   157,   156,   156,   158,   156,   156,   160,   159,
     161,   162,   162,   162,   162,   164,   163,   166,   165,   167,
     167,   167,   168,   169,   169,   170,   170,   171,   171,   171,
     171,   171,   172,   173,   173,   173,   174,   175,   175,   175,
     175,   175,   176,   176,   176,   178,   177,   179,   179,   180,
     180,   180,   181,   182,   182,   183,   183,   183,   184,   184,
     184,   184,   184,   185,   186,   186,   187,   187,   188,   188,
     189,   189,   191,   190,   190,   190,   192,   192,   193,   193,
     193,   194,   194,   195,   196,   195,   195,   197,   198,   198,
     198,   199,   200,   200,   202,   201,   203,   204,   203,   203,
     205,   205,   205,   205,   205,   205,   206,   206,   207,   207,
     207,   208,   208,   209,   209,   211,   210,   210,   212,   212,
     213,   213,   214,   213,   215,   215,   216,   216,   217,   218,
     217,   217,   219,   219,   219,   219,   219,   219,   220,   221,
     220,   220,   222,   220,   223,   223,   224,   224,   224,   224,
     224,   225,   226,   226,   228,   227,   229,   229,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   231,   231,   232,
     232,   232,   232,   232,   233,   233,   233,   233,   233,   233,
     233,   234,   234,   235,   235,   235,   235,   235,   236,   236,
     237,   237,   237,   238,   238,   239,   239,   239,   239,   239,
     240,   241,   241,   242,   242,   242,   242,   243,   243,   243,
     243,   243,   244,   245,   246,   246,   247,   247,   248,   248,
     248,   248,   248,   249,   249,   250,   250,   250,   250,   251,
     251,   251,   252,   252,   253,   253,   253,   254,   254,   255,
     255,   255,   256,   256,   256,   257,   257,   257,   257,   257,
     257,   257,   257,   257,   258,   258,   258,   259,   259,   259,
     260,   261,   262,   263,   261,   264,   264,   265,   265,   265,
     266,   266,   266,   266,   267,   267,   268,   269,   269,   270,
     269,   269,   269,   269,   269,   269,   271,   271,   271,   272,
     273,   273,   274,   274,   274,   274,   274,   274,   275,   275,
     276,   276,   277,   277,   277,   278,   278,   278,   278,   278,
     278,   279,   279,   279,   279,   280,   280,   280,   280,   280,
     280,   281,   281,   281,   282,   282,   283,   283,   284,   284,
     285,   285,   286,   286,   286,   287,   288,   288,   289,   289,
     290,   290,   290,   290,   291,   292,   293,   293,   294,   295,
     295,   296,   296,   297,   298,   296,   299,   299,   300,   302,
     301,   303,   303,   303,   304,   304,   305,   304,   304,   304,
     304,   304,   304,   304,   304,   304,   306,   304,   307,   308,
     304,   309,   310,   311,   304,   312,   313,   304,   314,   304,
     315,   304,   304,   316,   317,   317,   317,   317,   317,   318,
     318,   320,   319,   321,   321,   322,   322,   323,   323,   324,
     324,   324,   324,   324,   326,   325,   327,   327,   327,   327,
     327,   328,   328,   328,   328,   329,   329,   329,   330,   330,
     331,   331,   332,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   333,   333,   334,   334,   335,   335,   336,   337,
     337,   338,   339,   339,   340,   340,   340,   340,   341,   340,
     342,   342,   342,   343,   342,   344,   344,   344,   344,   344,
     344,   345,   345,   345,   345,   345,   345,   345,   346,   346,
     346,   347,   347,   348,   349,   349,   350,   350,   350,   351,
     351,   351,   351,   351,   351,   351,   351,   351,   351,   351,
     351,   351,   351,   351,   351,   351,   351,   352,   353,   354,
     354,   355,   355,   356,   356,   356,   356,   356,   356,   356,
     356,   356,   356,   356,   356,   356,   356,   356,   356,   357,
     357,   357,   358,   359,   359,   359,   359,   360,   360,   360,
     360,   361,   361,   361,   362,   363,   363,   363,   363,   363,
     364,   364,   365,   365,   366,   366,   367,   368,   369,   369,
     369,   369,   369,   370,   370,   370,   371,   371,   372,   372,
     373,   373,   373,   373,   373,   374,   374,   374,   375,   375,
     376,   376,   376,   376,   377,   377,   378,   378,   379,   379,
     379,   380,   380,   380,   380,   380,   380,   380,   381,   381,
     381,   381,   381,   381,   382,   382,   382,   382,   382,   382,
     383,   383,   383,   383,   384,   384,   384,   384,   385,   385,
     385,   385,   385,   385,   385,   386,   386,   386,   386,   386,
     386,   386,   386,   386,   386,   386,   386,   386,   386,   386,
     386,   386,   386,   386,   386,   386,   386,   386,   387,   387,
     387,   387,   388,   388,   388,   388,   389,   389,   390,   391,
     392,   392,   392,   392,   392,   393,   393,   394,   394,   395,
     396,   396,   396,   396,   396,   396,   396,   396,   396,   396,
     396,   396,   396,   396,   396,   396,   396,   396,   396,   396,
     396,   396,   396,   396,   396,   396,   396,   396,   396,   396,
     396,   396,   396,   396,   396,   396,   396,   396,   396,   396,
     396,   396,   396,   396,   396,   397,   398,   398,   398,   398,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   406,
     407,   407,   407,   408,   408,   409,   409,   410,   411
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     1,     0,     0,     8,     1,     0,     0,
      12,     1,     1,     0,     3,     0,     0,     9,     0,     6,
       0,     0,     8,     0,     7,     0,     7,     0,     0,     6,
       0,     4,     0,     3,     1,     0,     4,     1,     0,     3,
       1,     0,     2,     1,     1,     0,     6,     0,     6,     0,
       4,     4,     3,     1,     3,     1,     2,     1,     3,     1,
       3,     3,     3,     3,     1,     4,     1,     1,     3,     1,
       3,     3,     2,     3,     3,     0,     2,     0,     3,     1,
       3,     3,     4,     1,     1,     1,     3,     4,     1,     3,
       1,     3,     3,     2,     1,     2,     0,     2,     1,     1,
       0,     2,     0,     2,     3,     1,     0,     2,     1,     1,
       1,     0,     2,     1,     0,     2,     1,     3,     1,     3,
       3,     2,     1,     2,     0,     2,     2,     0,     4,     2,
       1,     3,     1,     3,     3,     2,     1,     1,     1,     2,
       1,     4,     8,     1,     2,     0,     8,     1,     1,     3,
       1,     2,     0,     5,     1,     3,     2,     1,     1,     0,
       3,     2,     1,     3,     1,     3,     3,     2,     5,     0,
       6,     3,     0,     9,     3,     3,     1,     3,     3,     3,
       2,     3,     1,     2,     0,     2,     1,     2,     1,     2,
       2,     1,     1,     1,     1,     1,     2,     3,     3,     1,
       3,     1,     3,     3,     6,     1,     4,     3,     3,     3,
       1,     1,     3,     1,     3,     3,     2,     1,     1,     1,
       0,     2,     7,     1,     2,     1,     3,     3,     3,     2,
       4,     0,     5,     3,     3,     1,     1,     1,     3,     3,
       1,     2,     5,     1,     1,     1,     3,     3,     1,     3,
       3,     3,     2,     3,     4,     2,     2,     2,     3,     1,
       1,     1,     2,     3,     1,     3,     3,     1,     1,     1,
       2,     1,     1,     2,     3,     4,     3,     5,     3,     3,
       1,     2,     1,     1,     1,     2,     2,     1,     1,     1,
       3,     3,     0,     0,     9,     1,     1,     3,     5,     5,
       5,     7,     5,     5,     1,     1,     3,     2,     3,     0,
       6,     6,     6,     3,     2,     2,     1,     3,     3,     4,
       1,     3,     1,     1,     1,     3,     4,     6,     1,     1,
       1,     1,     1,     2,     1,     1,     2,     3,     3,     5,
       3,     1,     3,     3,     3,     3,     4,     4,     3,     3,
       5,     1,     2,     1,     1,     2,     1,     0,     1,     1,
       0,     2,     1,     1,     1,     3,     1,     1,     6,     7,
       1,     3,     3,     3,     5,     3,     1,     1,     5,     1,
       3,     0,     1,     0,     0,     5,     1,     1,     0,     0,
       2,     1,     2,     1,     1,     1,     0,     4,     1,     2,
       1,     4,     4,     1,     6,     1,     0,     6,     0,     0,
       8,     0,     0,     0,     9,     0,     0,     8,     0,    11,
       0,     9,     2,     2,     1,     3,     1,     3,     3,     1,
       3,     0,     7,     0,     4,     1,     1,     0,     2,     1,
       3,     1,     3,     3,     0,     6,     1,     3,     3,     3,
       2,     1,     3,     3,     3,     1,     1,     1,     1,     2,
       1,     1,     2,     1,     4,     4,     6,     7,     5,     7,
       9,    11,     0,     1,     1,     1,     1,     3,     4,     1,
       3,     1,     1,     3,     1,     2,     3,     3,     0,     4,
       1,     3,     3,     0,     4,     1,     3,     3,     3,     3,
       3,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     2,     1,     1,     1,     3,     3,     2,     4,     4,
       3,     5,     2,     4,     5,     4,     4,     6,     7,     1,
       4,     4,     0,     1,     3,     1,     3,     1,     3,     3,
       3,     1,     3,     5,     1,     2,     3,     3,     1,     1,
       1,     3,     3,     1,     6,     4,     4,     3,     1,     2,
       3,     3,     3,     1,     3,     3,     1,     1,     3,     1,
       1,     3,     1,     3,     3,     1,     1,     3,     2,     3,
       1,     3,     3,     3,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     2,     1,     3,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     0,     0,     1,     1,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     1
};

/* YYDPREC[RULE-NUM] -- Dynamic precedence of rule #RULE-NUM (0 if none). */
static const unsigned char yydprec[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     1,     2,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     1,     2,
       0,     0,     0,     0,     0,     0,     0,     1,     2,     0,
       1,     2,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     1,     0,
       2,     2,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     2,     1,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0
};

/* YYMERGER[RULE-NUM] -- Index of merging function for rule #RULE-NUM. */
static const unsigned char yymerger[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error.  */
static const unsigned short int yydefact[] =
{
      49,     0,     0,   757,     0,     3,     7,    11,    12,   767,
       0,   767,   711,   712,   713,   714,   715,   717,   718,   721,
     722,   723,   748,   724,   749,   725,   726,   727,   728,   729,
     750,   730,   731,   732,   734,   733,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   716,   719,   720,   706,
     707,   709,   705,   710,   708,   704,   701,   702,   703,   746,
     751,   767,   699,   700,   747,     0,     1,     0,     0,     4,
       0,    55,   767,     0,     0,    53,     0,   767,    14,     0,
     767,    75,    56,     0,    20,    18,     0,     0,     0,   690,
      51,    50,     0,     0,   323,     0,   320,   324,   322,    96,
      77,    25,   767,     0,    27,   767,    54,   694,     0,     8,
     319,   767,   764,     0,   763,     0,   102,     0,    76,    27,
      21,    23,     0,     0,    77,    52,   692,   693,   691,    75,
     321,   574,   505,   620,     0,     0,     0,     0,     0,   508,
     509,   516,   510,   767,   517,   618,   619,     0,     0,     0,
       0,   616,   617,     0,   482,   484,   490,   495,   504,   503,
     513,   514,   507,   542,   544,   506,     0,     0,   543,   745,
     325,   745,     0,     0,     0,     0,     0,     0,     0,     0,
      97,    99,   124,    98,   105,     0,   295,   296,     0,    79,
     767,     0,     0,     0,    16,   766,   765,    19,   111,   106,
     552,     0,   562,     0,     0,   562,   541,   559,     0,   608,
     614,     0,   610,   502,   519,   523,   524,   525,   520,   522,
     526,   527,   535,   536,   521,   528,   529,   530,   531,   532,
     533,   534,   518,   326,   627,   640,   642,   632,   633,   621,
     623,   622,   629,   631,   678,   679,   680,   681,   628,   630,
     625,   624,   626,   643,     0,     0,   488,     0,   644,   636,
     637,   646,   638,   639,   682,   683,   684,   685,   634,   635,
     647,     0,   493,     0,     0,     0,     0,     0,     0,   515,
     761,     0,   762,   760,     0,   547,   562,   485,   501,     0,
     767,   132,   688,     0,   130,   136,   137,   767,     0,     0,
     671,   661,   664,   662,   673,   675,   668,   669,   670,   663,
     656,   658,   655,   657,   659,   660,   665,   667,   674,   672,
     767,   331,   677,   676,   330,   666,     0,   118,   767,   752,
       0,   103,     0,   767,     0,    78,    84,   767,    83,    26,
       0,    59,     0,    57,     0,    27,   114,   124,     0,     0,
     571,     0,   567,     0,     0,   545,     0,     0,     0,   609,
     641,   483,   486,     0,   487,   645,   491,     0,   492,   500,
     538,   539,   499,   496,   497,   498,   602,     0,   727,   734,
     706,   707,   710,   708,   767,     0,     0,   588,     0,   758,
     580,   578,   579,   583,     0,   600,   605,   745,   546,   550,
       0,     0,     0,     0,   357,   335,   135,   104,     0,     0,
     297,     0,     0,   767,     0,   117,     0,     0,   121,   122,
     389,     6,   127,     0,     0,   125,   291,   292,   316,    81,
      80,     0,     0,   767,    85,    22,     0,     0,     0,     0,
      41,   112,   124,   113,   116,     0,     0,    30,   107,   108,
     109,   110,     0,   555,     0,     0,     0,   553,     0,   556,
       0,   565,   563,   507,     0,   615,   612,   613,   611,   489,
     494,     0,     0,     0,   588,   758,   589,   588,   599,     0,
     593,     0,   602,   588,     0,     0,     0,   549,     0,   575,
       0,     0,     0,   548,     0,   327,     0,     0,     0,     0,
     756,     0,   336,     0,   341,     0,     0,   359,   358,   767,
       0,     0,   356,   354,   133,   134,   131,   767,   767,   767,
       0,   332,     0,   334,   120,   119,   123,   383,   753,   379,
     382,     0,     0,   147,     0,   143,   754,   695,   140,   126,
     138,   754,   767,   328,     0,   329,     0,     0,     0,    77,
     767,     0,     0,     0,    90,     0,    88,   767,    82,    60,
      61,    58,   106,    66,     0,    62,    64,    17,     0,     0,
      43,    44,   115,   767,   767,    77,     0,   767,   554,   572,
     569,   570,   568,     0,   767,   561,   560,     0,   540,     0,
       0,   759,   587,     0,   596,   590,   597,     0,     0,   592,
       0,   591,   607,   581,   576,     0,   577,   606,   603,   604,
     601,   582,   551,   340,   767,   767,   360,   338,   767,     0,
     337,     0,     0,     0,   357,   768,     0,   298,   351,   353,
     355,   300,   302,   303,   299,   333,     0,   389,     0,   649,
       0,     0,     0,     0,   651,   650,   411,   415,     0,   472,
     653,   654,   652,     0,   400,   398,   648,   463,     0,   394,
     390,   393,   391,   405,   395,   403,   458,   767,     0,   686,
     745,   164,     0,   162,   754,   144,     0,     0,   139,     0,
       0,     0,   512,   511,   307,     0,   314,   315,   100,   306,
     317,   318,     0,     0,    86,     0,     0,    93,    94,   124,
      69,     0,    67,   767,   697,     0,     0,     0,     0,    29,
       0,    42,    96,     0,   290,   305,   304,     0,   557,     0,
     566,   564,     0,   585,     0,   595,   594,   598,   607,   357,
     349,     0,   348,   343,   344,     0,   342,   360,     0,   755,
       0,   345,   363,   362,   367,   364,   366,   376,   377,     0,
       0,     0,   352,   537,   384,   380,   378,     0,     0,   422,
     687,     0,   752,   752,   426,     0,   424,   429,   473,     0,
       0,     0,   399,     0,   459,   392,   406,     0,   462,   423,
     167,     0,     0,     0,     0,   696,   184,   184,     0,   481,
     309,   308,   313,   102,    87,    91,    92,    89,    95,    24,
       0,    63,     0,     0,    72,     0,   767,     0,    45,    47,
     102,    10,   573,   558,     0,     0,     0,   361,   339,   347,
       0,     0,     0,     0,   346,   301,   389,   408,     0,   460,
       0,   461,   431,   389,     0,     0,   752,     0,     0,     0,
       0,     0,     0,     0,   752,     0,   165,   166,   163,     0,
       0,   176,     0,   171,   169,   184,   145,   182,     0,     0,
     141,     0,     0,   767,   101,     0,    70,    71,    68,    73,
     698,    74,    65,   389,   389,    32,    38,    31,    34,    37,
     758,   584,   350,   375,     0,   370,     0,   365,     0,   385,
       0,   420,     0,   752,     0,   416,   427,   389,   428,   425,
     430,     0,   465,     0,   401,   402,   464,   389,   397,   175,
     180,     0,   174,     0,   184,   767,   767,   767,   183,     0,
     574,   767,   767,     0,     0,     0,     0,   517,     0,   762,
     760,   185,   186,   195,   192,   244,   245,   193,   194,   191,
       0,   188,   537,   544,   745,     0,     0,   210,     0,     0,
       0,     0,     0,     0,   386,   387,     0,   389,   389,    35,
     586,     0,     0,     0,     0,     0,   441,   409,     0,   439,
       0,   446,     0,     0,   457,   456,   455,     0,   389,   412,
       0,   753,   468,   767,     0,   767,   753,   178,   179,   177,
     181,   767,   268,     0,   267,   287,   288,   289,   168,     0,
     284,     0,   767,   158,     0,     0,     0,   211,     0,   262,
       0,     0,     0,     0,   225,     0,   223,   184,   187,   189,
     257,   260,   261,   259,     0,     0,   248,   255,   544,   519,
     256,     0,     0,     0,   190,   196,     0,     0,   767,   310,
     311,   312,   294,    46,    48,    33,    40,    39,   389,   372,
     373,   371,     0,     0,     0,   433,     0,     0,   438,   450,
       0,   444,     0,     0,   752,   418,   753,     0,   389,   404,
       0,   475,   476,     0,   474,   466,     0,   407,   170,   767,
     286,   285,   161,     0,     0,   148,   217,     0,   213,   218,
     219,     0,     0,   184,   263,   209,   208,     0,   229,     0,
     221,   184,   207,   247,   252,   246,     0,   253,   201,     0,
     199,     0,     0,   258,     0,   154,    36,     0,   368,     0,
       0,   435,   436,     0,   752,   442,   443,   440,   449,   448,
     447,   752,   453,   454,   452,   389,     0,   432,   413,   753,
     469,   767,     0,     0,   467,     0,     0,   264,   160,   146,
     216,     0,     0,   212,   206,     0,   236,   243,     0,   745,
     227,   228,   226,   767,   250,   251,   249,     0,   197,     0,
     198,   254,   142,   374,   369,   410,   389,   389,   753,   752,
     753,   417,     0,   477,     0,     0,     0,   271,     0,   269,
     272,   767,     0,   149,   150,   157,   215,   214,   184,     0,
       0,   230,   202,   203,   200,   155,   753,   753,   421,   389,
     414,   470,     0,   478,   266,   265,   173,     0,     0,   712,
     717,   721,   722,   743,   273,   270,   283,     0,   151,   156,
     204,   240,     0,   237,     0,   234,   233,   434,   445,   753,
       0,   479,   767,   767,   767,   767,   281,   274,   184,   152,
     241,   759,   231,     0,   419,   471,     0,   357,   276,   278,
     279,   767,     0,   239,   238,   222,     0,   220,   480,     0,
     275,   153,   220,     0,   277,     0,   242,   758,   232
};

/* YYPDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     4,     5,    81,   179,     6,   129,   447,    67,   103,
     345,   104,     7,   102,   192,   122,   193,     8,   119,   123,
     124,   440,   576,   877,   957,  1048,   878,   958,  1045,   569,
     570,   873,   571,   874,     9,    85,    86,    69,   342,   343,
     565,   566,   701,   702,    99,   100,   118,   188,   189,   337,
     433,   555,   556,   697,   116,   180,   793,   181,   182,   347,
     448,   346,   441,   442,   183,   326,   327,   418,   450,   332,
     425,   532,   293,   294,   539,   540,   534,   535,   917,  1084,
    1193,  1262,  1114,  1194,  1002,  1083,   672,   673,   914,   915,
     783,   850,   851,   856,   857,   858,   931,   932,  1034,  1109,
     933,  1006,  1087,  1088,  1011,  1012,  1013,  1014,  1265,  1155,
    1232,  1233,  1156,  1089,   935,  1025,   936,   937,  1020,  1021,
    1146,   993,  1188,  1189,  1225,   998,   999,   451,   184,   549,
     865,   185,   186,   187,   714,   426,   550,   861,   427,   918,
      95,    96,   552,   320,   520,   404,   503,   504,   627,   510,
     511,   505,   732,   741,   742,   743,   744,   884,   885,   745,
     746,   659,  1046,   529,   636,   826,   953,   954,   955,   531,
     660,   661,   777,   844,   890,  1055,   762,  1067,  1180,   763,
     980,  1136,   973,   662,   765,   766,   663,   893,  1123,  1124,
     967,   968,   969,  1131,   970,   971,   977,   664,   830,   665,
     769,  1070,  1071,  1072,  1240,   972,   789,   154,   363,   155,
     367,   156,   157,   158,   681,   159,   160,   161,   232,   941,
     747,   370,   162,   163,   206,   349,   464,   351,   352,   164,
     388,   389,   390,   391,   723,   392,   393,   479,   597,   480,
     485,   395,   165,   211,   212,   166,   167,   254,   255,   271,
     256,   272,   667,   321,   257,   273,   668,   295,  1015,    88,
     536,   703,    89,    62,   168,    63,    64,   420,   638,   677,
    1091,   705,    10,   489,   285,   512,   197,   405,   629
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -971
static const short int yypact[] =
{
     399,  6099,  7757,  -971,   111,  -971,  -971,    63,  -971,   248,
    7757,   227,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,   227,  -971,  -971,  -971,   195,  -971,   292,   285,  -971,
     315,  -971,    12,  7757,   323,  -971,   348,   248,  -971,  7757,
    7647,  -971,  -971,   413,  -971,   444,   438,   439,   241,  -971,
    -971,  -971,   499,   542,  -971,   335,  -971,   237,  -971,  -971,
     559,  -971,   227,   532,  -971,   248,  -971,  7757,  6182,  -971,
    -971,  7647,  -971,  5169,  -971,  5169,   965,  7757,  -971,  -971,
    -971,  -971,   515,    53,   559,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  7757,   517,   524,   537,   565,  -971,
    -971,  -971,  -971,   570,  -971,  -971,  -971,  5169,  5038,  1534,
    1417,  -971,  -971,   579,  1241,   461,  1129,    22,  -971,  -971,
     414,  -971,   983,   584,  -971,  -971,  1534,  1534,  -971,   598,
    -971,  -971,  7757,  5931,  7757,  7757,  7757,  2004,  7757,   704,
    -971,  -971,  -971,  -971,  -971,   605,  -971,  -971,   138,  -971,
     664,    53,   532,  6265,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,   865,  -971,  5169,   865,  -971,  -971,  -971,   616,  -971,
     645,    88,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,   742,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  5169,  1534,  -971,  1534,   717,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  1534,  -971,  1534,   812,   812,  1534,  1534,  1534,  -971,
    -971,  2722,  -971,  -971,  7757,  -971,   650,   461,  -971,  5169,
      -3,  -971,  -971,   196,  -971,  -971,  -971,   271,   638,   647,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
     660,  -971,  -971,  -971,  -971,  -971,   231,  -971,   762,  -971,
      53,  -971,   543,  -971,  7757,  7812,  -971,   327,  -971,  -971,
      53,  -971,   145,  -971,   166,  -971,  1098,   860,   682,  5169,
     675,   274,  -971,   962,  3098,  -971,  5169,  5169,  3185,  -971,
    -971,   942,   461,  1534,   461,  -971,  1129,  1534,  1129,  -971,
    -971,   673,  -971,  -971,  -971,  -971,  -971,  4871,  7867,  5249,
     699,   705,   716,   718,   620,  4697,  2534,   194,   720,   737,
    -971,  -971,  -971,  -971,    84,  -971,  -971,   712,  -971,  -971,
    3098,   731,  4359,  7757,    93,  -971,  7702,  -971,  6015,  7757,
    -971,  7757,  7757,  7233,  7757,  -971,  7757,  5169,  -971,  -971,
      96,  -971,  -971,  6348,  6431,  -971,  -971,  1019,  -971,  -971,
    -971,   740,  6514,   762,  -971,  -971,  7757,  5682,   236,    53,
     838,  -971,  -971,  -971,  -971,  7757,  7757,   816,  -971,  -971,
    -971,  -971,   757,  -971,   768,  5169,  5169,  -971,  3272,  -971,
    2816,  -971,  -971,  1161,   428,  -971,  -971,  -971,  -971,   461,
    1129,   812,   854,   770,  -971,   776,  -971,   395,  -971,   215,
    -971,   779,   774,   226,   778,   123,  5169,  -971,  2628,   839,
    4871,  2910,  5249,  -971,   450,  -971,   788,  7757,  7757,  7757,
     103,   793,  -971,   349,  -971,   876,   798,  7757,  -971,   660,
     100,  7757,  -971,  -971,  -971,  -971,  -971,   660,   660,   660,
     100,  -971,  7757,  -971,  -971,  -971,  -971,  -971,   805,  -971,
    -971,  4528,  6597,  -971,  5515,  -971,   807,  -971,  -971,  7922,
    -971,   166,   414,  -971,   811,  -971,  5169,   815,   817,   559,
    -971,   819,   821,  6514,  -971,   281,  -971,   849,  -971,  -971,
    -971,  -971,  -971,  -971,  6680,  -971,   830,  -971,   512,   939,
     925,  -971,  -971,   660,   660,   559,   941,  -971,  -971,   841,
    -971,  -971,  -971,   533,   570,  -971,  -971,  3359,  -971,   842,
    5169,  -971,  -971,  4958,  -971,  -971,  -971,  4958,  5249,  -971,
    5169,  -971,  -971,  -971,  -971,  5249,  -971,   861,  -971,  -971,
    -971,  -971,  -971,  -971,   660,   660,   844,  -971,  7524,  5429,
    -971,  7757,   765,   845,    93,  -971,   812,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  6348,   502,   951,  -971,
    5169,   865,   750,  5169,  -971,  -971,  -971,  -971,  3446,   875,
    -971,  -971,  -971,   853,   856,  5169,  -971,   857,   865,  -971,
    -971,  -971,  4614,   964,   -10,  -971,   983,   570,   859,  -971,
     866,  -971,   149,  -971,   863,  -971,  7757,   868,  -971,   871,
    5169,     1,  -971,  -971,  -971,   869,  -971,  -971,  -971,   534,
    -971,  -971,   286,  7757,  -971,  6763,  7757,  -971,  -971,   715,
    -971,   297,  -971,   560,   872,  7757,  6680,   968,   980,  -971,
     981,  -971,  -971,    53,  -971,  -971,  1019,  5169,  -971,   880,
    -971,  -971,  2722,  -971,   974,  -971,  -971,  -971,   134,    55,
    -971,   765,  -971,  -971,  -971,   887,  -971,   844,    42,  -971,
     992,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  1010,
     765,   100,  -971,  -971,  -971,  -971,  -971,   994,   690,  -971,
    -971,   988,  -971,  -971,  -971,   288,  -971,   905,  -971,   910,
    5169,   792,  -971,  5169,   983,  -971,  -971,   372,  -971,  -971,
    7757,  5599,  6846,    80,   166,  -971,  -971,  -971,   914,  -971,
    -971,   956,   990,  1011,  -971,  -971,  -971,  -971,  -971,  -971,
    7977,  -971,  6929,  7757,  -971,  7757,   849,   299,  -971,  -971,
    1100,  -971,  -971,  -971,   912,   842,    50,  -971,  -971,  -971,
     507,  7757,  5169,   918,  -971,  -971,   502,  -971,  5169,  -971,
    5169,  -971,  -971,   345,  5169,  5169,  -971,  3533,  7757,   414,
     546,   927,   928,   314,  -971,  5169,  -971,  -971,  -971,   929,
     360,  -971,   934,  -971,  -971,   396,   248,  -971,  1912,   334,
    -971,  5169,  5169,   414,  -971,   704,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,   943,   943,  -971,  -971,  -971,  1002,  -971,
     776,  -971,  -971,  -971,   154,  -971,   959,  -971,  7757,  -971,
    1150,  -971,   491,  -971,    27,  -971,  -971,   625,  -971,  -971,
    -971,   810,  -971,  2816,  -971,  -971,  -971,   625,  -971,  -971,
    7757,  7012,  -971,   812,  -971,  1016,   604,   487,  -971,   945,
      46,   660,   660,  5848,  1036,  2167,   812,  7386,  3004,  5336,
    4229,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
     966,  -971,   354,   751,   607,  1404,  1015,  -971,  5249,   960,
     972,   978,   984,   989,  -971,  -971,   993,    96,   503,  -971,
    -971,  7757,  7095,  1041,  7757,   977,  -971,  -971,   303,  -971,
     176,  -971,   116,  1065,  -971,  -971,  -971,  5169,   625,  -971,
    1069,  -971,  -971,   414,   557,   570,  -971,  -971,  -971,  -971,
    -971,   604,  -971,  1029,  -971,  -971,  -971,  -971,  -971,  3620,
    -971,  3707,  -971,  -971,  2415,  5118,  1091,  -971,   563,  -971,
    1108,  1109,  1114,   408,  -971,  1006,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  1013,   322,  -971,  -971,   824,   926,
    -971,  5169,  3794,  5169,  -971,  -971,  1034,  7456,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,   805,  -971,    96,  -971,
    -971,  -971,   766,  1017,  1107,    71,  5169,  2302,  -971,  5169,
    3881,  -971,  5169,  3968,  -971,  -971,  -971,  5169,   625,  -971,
      -8,  1021,  -971,  1024,  -971,  -971,  1018,  -971,  -971,  1025,
    -971,  -971,  -971,  5169,  1022,  -971,  -971,   159,  -971,  -971,
    -971,  5169,  1023,  -971,  -971,  -971,  -971,  4784,  7757,  4442,
    -971,  -971,  -971,  -971,  7757,  -971,  7178,  -971,  -971,   324,
    -971,  1032,  5169,  -971,  1027,  -971,   805,  1030,  -971,   812,
     812,  -971,  -971,  1140,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,   625,  1131,  -971,  -971,  -971,
    -971,   414,   414,  5169,  -971,   595,  5765,  -971,  -971,   374,
    5118,  5118,  1133,  -971,  -971,  1134,  -971,  -971,  1042,   267,
    -971,  -971,  -971,    20,  -971,  -971,  -971,  5169,  -971,  4055,
    -971,  -971,   403,  -971,  -971,  -971,    96,   529,  -971,  -971,
    -971,  -971,   389,  -971,  1046,  1049,  1050,  -971,  1162,  7592,
    -971,   414,  5169,  -971,  -971,  -971,  -971,  -971,  -971,  4142,
    5118,  -971,  -971,  -971,  -971,  -971,   805,  -971,  -971,   625,
    -971,  -971,   414,  -971,  -971,  -971,  -971,  7757,  7757,    44,
     285,  7757,  7757,  1736,   189,  1060,  -971,  1059,  1089,  -971,
    -971,  -971,   383,  -971,   259,  -971,  -971,  -971,  -971,  -971,
     566,  -971,   660,   660,   660,   660,  -971,  -971,  -971,  -971,
    5169,  5169,    71,  1068,  -971,  -971,   414,    74,  -971,  -971,
    -971,    20,  5169,  -971,  -971,  -971,  1070,  7316,  -971,    82,
    -971,  -971,  7316,  1074,  -971,  1076,  -971,   776,  -971
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  1003,  -971,  1127,  -971,   -73,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,   238,   387,
    -971,  -971,   628,  -971,  -971,  1097,    68,    21,  -971,   256,
    -971,  -971,   495,  -220,   -88,  -971,   -96,  -971,   369,  -971,
    -971,   653,   -90,  -650,   497,  -971,  -971,   417,  -971,   649,
    -971,  -971,  -971,  -971,  -310,  -971,   198,   780,  -139,  -971,
    -971,  -971,  -971,   216,  -971,   668,  -971,  -473,  -971,  -971,
    -971,  -971,  -971,    43,  -971,  -971,  -971,   -74,  -971,  -971,
    -971,  -971,  -194,  -727,  -970,  -971,  -971,   289,  -971,  -971,
     272,  -971,  -971,  -957,  -711,  -971,  -971,  -355,  -971,  -971,
    -971,  -497,    16,  -828,  -971,  -971,  -971,  -971,  -824,  -780,
    -971,  -971,  -971,  -971,  -971,  -892,  -971,  -971,   883,  -971,
    -971,  -971,  -326,  -971,  -971,   641,  -971,  -971,   -63,    -5,
    -971,  1115,  -971,  -971,  -971,  -294,  -971,   139,  -514,  -613,
    -971,  -971,   493,  -219,  -562,   181,  -971,  -971,  -528,  -971,
     418,  -165,  -413,  -587,  -971,  -971,  -830,  -498,  -407,  -971,
    -971,   577,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -195,  -971,  -971,  -971,    -7,
    -971,  -971,  -297,  -971,  -807,  -273,  -971,  -971,   467,  -971,
    -971,   105,  -971,   107,  -971,  -651,  1318,   996,  -971,  -108,
    -971,    15,  -140,  -971,  -821,  -523,   412,  -152,  -971,  -593,
    -259,  -971,  -169,  -971,  -560,    78,  -380,   474,   214,  -591,
    -348,  -971,   769,   771,   441,   772,  -362,  -971,  -971,     4,
     986,  -316,  -971,  -971,   478,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  1085,  1093,   626,  -345,   -72,  -971,
    -971,  -432,    72,  -971,  -971,   733,  -971,  -723,  -922,  -492,
    -588,  -357,  1206,  -470,  -557,   -87,  -173,    -9,  -803
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -768
static const short int yytable[] =
{
      71,    87,    75,   410,    70,   592,   634,   528,   279,   213,
     115,   751,   628,   530,   330,   369,   372,   475,   339,   682,
     494,   452,   628,   478,   719,  1003,   413,   288,   198,   788,
     934,   748,   348,   752,   749,   353,   443,   449,   484,   833,
     834,   199,   951,   331,   956,   507,   191,  1102,  1092,   679,
     755,   625,    75,   804,   195,   947,  -767,  -282,   287,  1069,
     859,   675,   979,    75,  1077,    83,   820,   981,    71,   481,
    -767,    98,    70,    61,    65,  -767,  1121,   986,   938,    74,
     583,   853,    72,   625,  -396,   490,   277,  -767,  -396,   357,
     325,   995,   790,    75,  -767,  -388,    71,   934,    92,  1078,
      70,   625,    98,    84,  -746,  1027,  1030,   778,  1140,  -381,
    1141,    66,   402,   897,   996,   791,   816,  1062,   997,  -396,
     403,   907,   947,  1154,   490,   278,   125,    73,   916,    76,
     611,  1163,   527,  1122,   207,  -607,   373,   374,   375,   334,
     748,   637,   947,   749,  1137,   938,   436,   362,  1066,   364,
     780,    93,    97,   112,   -13,   961,   871,   421,  -282,   748,
    1150,   821,   749,   754,  -388,  1005,  -388,   435,   626,  -767,
     978,  -767,   112,  -767,   608,   610,   196,  1059,   112,   126,
     128,   338,   784,    97,   114,   463,   669,   991,  -767,   190,
    -746,   112,  -767,  1196,  1197,  -588,  -388,   406,  -746,  -746,
     626,   491,   492,   114,   493,   358,   200,  -767,   359,   114,
    -381,  -767,  1063,  1113,  -388,   624,   593,  1181,   626,  -746,
    -746,  -746,   114,   631,   632,   633,  -746,  -606,  1230,   748,
     530,   478,   414,  -451,  -451,   478,   727,   825,  1139,   889,
     491,   492,   107,   475,   290,   296,   297,   298,   299,   324,
     328,  -607,   335,   628,  -615,   469,  1208,   438,  1210,   437,
    1059,   507,   507,   781,   112,   344,   567,   943,   962,  1157,
     945,  1201,   439,   806,   963,   456,  1151,   481,  1261,  1152,
     410,   481,   693,   354,  1237,  1238,   366,   693,   368,   835,
     486,  -235,    68,  1060,  1061,   114,   939,   669,   800,   836,
     800,   946,   882,   572,  1056,  1178,  -746,  -746,  -758,    77,
     407,  -588,  -606,   408,  -588,   456,  -758,  1254,   628,   419,
     729,   730,   600,  1104,   428,  1167,   522,   563,   434,   594,
     506,   595,   596,  1019,   943,   112,  1022,   945,  1028,  1022,
     682,  1135,    73,  -606,  -606,   415,  -588,  1207,   416,   562,
     618,   564,   113,   396,   943,  -689,   398,  -689,   108,  -689,
     965,   910,   666,   939,   400,  -758,   114,   753,   946,  1270,
    1228,   869,  1157,   452,   814,   207,  1060,  1253,    68,  1239,
    -381,   527,   470,     3,  1250,  -700,   402,   431,  -758,   449,
     457,   458,  1234,   508,   409,   513,  -758,   694,   695,    -2,
      80,  1176,   794,   695,   523,   837,   190,   190,  1177,  1098,
     960,  1132,  1134,   801,   802,   872,   802,  1057,    68,   530,
     894,  -758,   551,  1191,   419,  1076,   530,   616,     1,    82,
     906,   458,   948,  1049,  1051,   623,  -172,    90,  1105,  1106,
    1168,  1169,   432,  1234,  1234,  -758,  1022,    68,  1192,   473,
     200,   110,   111,   688,   680,  -172,  1209,   396,   396,  -381,
    1073,   748,    91,   619,   749,   620,   829,   258,     2,  1032,
     112,   259,   758,  1033,   911,   509,   912,  1192,   296,   712,
     296,   517,   260,   518,   519,   521,   328,   689,   328,   774,
       3,   486,   974,   666,  1094,   537,   541,  1251,  1058,  -758,
     141,   114,   261,   975,   557,  1211,   144,  1212,   344,   344,
     628,   355,   817,  -606,   716,  -381,  -381,   573,   574,   976,
     707,   131,  1099,   984,  -758,   708,  1001,   101,   262,   263,
    -388,   824,   584,   683,  -388,   -15,   150,  -381,   527,   527,
     811,   428,  -388,  1100,   586,   587,   506,   506,   698,   737,
     530,   530,   105,  -381,  -381,   106,  1273,    22,   995,    24,
     396,  1275,   396,   396,   625,    30,   612,   587,   428,   614,
     615,   264,   265,   266,   267,   207,  -388,   422,    68,   423,
     866,   996,   868,   630,   543,   997,  1038,   268,   269,   424,
     109,  -388,   545,   270,   635,    83,  1185,   725,    59,   942,
      60,   726,  -388,   795,   674,   797,   537,  -388,  -539,   508,
     508,   541,   524,   117,   525,   513,  -381,  -381,  1073,  1073,
    -539,  -703,   514,   121,   516,   557,  -388,  1008,  1009,   194,
    -388,  -539,   201,  -703,  -388,  1116,   704,  1081,  -388,   202,
     896,   530,   899,  -388,  1269,    22,  -539,    24,    68,   718,
     587,  -539,   203,    30,   990,   696,   803,  -388,   207,  -703,
    -388,  -388,   902,   903,  -703,   396,   942,   753,   682,   396,
     580,   831,   582,  1075,   587,   995,  -388,  -388,  -539,  -388,
     204,   626,  1255,  1256,   551,   205,    59,  -388,    60,  1241,
     831,  -703,   559,   561,   698,   233,   854,   855,   996,   286,
     952,  -539,   997,   429,   430,  -539,   846,   848,   537,   828,
     852,   551,   329,  -700,  -703,   289,   987,   989,  -703,   333,
     513,  -539,  -539,  -539,  -539,  -700,  -539,  -539,   799,   336,
     471,   445,   355,  1268,  -703,   205,  -703,  -703,  -703,  -388,
    -703,   356,   446,  1160,  1162,  1090,  1090,   360,   785,   279,
     365,  -700,  -205,  1263,  1264,  1274,  -700,   733,   736,  1125,
    1127,   411,  1252,  1206,  -205,   557,   399,   557,   798,   530,
     412,   628,   738,  1117,   280,   402,   177,   704,   704,   131,
     131,   417,   280,  -700,   829,   178,  1128,  1130,   112,   213,
    -205,   739,   739,   455,   396,  -205,   471,   698,   453,   740,
      22,   281,    24,   282,   283,   284,  -700,  1278,    30,   281,
    -700,   282,   283,   284,   201,    22,    22,    24,    24,   114,
     202,   841,  -205,    30,    30,  -261,  -700,  -700,  -700,  -700,
    -700,   203,  -700,   204,   292,   466,   468,  -261,   852,   852,
     487,    59,    22,    60,    24,  -205,   169,   495,   171,  -205,
      30,   488,   674,   674,   683,   553,    59,    59,    60,    60,
    1173,  1174,    22,  -261,    24,  -205,   568,  -205,  -261,   575,
      30,   577,   704,    -9,   704,   704,   445,   870,   589,   131,
     171,   171,   171,    59,   578,    60,  1186,   446,   590,   276,
     591,  1090,  1090,   886,   599,  -261,   141,   598,   601,   171,
     171,   605,   144,    59,   613,    60,   994,  1000,  1000,   617,
     900,  1007,   621,    -9,  1016,    22,   622,    24,  -261,   637,
     134,   177,  -261,    30,   676,   684,   982,  -751,   983,   686,
     178,   687,   150,   690,   171,   691,   171,   171,  -261,  -751,
    -261,  1236,   135,   136,   696,   706,   137,   138,  1257,  1258,
    1259,  1260,   709,   710,   713,   143,    59,   486,    60,   717,
     886,   722,   731,   750,   756,  -751,   768,   235,   770,   776,
    -751,   771,   773,    -5,  1074,   985,   207,   779,   782,   808,
     147,   172,  1000,   792,  -687,   173,   786,   171,   171,   787,
     171,   809,   174,  1085,   708,   805,   813,  -751,   815,  1023,
    1026,  1023,  1023,   818,   171,   236,   171,   371,   371,   171,
     171,   171,   175,   176,   397,   237,   822,   823,   827,  -293,
    -751,   832,   171,   838,  -751,   839,   177,   172,   860,  1115,
     862,   173,   880,   886,   886,   178,  1053,   888,   174,   863,
    -751,   238,  -751,   904,   905,   909,   242,   243,   244,   245,
     246,   247,   913,   959,   280,   964,   992,  -388,   175,   176,
    1017,  1037,  1031,    68,  1004,  1052,   248,   249,   542,   543,
    1147,   544,   177,   253,  1039,   280,  1064,   545,   459,   460,
    1068,   281,   171,   282,   283,   284,  1040,   171,  1079,   171,
     171,   171,  1041,   546,   547,   548,   171,  1054,  1042,   276,
     171,   276,   281,  1043,   282,   283,   284,  1044,   875,  1023,
     397,   -28,   171,   -41,   172,  1093,   172,  1227,   397,   397,
     173,  1095,  1096,  1097,  1101,   174,   -28,   174,   568,  1103,
    1112,  1120,  1074,   171,  1144,  1119,  1149,  1190,  1142,  1143,
    1145,  1172,  1179,  1153,  1195,   175,   176,   175,   176,   821,
     171,   966,  1170,  1175,  1000,  -437,   876,  1198,  1199,   177,
    1200,   177,  1213,  -437,   131,  1214,  1215,  1195,   178,  1158,
     178,   274,   132,   133,  1247,  1216,  1164,  1248,  1166,    22,
    1249,    24,   683,  1267,  1226,  1272,   275,    30,   171,   171,
    1276,   171,  1277,   397,    78,   340,  1047,   879,   711,   120,
      22,   807,    24,   276,   588,   134,   692,   678,    30,   810,
     864,   699,  -437,   558,  1018,  1205,  1235,  1035,   715,   171,
      59,   397,    60,   397,   397,   171,   130,   135,   136,   444,
     819,   137,   138,  1118,   139,   140,   141,   142,   883,   775,
     143,    59,   144,    60,   845,  1266,  1182,   843,   513,  1183,
     361,   901,  1000,   280,   145,   146,   881,   603,  1016,   604,
     234,   606,   322,  1016,   670,   147,   235,   394,   759,   148,
     323,   149,   150,    79,   151,   152,     0,   585,     0,   171,
     281,     0,   282,   283,   284,     0,     0,     0,     0,  1242,
    1243,     0,     0,  1244,  1245,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   237,     0,     0,     0,     0,     0,
     171,     0,     0,   171,     0,     0,   397,     0,     0,     0,
     397,   171,     0,   171,     0,     0,     0,     0,   171,     0,
     238,   239,   240,   241,     0,   242,   243,   244,   245,   246,
     247,     0,     0,     0,     0,   371,     0,     0,     0,   371,
       0,     0,     0,     0,     0,   248,   249,     0,     0,   250,
     251,   252,   253,   171,   171,   760,   171,     0,     0,     0,
       0,   171,     0,     0,     0,     0,     0,     0,   171,     0,
       0,   171,     0,     0,     0,   171,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   625,     0,     0,     0,     0,
       0,   919,     0,   171,     0,     0,     0,     0,   920,     0,
       0,     0,     0,     0,     0,     0,   132,   133,     0,     0,
       0,   153,     0,   170,   923,     0,   924,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     171,     0,     0,     0,    22,   397,    24,     0,     0,   134,
       0,     0,    30,     0,   371,   208,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   135,   136,   371,     0,   137,   138,     0,   139,   140,
     141,   142,     0,     0,   143,    59,   144,    60,     0,     0,
       0,     0,     0,   171,   842,     0,   171,     0,   145,   146,
     214,     0,     0,     0,     0,     0,     0,     0,     0,   147,
       0,   350,     0,   148,     0,   149,   150,     0,   151,   152,
       0,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   131,     0,
       0,     0,     0,   371,     0,   171,   132,   133,     0,     0,
       0,   171,     0,   171,     0,     0,     0,   171,   171,     0,
     171,     0,     0,     0,     0,     0,     0,     0,   171,     0,
       0,     0,     0,     0,    22,     0,    24,     0,     0,   134,
       0,   944,    30,     0,   171,   171,     0,     0,     0,   387,
       0,     0,     0,     0,     0,     0,     0,   401,     0,     0,
       0,   135,   136,     0,     0,   137,   138,     0,   139,   140,
     141,   142,     0,   171,   143,    59,   144,    60,     0,     0,
       0,     0,     0,     0,     0,     0,   397,     0,   145,   146,
       0,     0,     0,     0,     0,     0,   371,     0,     0,   147,
       0,     0,     0,   148,     0,   149,   150,     0,   944,   371,
       0,   397,   397,     0,     0,     0,     0,   454,     0,     0,
       0,     0,   462,     0,   465,   210,   210,     0,   171,     0,
       0,   171,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   472,     0,   474,     0,     0,
       0,     0,     0,   477,   483,     0,     0,     0,     0,     0,
     171,     0,     0,     0,     0,     0,     0,     0,   462,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   171,     0,     0,   526,     0,   944,   944,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -280,
     131,     0,     0,     0,     0,     0,     0,     0,   132,   133,
       0,     0,     0,     0,   171,   171,   171,     0,     0,     0,
       0,     0,     0,   579,   350,     0,   350,     0,   462,     0,
       0,     0,     0,     0,     0,   371,    22,     0,    24,   171,
     171,   134,   171,   171,    30,   171,   171,     0,     0,     0,
     171,     0,     0,     0,   602,     0,   387,     0,   607,   607,
     474,     0,     0,   135,   136,     0,   171,   137,   138,     0,
     139,   140,   141,   142,   171,     0,   143,    59,   144,    60,
    1159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     145,   146,     0,     0,     0,   171,     0,     0,     0,     0,
    -280,   147,   371,   371,     0,   148,     0,   149,   150,     0,
     151,   152,     0,     0,   685,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   171,     0,   371,     0,
       0,     0,     0,   944,   944,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     171,     0,   171,     0,     0,   721,     0,     0,   724,     0,
       0,   387,     0,   625,     0,   387,   474,     0,   728,   919,
       0,     0,     0,   474,     0,   171,   920,     0,   921,     0,
       0,     0,   171,   944,   132,   133,     0,     0,   739,   922,
       0,     0,   923,     0,   924,     0,   740,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   171,   925,   757,     0,
       0,   761,    22,     0,    24,     0,   767,   134,     0,     0,
      30,     0,     0,   772,     0,     0,     0,     0,   926,     0,
       0,     0,     0,   171,   171,     0,     0,     0,     0,   135,
     136,     0,     0,   137,   138,   171,   139,   140,   141,   142,
       0,     0,   143,    59,   927,    60,     0,     0,     0,     0,
     300,     0,     0,     0,   301,     0,   145,   146,     0,     0,
       0,     0,     0,   302,     0,   303,     0,   928,     0,   304,
       0,   148,     0,   929,   930,   812,   151,   152,     0,     0,
     387,     0,     0,    12,    13,    14,    15,    16,    17,    18,
       0,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,   840,     0,
       0,   350,    56,    57,    58,    59,     0,    60,     0,     0,
       0,     0,   112,   305,   306,   307,   308,   309,   310,   311,
     244,   245,   246,   247,   264,   265,   266,   267,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   312,   313,
     314,   315,   316,   114,   317,   318,   319,     0,     0,     0,
     887,     0,     0,     0,     0,     0,   891,     0,   892,     0,
       0,     0,   895,   767,     0,   767,     0,     0,     0,     0,
       0,     0,     0,   908,     0,     0,     0,     0,   625,     0,
       0,     0,     0,     0,   919,     0,   940,     0,     0,   949,
     950,   920,     0,   921,     0,     0,     0,     0,     0,   132,
     133,     0,     0,   739,   922,     0,     0,   923,     0,   924,
       0,   740,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    22,     0,    24,
       0,   462,   134,     0,     0,    30,     0,     0,     0,     0,
       0,     0,     0,   926,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   940,   135,   136,   208,     0,   137,   138,
       0,   139,   140,   141,   142,     0,     0,   143,    59,   927,
      60,     0,     0,  1036,     0,     0,   474,     0,     0,     0,
       0,   145,   146,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   928,     0,     0,     0,   148,     0,   929,   930,
       0,   151,   152,     0,     0,  1065,     0,     0,     0,     0,
       0,     0,     0,  1126,     0,     0,     0,  -759,     0,     0,
       0,     0,     0,     0,     0,  -759,   131,   474,     0,     0,
       0,     0,   940,   940,   132,   133,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1107,
    1110,  1111,    22,     0,    24,     0,     0,   134,     0,     0,
      30,     0,     0,     0,  -759,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   135,
     136,     0,     0,   137,   138,  1138,   139,   140,   141,   142,
       0,     0,   143,    59,   144,    60,     0,     0,     0,     0,
       0,  1148,     0,     0,     0,     0,   145,   146,     0,  1036,
       0,     0,     0,     0,     0,   940,  1086,   147,     0,     0,
       0,   148,     0,   149,   150,     0,   151,   152,     0,   131,
    1171,     0,     0,     0,     0,     0,     0,   132,   133,     0,
       0,   739,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1184,     0,     0,     0,    22,     0,    24,   940,   940,
     134,     0,     0,    30,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1202,     0,  1204,     0,     0,
       0,     0,   135,   136,     0,     0,   137,   138,     0,   139,
     140,   141,   142,     0,     0,   143,    59,   144,    60,     0,
    1229,     0,     0,     0,     0,     0,     0,     0,   940,   145,
     146,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     928,     0,     0,     0,   148,   482,   149,   150,     0,   151,
     152,  1246,     0,   377,     0,     0,     0,     0,   131,     0,
       0,     0,     0,     0,     0,     0,   132,   133,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    12,    13,    14,    15,    16,    17,    18,
    1271,    19,    20,    21,    22,    23,    24,    25,    26,   378,
      28,    29,    30,    31,    32,    33,   379,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,   380,   381,    51,    52,   382,   383,    55,   139,   140,
     141,   142,    56,    57,   384,    59,   144,    60,     0,   376,
       0,     0,     0,     0,     0,     0,     0,   377,   145,   146,
       0,     0,   131,     0,     0,     0,     0,     0,     0,   385,
     132,   133,     0,   386,   209,   149,   150,     0,   151,   152,
       0,     0,     0,     0,     0,     0,     0,    12,    13,    14,
      15,    16,    17,    18,     0,    19,    20,    21,    22,    23,
      24,    25,    26,   378,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,   380,   381,    51,    52,   382,
     383,    55,   139,   140,   141,   142,    56,    57,   384,    59,
     144,    60,     0,   376,     0,     0,     0,     0,     0,     0,
       0,   377,   145,   146,     0,     0,   131,     0,     0,     0,
       0,     0,     0,   385,   132,   133,     0,   386,  -759,   149,
     150,     0,   151,   152,     0,     0,     0,     0,     0,     0,
       0,    12,    13,    14,    15,    16,    17,    18,     0,    19,
      20,    21,    22,    23,    24,    25,    26,   378,    28,    29,
      30,    31,    32,    33,   379,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,   380,
     381,    51,    52,   382,   383,    55,   139,   140,   141,   142,
      56,    57,   384,    59,   144,    60,     0,   461,     0,     0,
       0,     0,     0,     0,     0,     0,   145,   146,     0,     0,
     131,     0,     0,     0,     0,     0,     0,   385,   132,   133,
       0,   386,     0,   149,   150,     0,   151,   152,     0,     0,
       0,     0,     0,     0,     0,    12,    13,    14,    15,    16,
      17,    18,     0,    19,    20,    21,    22,    23,    24,    25,
      26,   378,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,   380,   381,    51,    52,   382,   383,    55,
     139,   140,   141,   142,    56,    57,   384,    59,   144,    60,
       0,   609,     0,     0,     0,     0,     0,     0,     0,     0,
     145,   146,     0,     0,   131,     0,     0,     0,     0,     0,
       0,   147,   132,   133,     0,   148,     0,   149,   150,     0,
     151,   152,     0,     0,     0,     0,     0,     0,     0,    12,
      13,    14,    15,    16,    17,    18,     0,    19,    20,    21,
      22,    23,    24,    25,    26,   378,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,   380,   381,    51,
      52,   382,   383,    55,   139,   140,   141,   142,    56,    57,
     384,    59,   144,    60,     0,  1024,     0,     0,     0,     0,
       0,     0,     0,     0,   145,   146,     0,     0,   131,     0,
       0,     0,     0,     0,     0,   147,   132,   133,     0,   148,
       0,   149,   150,     0,   151,   152,     0,     0,     0,     0,
       0,     0,     0,    12,    13,    14,    15,    16,    17,    18,
       0,    19,    20,    21,    22,    23,    24,    25,    26,   378,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,   380,   381,    51,    52,   382,   383,    55,   139,   140,
     141,   142,    56,    57,   384,    59,   144,    60,     0,   461,
       0,     0,     0,     0,     0,     0,     0,     0,   145,   146,
       0,     0,   131,     0,     0,     0,     0,     0,     0,   147,
     132,   133,     0,   148,     0,   149,   150,     0,   151,   152,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    22,     0,
      24,     0,     0,   134,     0,     0,    30,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   135,   136,     0,     0,   137,
     138,     0,   139,   140,   141,   142,   467,     0,   143,    59,
     144,    60,     0,     0,     0,     0,     0,     0,     0,   131,
       0,     0,   145,   146,     0,     0,     0,   132,   133,     0,
       0,     0,     0,   147,     0,     0,     0,   148,     0,   149,
     150,     0,   151,   152,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    22,     0,    24,     0,     0,
     134,     0,     0,    30,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   135,   136,     0,     0,   137,   138,     0,   139,
     140,   141,   142,   581,     0,   143,    59,   144,    60,     0,
       0,     0,     0,     0,     0,     0,   131,     0,     0,   145,
     146,     0,     0,     0,   132,   133,     0,     0,     0,     0,
     147,     0,     0,     0,   148,     0,   149,   150,     0,   151,
     152,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    22,     0,    24,     0,     0,   134,     0,     0,
      30,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   135,
     136,     0,     0,   137,   138,     0,   139,   140,   141,   142,
     720,     0,   143,    59,   144,    60,     0,     0,     0,     0,
       0,     0,     0,   131,     0,     0,   145,   146,     0,     0,
       0,   132,   133,     0,     0,     0,     0,   147,     0,     0,
       0,   148,     0,   149,   150,     0,   151,   152,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    22,
       0,    24,     0,     0,   134,     0,     0,    30,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   135,   136,     0,     0,
     137,   138,     0,   139,   140,   141,   142,   764,     0,   143,
      59,   144,    60,     0,     0,     0,     0,     0,     0,     0,
     131,     0,     0,   145,   146,     0,     0,     0,   132,   133,
       0,     0,     0,     0,   147,     0,     0,     0,   148,     0,
     149,   150,     0,   151,   152,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    22,     0,    24,     0,
       0,   134,     0,     0,    30,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   135,   136,     0,     0,   137,   138,     0,
     139,   140,   141,   142,   898,     0,   143,    59,   144,    60,
       0,     0,     0,     0,     0,     0,     0,   131,     0,     0,
     145,   146,     0,     0,     0,   132,   133,     0,     0,     0,
       0,   147,     0,     0,     0,   148,     0,   149,   150,     0,
     151,   152,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    22,     0,    24,     0,     0,   134,     0,
       0,    30,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     135,   136,     0,     0,   137,   138,     0,   139,   140,   141,
     142,  1080,     0,   143,    59,   144,    60,     0,     0,     0,
       0,     0,     0,     0,   131,     0,     0,   145,   146,     0,
       0,     0,   132,   133,     0,     0,     0,     0,   147,     0,
       0,     0,   148,     0,   149,   150,     0,   151,   152,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      22,     0,    24,     0,     0,   134,     0,     0,    30,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   135,   136,     0,
       0,   137,   138,     0,   139,   140,   141,   142,  1082,     0,
     143,    59,   144,    60,     0,     0,     0,     0,     0,     0,
       0,  -159,     0,     0,   145,   146,     0,     0,     0,  -159,
    -159,     0,     0,     0,     0,   385,     0,     0,     0,   386,
       0,   149,   150,     0,   151,   152,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -159,     0,  -159,
       0,     0,  -159,     0,     0,  -159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -159,  -159,     0,     0,  -159,  -159,
       0,  -159,  -159,  -159,  -159,  1108,     0,  -159,  -159,  -159,
    -159,     0,     0,     0,     0,     0,     0,     0,   131,     0,
       0,  -159,  -159,     0,     0,     0,   132,   133,     0,     0,
       0,     0,  -159,     0,     0,     0,  -159,     0,  -159,  -159,
       0,  -159,  -159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    22,     0,    24,     0,     0,   134,
       0,     0,    30,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   135,   136,     0,     0,   137,   138,     0,   139,   140,
     141,   142,  1129,     0,   143,    59,   144,    60,     0,     0,
       0,     0,     0,     0,     0,   131,     0,     0,   145,   146,
       0,     0,     0,   132,   133,     0,     0,     0,     0,   147,
       0,     0,     0,   148,     0,   149,   150,     0,   151,   152,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    22,     0,    24,     0,     0,   134,     0,     0,    30,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   135,   136,
       0,     0,   137,   138,     0,   139,   140,   141,   142,  1133,
       0,   143,    59,   144,    60,     0,     0,     0,     0,     0,
       0,     0,   131,     0,     0,   145,   146,     0,     0,     0,
     132,   133,     0,     0,     0,     0,   147,     0,     0,     0,
     148,     0,   149,   150,     0,   151,   152,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    22,     0,
      24,     0,     0,   134,     0,     0,    30,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   135,   136,     0,     0,   137,
     138,     0,   139,   140,   141,   142,  1203,     0,   143,    59,
     144,    60,     0,     0,     0,     0,     0,     0,     0,   131,
       0,     0,   145,   146,     0,     0,     0,   132,   133,     0,
       0,     0,     0,   147,     0,     0,     0,   148,     0,   149,
     150,     0,   151,   152,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    22,     0,    24,     0,     0,
     134,     0,     0,    30,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   135,   136,     0,     0,   137,   138,     0,   139,
     140,   141,   142,  1231,     0,   143,    59,   144,    60,     0,
       0,     0,     0,     0,     0,     0,   131,     0,     0,   145,
     146,     0,     0,     0,   132,   133,     0,     0,     0,     0,
     147,     0,     0,     0,   148,     0,   149,   150,     0,   151,
     152,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    22,     0,    24,     0,     0,   134,     0,     0,
      30,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   135,
     136,     0,     0,   137,   138,     0,   139,   140,   141,   142,
       0,     0,   143,    59,   144,    60,     0,     0,     0,     0,
       0,     0,     0,   131,     0,   921,   145,   146,     0,     0,
       0,     0,     0,     0,     0,     0,   922,   147,     0,     0,
       0,   148,     0,   149,   150,     0,   151,   152,    12,    13,
      14,    15,    16,    17,    18,     0,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,     0,     0,     0,     0,    56,    57,    58,
      59,     0,  1029,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     496,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   497,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   498,     0,     0,     0,
       0,     0,     0,     0,     0,  -767,     0,     0,    12,    13,
      14,    15,    16,    17,    18,   499,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,  1161,     0,     0,     0,    56,    57,    58,
     500,  -224,    60,     0,     0,  -759,   501,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   502,     0,     0,     0,     0,
       0,    12,    13,    14,    15,    16,    17,    18,     0,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,     0,     0,     0,     0,
      56,    57,    58,    59,   639,    60,   329,   640,     0,     0,
       0,     0,   131,   641,     0,   642,   643,     0,     0,     0,
       0,   644,     0,   645,     0,     0,     0,     0,  -759,   646,
       0,     0,     0,     0,     0,   647,   648,     0,     0,     0,
       0,   649,     0,     0,     0,     0,     0,     0,    22,     0,
      24,     0,     0,   134,     0,     0,    30,     0,     0,     0,
       0,     0,     0,     0,     0,   650,   651,     0,     0,     0,
       0,   652,     0,     0,     0,   135,   136,   653,   654,   137,
     138,   655,   292,     0,     0,     0,   656,   657,   143,    59,
     639,    60,   329,   640,     0,     0,     0,     0,   131,   641,
       0,   642,   643,     0,     0,     0,     0,   644,     0,   645,
       0,     0,     0,   147,     0,   646,     0,     0,     0,   658,
       0,   647,   648,     0,     0,     0,     0,   649,     0,     0,
       0,     0,     0,     0,    22,     0,    24,     0,     0,   134,
       0,     0,    30,     0,     0,     0,     0,     0,     0,     0,
       0,   650,   651,     0,     0,     0,     0,   652,     0,     0,
       0,   135,   136,   653,   654,   137,   138,   655,     0,     0,
       0,     0,   656,   657,   143,    59,     0,    60,     0,     0,
       0,   131,     0,     0,     0,     0,     0,     0,     0,   132,
     133,     0,     0,     0,     0,     0,     0,     0,     0,   147,
       0,     0,     0,     0,     0,   658,    12,    13,    14,    15,
      16,    17,    18,     0,    19,    20,    21,    22,    23,    24,
      25,    26,   378,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,   380,   381,    51,    52,   382,   383,
      55,   139,   140,   141,   142,    56,    57,   384,    59,   144,
      60,     0,     0,     0,     0,     0,     0,     0,   131,     0,
       0,   145,   146,     0,     0,     0,   132,   133,     0,     0,
     739,     0,   385,   476,     0,     0,   386,     0,   149,   150,
       0,   151,   152,    12,    13,    14,    15,    16,    17,    18,
       0,    19,    20,    21,    22,    23,    24,    25,    26,   378,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,   380,   381,    51,    52,   382,   383,    55,   139,   140,
     141,   142,    56,    57,   384,    59,   144,    60,     0,     0,
       0,     0,     0,     0,     0,   131,     0,     0,   145,   146,
       0,     0,     0,   132,   133,     0,     0,     0,     0,   928,
       0,     0,     0,   148,     0,   149,   150,     0,   151,   152,
      12,    13,    14,    15,    16,    17,    18,     0,    19,    20,
      21,    22,    23,    24,    25,    26,   378,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,   380,   381,
      51,    52,   382,   383,    55,   139,   140,   141,   142,    56,
      57,   384,    59,   144,    60,     0,     0,     0,     0,     0,
       0,     0,   131,     0,     0,   145,   146,     0,     0,     0,
     132,   133,     0,     0,     0,     0,   147,     0,     0,     0,
     148,     0,   149,   150,     0,   151,   152,    12,    13,    14,
      15,    16,    17,    18,     0,    19,    20,    21,    22,    23,
      24,    25,    26,   378,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,   380,   381,    51,    52,   382,
     383,    55,   139,   140,   141,   142,    56,    57,   384,    59,
     144,    60,   131,     0,     0,     0,     0,     0,     0,     0,
     132,   133,   145,   146,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   385,     0,     0,     0,   386,     0,   149,
     150,     0,   151,   152,     0,     0,     0,     0,    22,     0,
      24,     0,     0,   134,     0,     0,    30,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   135,   136,     0,     0,   137,
     138,     0,   139,   140,   141,   142,     0,     0,   143,    59,
     144,    60,   131,     0,     0,     0,     0,     0,     0,     0,
     132,   133,   145,   146,   739,     0,     0,     0,     0,     0,
       0,     0,     0,   147,     0,     0,     0,   148,   209,   149,
     150,     0,   151,   152,     0,     0,     0,     0,    22,     0,
      24,     0,     0,   134,     0,     0,    30,     0,     0,     0,
       0,     0,     0,   131,     0,     0,     0,     0,     0,     0,
       0,   132,   133,     0,     0,   135,   136,     0,     0,   137,
     138,     0,   139,   140,   141,   142,     0,     0,   143,    59,
     144,    60,     0,     0,     0,     0,     0,     0,     0,    22,
       0,    24,   145,   146,   134,     0,     0,    30,     0,     0,
       0,     0,     0,   928,     0,     0,     0,   148,     0,   149,
     150,     0,   151,   152,     0,     0,   135,   136,     0,     0,
     137,   138,     0,   139,   140,   141,   142,     0,     0,   143,
      59,   144,    60,   131,     0,     0,     0,     0,     0,     0,
       0,   132,   133,   145,   146,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   147,     0,     0,     0,   148,     0,
     149,   150,     0,   151,   152,     0,     0,     0,     0,    22,
       0,    24,     0,     0,   134,     0,     0,    30,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   135,   136,     0,     0,
     137,   138,     0,   139,   140,   141,   142,     0,     0,   143,
      59,   144,    60,     0,     0,     0,     0,     0,     0,     0,
     131,     0,   921,   145,   146,     0,     0,     0,   132,   133,
       0,     0,     0,   922,   385,     0,     0,     0,   386,     0,
     149,   150,     0,   151,   152,    12,    13,    14,    15,    16,
      17,    18,     0,    19,    20,    21,    22,    23,    24,    25,
      26,   378,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,   380,   381,    51,    52,   382,   383,    55,
     139,   140,   141,   142,    56,    57,   384,    59,   144,    60,
     734,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     145,   146,     0,     0,     0,   497,     0,     0,     0,     0,
       0,   147,     0,     0,     0,   148,   498,   149,   150,     0,
       0,     0,     0,     0,     0,  -767,     0,     0,    12,    13,
      14,    15,    16,    17,    18,   499,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,     0,     0,     0,   533,    56,    57,    58,
     500,     0,    60,  -129,     0,     0,   735,     0,  -129,     0,
       0,  -129,     0,     0,     0,  -129,     0,     0,     0,     0,
       0,     0,  -129,  -129,     0,     0,     0,     0,     0,  -129,
       0,  -129,     0,     0,    12,    13,    14,    15,    16,    17,
      18,  -129,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,     0,
     847,     0,     0,    56,    57,    58,    59,  -128,    60,     0,
       0,     0,  -128,     0,     0,  -128,     0,     0,     0,  -128,
       0,     0,     0,     0,     0,     0,  -128,  -128,     0,     0,
       0,     0,     0,  -128,     0,  -128,     0,     0,    12,    13,
      14,    15,    16,    17,    18,  -128,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,   560,     0,     0,     0,    56,    57,    58,
      59,     0,    60,     0,     0,   -75,     0,     0,   -75,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   -75,
       0,     0,     0,     0,     0,     0,   -75,     0,   -75,     0,
       0,    12,    13,    14,    15,    16,    17,    18,   -75,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,  1187,     0,     0,     0,
      56,    57,    58,    59,     0,    60,     0,     0,  -767,     0,
       0,  -767,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -767,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -767,  -767,  -767,  -767,  -767,  -767,
    -767,     0,  -767,  -767,  -767,  -767,  -767,  -767,  -767,  -767,
    -767,  -767,  -767,  -767,  -767,  -767,  -767,  -767,  -767,  -767,
    -767,  -767,  -767,  -767,  -767,  -767,  -767,  -767,  -767,  -767,
    -767,  -767,  -767,  -767,  -767,  -767,  -767,  -767,  -767,  1010,
       0,     0,     0,  -767,  -767,  -767,  -767,  -767,  -767,     0,
       0,  -220,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    12,    13,    14,
      15,    16,    17,    18,     0,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,   291,     0,     0,     0,    56,    57,    58,    59,
       0,    60,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      12,    13,    14,    15,    16,    17,    18,     0,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,   292,   515,     0,     0,    56,
      57,    58,    59,     0,    60,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    12,    13,    14,    15,    16,    17,
      18,     0,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,   292,
      11,     0,     0,    56,    57,    58,    59,     0,    60,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    12,    13,
      14,    15,    16,    17,    18,     0,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,   127,     0,     0,     0,    56,    57,    58,
      59,     0,    60,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    12,    13,    14,    15,    16,    17,    18,     0,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,   341,     0,     0,     0,
      56,    57,    58,    59,     0,    60,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    12,    13,    14,    15,    16,    17,
      18,     0,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,   533,
       0,     0,     0,    56,    57,    58,    59,     0,    60,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    12,    13,    14,
      15,    16,    17,    18,     0,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,   538,     0,     0,     0,    56,    57,    58,    59,
       0,    60,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      12,    13,    14,    15,    16,    17,    18,     0,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,   554,     0,     0,     0,    56,
      57,    58,    59,     0,    60,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    12,    13,    14,    15,    16,    17,    18,
       0,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,   671,     0,
       0,     0,    56,    57,    58,    59,     0,    60,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    12,    13,    14,    15,
      16,    17,    18,     0,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,   700,     0,     0,     0,    56,    57,    58,    59,     0,
      60,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    12,
      13,    14,    15,    16,    17,    18,     0,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,   796,     0,     0,     0,    56,    57,
      58,   500,     0,    60,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    12,    13,    14,    15,    16,    17,    18,     0,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,   849,     0,     0,
       0,    56,    57,    58,    59,     0,    60,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    12,    13,    14,    15,    16,
      17,    18,     0,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
     867,     0,     0,     0,    56,    57,    58,    59,     0,    60,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    12,    13,
      14,    15,    16,    17,    18,     0,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,   988,     0,     0,     0,    56,    57,    58,
     500,     0,    60,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    12,    13,    14,    15,    16,    17,    18,     0,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,  1050,     0,     0,     0,
      56,    57,    58,    59,     0,    60,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    12,    13,    14,    15,    16,    17,
      18,     0,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,  1165,
       0,     0,     0,    56,    57,    58,    59,     0,    60,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    12,    13,    14,
      15,    16,    17,    18,     0,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,     0,     0,     0,     0,    56,    57,    58,    59,
       0,    60,    12,    13,    14,    15,    16,    17,    18,     0,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,     0,     0,     0,
       0,    56,    57,    58,    59,  -767,    60,     0,     0,     0,
       0,   112,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    12,    13,    14,    15,    16,
      17,    18,   114,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
     131,     0,   921,     0,    56,    57,    58,    59,     0,    60,
       0,     0,     0,   922,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    12,    13,    14,    15,    16,
      17,    18,  -761,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
     131,     0,   921,     0,    56,    57,    58,    59,     0,    60,
       0,     0,     0,   922,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    12,    13,    14,    15,    16,
      17,    18,     0,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
     497,     0,     0,     0,    56,    57,    58,    59,     0,    60,
       0,   498,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    12,    13,    14,    15,    16,    17,    18,
     499,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,  1217,     0,
       0,     0,    56,    57,    58,   500,     0,    60,     0,  1218,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    12,  1219,    14,    15,    16,  1220,    18,     0,  1221,
    1222,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,  1223,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,     0,     0,     0,     0,
      56,    57,    58,  1224,     0,    60,    12,    13,    14,    15,
      16,    17,    18,    94,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,     0,     0,     0,     0,    56,    57,    58,    59,     0,
      60,    12,    13,    14,    15,    16,    17,    18,     0,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,   292,     0,     0,     0,
      56,    57,    58,    59,     0,    60,    12,    13,    14,    15,
      16,    17,    18,     0,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,     0,     0,     0,     0,    56,    57,    58,    59,     0,
      60,    12,    13,    14,    15,    16,    17,    18,     0,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,     0,     0,     0,     0,
      56,    57,    58,    59,     0,    60,    12,    13,    14,    15,
      16,    17,    18,     0,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,     0,     0,     0,     0,    56,    57,    58,    59,     0,
      60,    12,    13,    14,    15,    16,    17,    18,     0,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,     0,     0,     0,     0,
      56,    57,    58,    59,     0,    60,    12,    13,    14,    15,
      16,    17,    18,     0,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,     0,     0,     0,     0,    56,    57,    58,   500,     0,
      60
};

/* YYCONFLP[YYPACT[STATE-NUM]] -- Pointer into YYCONFL of start of
   list of conflicting reductions corresponding to action entry for
   state STATE-NUM in yytable.  0 means no conflicts.  The list in
   yyconfl is terminated by a rule number of 0.  */
static const unsigned char yyconflp[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   103,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   119,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    41,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    71,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   105,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    43,     0,     0,    45,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    73,     0,     0,    75,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   153,     0,
       0,     0,     0,   155,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   159,   157,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   161,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    69,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    27,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    47,     0,     0,     0,     0,     0,     0,
       0,     0,   147,     0,     0,     0,   149,     0,     0,     0,
     151,     0,     0,     0,    29,    31,    33,    35,    37,     0,
      39,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    19,     0,     0,     0,     0,     0,
      21,     0,     0,     0,     0,     0,    49,    51,    53,    55,
      57,    23,    59,    25,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    67,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      77,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    79,    81,     0,     0,     0,     0,    83,     0,
       0,    85,     0,     0,     0,     0,    87,     0,     0,     0,
       0,     0,     0,     0,     0,    89,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   107,   109,     0,     0,
       0,     0,   111,     0,     0,   113,     0,     0,     0,     0,
     115,     0,     0,     0,     0,     0,     0,     0,     0,   117,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    61,     0,     0,     0,
       0,     0,     0,    63,     0,     0,     0,     0,     0,     0,
       0,     0,    65,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   121,   123,     0,
       0,     0,     0,     0,     0,     0,   125,     0,   127,     0,
       0,     0,     0,   129,   131,     0,     0,     0,     0,   133,
     135,     0,     0,   137,   139,     0,     0,     0,     0,   141,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,     0,   145,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     1,
       3,     0,     0,     0,     0,     5,     0,     0,     7,     0,
       0,     0,     0,     9,     0,     0,     0,     0,     0,     0,
       0,     0,    11,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    13,     0,     0,     0,
       0,    15,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    17,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    91,
      93,     0,     0,     0,     0,    95,     0,     0,    97,     0,
       0,     0,     0,    99,     0,     0,     0,     0,     0,     0,
       0,     0,   101,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0
};

/* YYCONFL[I] -- lists of conflicting rule numbers, each terminated by
   0, pointed into by YYCONFLP.  */
static const short int yyconfl[] =
{
       0,    78,     0,    78,     0,    78,     0,    78,     0,    78,
       0,    78,     0,   727,     0,   727,     0,   727,     0,   706,
       0,   707,     0,   710,     0,   708,     0,   767,     0,   767,
       0,   703,     0,   767,     0,   767,     0,   767,     0,   767,
       0,   606,     0,   606,     0,   606,     0,   745,     0,   745,
       0,   745,     0,   745,     0,   745,     0,   745,     0,   745,
       0,    75,     0,    75,     0,    75,     0,   507,     0,   588,
       0,   614,     0,   614,     0,   614,     0,   759,     0,   129,
       0,   129,     0,   129,     0,   129,     0,   129,     0,   129,
       0,   126,     0,   126,     0,   126,     0,   126,     0,   126,
       0,   126,     0,   615,     0,   615,     0,   128,     0,   128,
       0,   128,     0,   128,     0,   128,     0,   128,     0,   574,
       0,   517,     0,   517,     0,   517,     0,   517,     0,   517,
       0,   517,     0,   517,     0,   517,     0,   517,     0,   517,
       0,   517,     0,   517,     0,   517,     0,   745,     0,   745,
       0,   745,     0,   146,     0,   146,     0,   146,     0,   142,
       0,   142,     0
};

static const short int yycheck[] =
{
       9,    73,    11,   297,     9,   475,   520,   420,   160,   149,
      97,   624,   510,   420,   179,   274,   275,   379,   191,   542,
     400,   347,   520,   385,   584,   917,   320,   167,   124,   680,
     858,   622,   201,   626,   622,   204,   346,   347,   386,   762,
     763,   129,   863,   182,   874,   402,   119,  1017,  1005,   541,
     637,     1,    61,   703,     1,   858,     1,    13,   166,   981,
     787,   534,    35,    72,   986,    53,    24,   897,    77,   385,
      24,    80,    77,     1,     2,     1,     5,   907,   858,    11,
     460,     1,    10,     1,    94,     1,    64,    13,    98,     1,
     177,    71,    91,   102,     1,    13,   105,   925,    77,   991,
     105,     1,   111,    91,     1,   929,   930,   667,   116,    13,
     118,     0,   115,   836,    94,   114,   729,     1,    98,   129,
     123,   844,   925,  1093,     1,   103,   105,   115,   855,    61,
     492,  1101,    36,    62,   143,     1,   276,   277,   278,     1,
     731,   114,   945,   731,  1066,   925,     1,   255,   978,   257,
       1,    79,    80,    98,    91,     1,   806,   330,   114,   750,
       1,   119,   750,   636,   114,   119,   116,   340,   118,   114,
     893,   116,    98,   118,   490,   491,   123,     1,    98,   107,
     108,   190,   674,   111,   129,   354,   531,   914,   114,   117,
       1,    98,   118,  1150,  1151,     1,   114,     1,    95,    96,
     118,   117,   118,   129,   120,   117,   134,   114,   120,   129,
     114,   118,    96,  1037,   114,   509,     1,  1139,   118,   116,
     117,   118,   129,   517,   518,   519,   123,     1,  1198,   820,
     637,   593,     1,   117,   118,   597,   598,   751,  1068,   826,
     117,   118,     1,   605,   172,   173,   174,   175,   176,   177,
     178,   117,   114,   751,   120,   363,  1178,   344,  1180,   114,
       1,   618,   619,   114,    98,   193,   439,   858,   114,  1097,
     858,  1163,   345,   705,   120,     1,   117,   593,  1248,   120,
     574,   597,     1,   205,  1206,  1207,   271,     1,   273,     1,
      96,    24,    44,   117,   118,   129,   858,   642,     1,    11,
       1,   858,   816,   442,     1,  1135,   117,   118,     5,   114,
     114,   117,   118,   117,   120,     1,    13,  1239,   816,   328,
     614,   615,    96,     1,   333,     1,   413,    91,   337,   114,
     402,   116,   117,   926,   925,    98,   927,   925,   929,   930,
     863,  1064,   115,   117,   118,   114,   120,  1177,   117,   437,
       1,   115,   115,   281,   945,   114,   284,   116,   117,   118,
     888,     1,   531,   925,   286,    62,   129,   626,   925,  1261,
    1191,   803,  1200,   699,   722,   384,   117,   118,    44,  1209,
      35,    36,   367,    91,     1,   118,   115,    60,     5,   699,
     116,   117,  1199,   402,   123,   404,    13,   116,   117,     0,
     115,  1124,   116,   117,   413,   117,   334,   335,  1131,     1,
     880,  1062,  1063,   116,   117,   116,   117,   114,    44,   826,
     833,    13,   427,    49,   433,   985,   833,   499,    29,   114,
     116,   117,    98,   961,   962,   507,    40,   114,   116,   117,
     116,   117,   115,  1250,  1251,    62,  1037,    44,    74,   377,
     378,   116,   117,   549,   541,    59,  1179,   385,   386,   114,
     983,  1052,   114,   114,  1052,   116,    94,     6,    69,   115,
      98,    10,   641,   119,   114,   403,   116,    74,   406,   575,
     408,   409,    21,   411,   412,   413,   414,   550,   416,   658,
      91,    96,     1,   662,  1008,   423,   424,   114,   968,   116,
      86,   129,    41,    12,   432,   116,    92,   118,   436,   437,
    1008,   116,   731,   118,   577,    13,    13,   445,   446,    28,
       8,    14,   114,   903,   116,    13,    39,   114,    67,    68,
       1,   750,   460,   542,     5,    91,   122,    35,    36,    36,
     713,   550,    13,  1013,   116,   117,   618,   619,   557,   621,
     957,   958,   114,    51,    51,   116,  1267,    50,    71,    52,
     488,  1272,   490,   491,     1,    58,   116,   117,   577,   497,
     498,   110,   111,   112,   113,   584,    13,    34,    44,    36,
     800,    94,   802,   511,    50,    98,   948,   126,   127,    46,
      91,    62,    58,   132,   522,    53,     1,   593,    91,   858,
      93,   597,    39,   693,   532,   695,   534,    44,     1,   618,
     619,   539,   414,    54,   416,   624,   114,   114,  1141,  1142,
      13,     1,   406,    91,   408,   553,     1,   921,   922,   114,
       5,    24,   115,    13,    71,  1048,   564,   999,    13,   115,
     835,  1048,   837,   114,  1257,    50,    39,    52,    44,   116,
     117,    44,   115,    58,   913,    95,    96,    94,   667,    39,
      35,    98,   116,   117,    44,   593,   925,   926,  1191,   597,
     456,   758,   458,   116,   117,    71,    51,   114,    71,   116,
     115,   118,   116,   117,   689,   115,    91,    62,    93,  1212,
     777,    71,   436,   437,   703,   116,   783,   784,    94,   115,
     865,    94,    98,   334,   335,    98,   780,   781,   636,    19,
     782,   716,     8,     1,    94,   117,   910,   911,    98,   114,
     729,   114,   115,   116,   117,    13,   119,   120,    13,    65,
     123,    16,   116,  1256,   114,   115,   116,   117,   118,   114,
     120,    96,    27,  1098,  1099,  1004,  1005,     5,   676,   901,
      33,    39,     1,  1250,  1251,  1269,    44,   618,   619,  1056,
    1057,   123,  1232,  1176,    13,   693,   116,   695,   696,  1176,
     123,  1269,     7,     7,    92,   115,    61,   705,   706,    14,
      14,    19,    92,    71,    94,    70,  1059,  1060,    98,   929,
      39,    26,    26,   118,   722,    44,   123,   806,   116,    34,
      50,   119,    52,   121,   122,   123,    94,  1277,    58,   119,
      98,   121,   122,   123,   115,    50,    50,    52,    52,   129,
     115,    29,    71,    58,    58,     1,   114,   115,   116,   117,
     118,   115,   120,   115,    84,   357,   358,    13,   910,   911,
     120,    91,    50,    93,    52,    94,   113,   116,   115,    98,
      58,   114,   780,   781,   863,   115,    91,    91,    93,    93,
    1119,  1120,    50,    39,    52,   114,    28,   116,    44,    53,
      58,   114,   800,    13,   802,   803,    16,   805,    24,    14,
     147,   148,   149,    91,   116,    93,  1145,    27,   118,   156,
     114,  1150,  1151,   821,   120,    71,    86,   118,   120,   166,
     167,    62,    92,    91,   116,    93,   915,   916,   917,   116,
     838,   920,    36,    53,   923,    50,   118,    52,    94,   114,
      55,    61,    98,    58,   117,   114,   116,     1,   118,   114,
      70,   114,   122,   114,   201,   114,   203,   204,   114,    13,
     116,  1200,    77,    78,    95,   115,    81,    82,  1242,  1243,
    1244,  1245,    13,    28,    13,    90,    91,    96,    93,   118,
     888,   119,   118,   118,    13,    39,    91,    25,   115,     5,
      44,   115,   115,     8,   983,   903,   985,   118,   115,    11,
     115,    16,   991,   114,   118,    20,   118,   254,   255,   118,
     257,    11,    27,  1002,    13,   123,   116,    71,    24,   927,
     928,   929,   930,   116,   271,    63,   273,   274,   275,   276,
     277,   278,    47,    48,   281,    73,    24,     7,    24,     8,
      94,    33,   289,   118,    98,   115,    61,    16,   114,  1038,
      74,    20,   120,   961,   962,    70,   964,   119,    27,    49,
     114,    99,   116,   116,   116,   116,   104,   105,   106,   107,
     108,   109,   118,    51,    92,    96,    40,   114,    47,    48,
      24,    46,    96,    44,   119,    24,   124,   125,    49,    50,
    1079,    52,    61,   131,   114,    92,    11,    58,   116,   117,
      11,   119,   349,   121,   122,   123,   114,   354,    59,   356,
     357,   358,   114,    74,    75,    76,   363,   120,   114,   366,
     367,   368,   119,   114,   121,   122,   123,   114,     8,  1037,
     377,    13,   379,    13,    16,    24,    16,  1189,   385,   386,
      20,    13,    13,     9,   118,    27,    28,    27,    28,   116,
      96,    24,  1141,   400,   116,   118,   114,  1146,   117,   115,
     115,   114,    11,   120,  1149,    47,    48,    47,    48,   119,
     417,     1,   120,    13,  1163,     5,    56,    24,    24,    61,
     118,    61,   116,    13,    14,   116,   116,  1172,    70,  1097,
      70,    42,    22,    23,   114,    13,  1104,   118,  1106,    50,
      91,    52,  1191,   115,  1189,   115,    57,    58,   455,   456,
     116,   458,   116,   460,    67,   192,   958,   810,   570,   102,
      50,   706,    52,   470,   471,    55,   553,   539,    58,   712,
     793,   562,    62,   433,   925,  1172,  1200,   945,   577,   486,
      91,   488,    93,   490,   491,   492,   111,    77,    78,   346,
     737,    81,    82,  1052,    84,    85,    86,    87,   820,   662,
      90,    91,    92,    93,   777,  1252,  1141,   773,  1257,  1142,
     254,   839,  1261,    92,   104,   105,   815,   488,  1267,   488,
      19,   489,   177,  1272,   531,   115,    25,   281,   642,   119,
     177,   121,   122,    67,   124,   125,    -1,   116,    -1,   546,
     119,    -1,   121,   122,   123,    -1,    -1,    -1,    -1,  1217,
    1218,    -1,    -1,  1221,  1222,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    63,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,
     587,    -1,    -1,   590,    -1,    -1,   593,    -1,    -1,    -1,
     597,   598,    -1,   600,    -1,    -1,    -1,    -1,   605,    -1,
      99,   100,   101,   102,    -1,   104,   105,   106,   107,   108,
     109,    -1,    -1,    -1,    -1,   622,    -1,    -1,    -1,   626,
      -1,    -1,    -1,    -1,    -1,   124,   125,    -1,    -1,   128,
     129,   130,   131,   640,   641,   642,   643,    -1,    -1,    -1,
      -1,   648,    -1,    -1,    -1,    -1,    -1,    -1,   655,    -1,
      -1,   658,    -1,    -1,    -1,   662,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,
      -1,     7,    -1,   680,    -1,    -1,    -1,    -1,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    -1,
      -1,   113,    -1,   115,    30,    -1,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     717,    -1,    -1,    -1,    50,   722,    52,    -1,    -1,    55,
      -1,    -1,    58,    -1,   731,   147,   148,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    78,   750,    -1,    81,    82,    -1,    84,    85,
      86,    87,    -1,    -1,    90,    91,    92,    93,    -1,    -1,
      -1,    -1,    -1,   770,   771,    -1,   773,    -1,   104,   105,
      93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,
      -1,   203,    -1,   119,    -1,   121,   122,    -1,   124,   125,
      -1,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,    14,    -1,
      -1,    -1,    -1,   820,    -1,   822,    22,    23,    -1,    -1,
      -1,   828,    -1,   830,    -1,    -1,    -1,   834,   835,    -1,
     837,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   845,    -1,
      -1,    -1,    -1,    -1,    50,    -1,    52,    -1,    -1,    55,
      -1,   858,    58,    -1,   861,   862,    -1,    -1,    -1,   281,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   289,    -1,    -1,
      -1,    77,    78,    -1,    -1,    81,    82,    -1,    84,    85,
      86,    87,    -1,   890,    90,    91,    92,    93,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   903,    -1,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,   913,    -1,    -1,   115,
      -1,    -1,    -1,   119,    -1,   121,   122,    -1,   925,   926,
      -1,   928,   929,    -1,    -1,    -1,    -1,   349,    -1,    -1,
      -1,    -1,   354,    -1,   356,   357,   358,    -1,   945,    -1,
      -1,   948,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   377,    -1,   379,    -1,    -1,
      -1,    -1,    -1,   385,   386,    -1,    -1,    -1,    -1,    -1,
     977,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   400,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   999,    -1,    -1,   417,    -1,  1004,  1005,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    -1,    -1,    -1,  1031,  1032,  1033,    -1,    -1,    -1,
      -1,    -1,    -1,   455,   456,    -1,   458,    -1,   460,    -1,
      -1,    -1,    -1,    -1,    -1,  1052,    50,    -1,    52,  1056,
    1057,    55,  1059,  1060,    58,  1062,  1063,    -1,    -1,    -1,
    1067,    -1,    -1,    -1,   486,    -1,   488,    -1,   490,   491,
     492,    -1,    -1,    77,    78,    -1,  1083,    81,    82,    -1,
      84,    85,    86,    87,  1091,    -1,    90,    91,    92,    93,
    1097,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     104,   105,    -1,    -1,    -1,  1112,    -1,    -1,    -1,    -1,
     114,   115,  1119,  1120,    -1,   119,    -1,   121,   122,    -1,
     124,   125,    -1,    -1,   546,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1143,    -1,  1145,    -1,
      -1,    -1,    -1,  1150,  1151,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1167,    -1,  1169,    -1,    -1,   587,    -1,    -1,   590,    -1,
      -1,   593,    -1,     1,    -1,   597,   598,    -1,   600,     7,
      -1,    -1,    -1,   605,    -1,  1192,    14,    -1,    16,    -1,
      -1,    -1,  1199,  1200,    22,    23,    -1,    -1,    26,    27,
      -1,    -1,    30,    -1,    32,    -1,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1223,    45,   640,    -1,
      -1,   643,    50,    -1,    52,    -1,   648,    55,    -1,    -1,
      58,    -1,    -1,   655,    -1,    -1,    -1,    -1,    66,    -1,
      -1,    -1,    -1,  1250,  1251,    -1,    -1,    -1,    -1,    77,
      78,    -1,    -1,    81,    82,  1262,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    93,    -1,    -1,    -1,    -1,
       6,    -1,    -1,    -1,    10,    -1,   104,   105,    -1,    -1,
      -1,    -1,    -1,    19,    -1,    21,    -1,   115,    -1,    25,
      -1,   119,    -1,   121,   122,   717,   124,   125,    -1,    -1,
     722,    -1,    -1,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,   770,    -1,
      -1,   773,    88,    89,    90,    91,    -1,    93,    -1,    -1,
      -1,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   124,   125,
     126,   127,   128,   129,   130,   131,   132,    -1,    -1,    -1,
     822,    -1,    -1,    -1,    -1,    -1,   828,    -1,   830,    -1,
      -1,    -1,   834,   835,    -1,   837,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   845,    -1,    -1,    -1,    -1,     1,    -1,
      -1,    -1,    -1,    -1,     7,    -1,   858,    -1,    -1,   861,
     862,    14,    -1,    16,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    -1,    26,    27,    -1,    -1,    30,    -1,    32,
      -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,    52,
      -1,   903,    55,    -1,    -1,    58,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   925,    77,    78,   928,    -1,    81,    82,
      -1,    84,    85,    86,    87,    -1,    -1,    90,    91,    92,
      93,    -1,    -1,   945,    -1,    -1,   948,    -1,    -1,    -1,
      -1,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   115,    -1,    -1,    -1,   119,    -1,   121,   122,
      -1,   124,   125,    -1,    -1,   977,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     1,    -1,    -1,    -1,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    13,    14,   999,    -1,    -1,
      -1,    -1,  1004,  1005,    22,    23,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1031,
    1032,  1033,    50,    -1,    52,    -1,    -1,    55,    -1,    -1,
      58,    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      78,    -1,    -1,    81,    82,  1067,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    93,    -1,    -1,    -1,    -1,
      -1,  1083,    -1,    -1,    -1,    -1,   104,   105,    -1,  1091,
      -1,    -1,    -1,    -1,    -1,  1097,     1,   115,    -1,    -1,
      -1,   119,    -1,   121,   122,    -1,   124,   125,    -1,    14,
    1112,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      -1,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1143,    -1,    -1,    -1,    50,    -1,    52,  1150,  1151,
      55,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1167,    -1,  1169,    -1,    -1,
      -1,    -1,    77,    78,    -1,    -1,    81,    82,    -1,    84,
      85,    86,    87,    -1,    -1,    90,    91,    92,    93,    -1,
    1192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1200,   104,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     115,    -1,    -1,    -1,   119,     1,   121,   122,    -1,   124,
     125,  1223,    -1,     9,    -1,    -1,    -1,    -1,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    42,    43,    44,    45,
    1262,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    -1,     1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     9,   104,   105,
      -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,   115,
      22,    23,    -1,   119,   120,   121,   122,    -1,   124,   125,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     9,   104,   105,    -1,    -1,    14,    -1,    -1,    -1,
      -1,    -1,    -1,   115,    22,    23,    -1,   119,   120,   121,
     122,    -1,   124,   125,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    -1,     1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,   105,    -1,    -1,
      14,    -1,    -1,    -1,    -1,    -1,    -1,   115,    22,    23,
      -1,   119,    -1,   121,   122,    -1,   124,   125,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     104,   105,    -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,
      -1,   115,    22,    23,    -1,   119,    -1,   121,   122,    -1,
     124,   125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    -1,     1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   104,   105,    -1,    -1,    14,    -1,
      -1,    -1,    -1,    -1,    -1,   115,    22,    23,    -1,   119,
      -1,   121,   122,    -1,   124,   125,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    -1,     1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,   105,
      -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,   115,
      22,    23,    -1,   119,    -1,   121,   122,    -1,   124,   125,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,
      52,    -1,    -1,    55,    -1,    -1,    58,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    78,    -1,    -1,    81,
      82,    -1,    84,    85,    86,    87,     1,    -1,    90,    91,
      92,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      -1,    -1,   104,   105,    -1,    -1,    -1,    22,    23,    -1,
      -1,    -1,    -1,   115,    -1,    -1,    -1,   119,    -1,   121,
     122,    -1,   124,   125,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    50,    -1,    52,    -1,    -1,
      55,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    77,    78,    -1,    -1,    81,    82,    -1,    84,
      85,    86,    87,     1,    -1,    90,    91,    92,    93,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    -1,    -1,   104,
     105,    -1,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,
     115,    -1,    -1,    -1,   119,    -1,   121,   122,    -1,   124,
     125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    50,    -1,    52,    -1,    -1,    55,    -1,    -1,
      58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      78,    -1,    -1,    81,    82,    -1,    84,    85,    86,    87,
       1,    -1,    90,    91,    92,    93,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    -1,    -1,   104,   105,    -1,    -1,
      -1,    22,    23,    -1,    -1,    -1,    -1,   115,    -1,    -1,
      -1,   119,    -1,   121,   122,    -1,   124,   125,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,
      -1,    52,    -1,    -1,    55,    -1,    -1,    58,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    77,    78,    -1,    -1,
      81,    82,    -1,    84,    85,    86,    87,     1,    -1,    90,
      91,    92,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    -1,    -1,   104,   105,    -1,    -1,    -1,    22,    23,
      -1,    -1,    -1,    -1,   115,    -1,    -1,    -1,   119,    -1,
     121,   122,    -1,   124,   125,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,    52,    -1,
      -1,    55,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    77,    78,    -1,    -1,    81,    82,    -1,
      84,    85,    86,    87,     1,    -1,    90,    91,    92,    93,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    -1,    -1,
     104,   105,    -1,    -1,    -1,    22,    23,    -1,    -1,    -1,
      -1,   115,    -1,    -1,    -1,   119,    -1,   121,   122,    -1,
     124,   125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    50,    -1,    52,    -1,    -1,    55,    -1,
      -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      77,    78,    -1,    -1,    81,    82,    -1,    84,    85,    86,
      87,     1,    -1,    90,    91,    92,    93,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    -1,    -1,   104,   105,    -1,
      -1,    -1,    22,    23,    -1,    -1,    -1,    -1,   115,    -1,
      -1,    -1,   119,    -1,   121,   122,    -1,   124,   125,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      50,    -1,    52,    -1,    -1,    55,    -1,    -1,    58,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    78,    -1,
      -1,    81,    82,    -1,    84,    85,    86,    87,     1,    -1,
      90,    91,    92,    93,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    -1,    -1,   104,   105,    -1,    -1,    -1,    22,
      23,    -1,    -1,    -1,    -1,   115,    -1,    -1,    -1,   119,
      -1,   121,   122,    -1,   124,   125,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,    52,
      -1,    -1,    55,    -1,    -1,    58,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    77,    78,    -1,    -1,    81,    82,
      -1,    84,    85,    86,    87,     1,    -1,    90,    91,    92,
      93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    -1,
      -1,   104,   105,    -1,    -1,    -1,    22,    23,    -1,    -1,
      -1,    -1,   115,    -1,    -1,    -1,   119,    -1,   121,   122,
      -1,   124,   125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    50,    -1,    52,    -1,    -1,    55,
      -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    78,    -1,    -1,    81,    82,    -1,    84,    85,
      86,    87,     1,    -1,    90,    91,    92,    93,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    -1,    -1,   104,   105,
      -1,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,   115,
      -1,    -1,    -1,   119,    -1,   121,   122,    -1,   124,   125,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    50,    -1,    52,    -1,    -1,    55,    -1,    -1,    58,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    78,
      -1,    -1,    81,    82,    -1,    84,    85,    86,    87,     1,
      -1,    90,    91,    92,    93,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    -1,    -1,   104,   105,    -1,    -1,    -1,
      22,    23,    -1,    -1,    -1,    -1,   115,    -1,    -1,    -1,
     119,    -1,   121,   122,    -1,   124,   125,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,
      52,    -1,    -1,    55,    -1,    -1,    58,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    78,    -1,    -1,    81,
      82,    -1,    84,    85,    86,    87,     1,    -1,    90,    91,
      92,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      -1,    -1,   104,   105,    -1,    -1,    -1,    22,    23,    -1,
      -1,    -1,    -1,   115,    -1,    -1,    -1,   119,    -1,   121,
     122,    -1,   124,   125,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    50,    -1,    52,    -1,    -1,
      55,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    77,    78,    -1,    -1,    81,    82,    -1,    84,
      85,    86,    87,     1,    -1,    90,    91,    92,    93,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    -1,    -1,   104,
     105,    -1,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,
     115,    -1,    -1,    -1,   119,    -1,   121,   122,    -1,   124,
     125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    50,    -1,    52,    -1,    -1,    55,    -1,    -1,
      58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      78,    -1,    -1,    81,    82,    -1,    84,    85,    86,    87,
      -1,    -1,    90,    91,    92,    93,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    -1,    16,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    27,   115,    -1,    -1,
      -1,   119,    -1,   121,   122,    -1,   124,   125,    39,    40,
      41,    42,    43,    44,    45,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    -1,    -1,    -1,    -1,    88,    89,    90,
      91,    -1,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
       1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    16,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,     1,    -1,    -1,    -1,    88,    89,    90,
      91,     9,    93,    -1,    -1,    13,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    -1,    -1,    -1,    -1,
      88,    89,    90,    91,     6,    93,     8,     9,    -1,    -1,
      -1,    -1,    14,    15,    -1,    17,    18,    -1,    -1,    -1,
      -1,    23,    -1,    25,    -1,    -1,    -1,    -1,   116,    31,
      -1,    -1,    -1,    -1,    -1,    37,    38,    -1,    -1,    -1,
      -1,    43,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,
      52,    -1,    -1,    55,    -1,    -1,    58,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    67,    68,    -1,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    77,    78,    79,    80,    81,
      82,    83,    84,    -1,    -1,    -1,    88,    89,    90,    91,
       6,    93,     8,     9,    -1,    -1,    -1,    -1,    14,    15,
      -1,    17,    18,    -1,    -1,    -1,    -1,    23,    -1,    25,
      -1,    -1,    -1,   115,    -1,    31,    -1,    -1,    -1,   121,
      -1,    37,    38,    -1,    -1,    -1,    -1,    43,    -1,    -1,
      -1,    -1,    -1,    -1,    50,    -1,    52,    -1,    -1,    55,
      -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    68,    -1,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    77,    78,    79,    80,    81,    82,    83,    -1,    -1,
      -1,    -1,    88,    89,    90,    91,    -1,    93,    -1,    -1,
      -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,
      -1,    -1,    -1,    -1,    -1,   121,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    -1,
      -1,   104,   105,    -1,    -1,    -1,    22,    23,    -1,    -1,
      26,    -1,   115,   116,    -1,    -1,   119,    -1,   121,   122,
      -1,   124,   125,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    -1,    -1,   104,   105,
      -1,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,   115,
      -1,    -1,    -1,   119,    -1,   121,   122,    -1,   124,   125,
      39,    40,    41,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    -1,    -1,   104,   105,    -1,    -1,    -1,
      22,    23,    -1,    -1,    -1,    -1,   115,    -1,    -1,    -1,
     119,    -1,   121,   122,    -1,   124,   125,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   115,    -1,    -1,    -1,   119,    -1,   121,
     122,    -1,   124,   125,    -1,    -1,    -1,    -1,    50,    -1,
      52,    -1,    -1,    55,    -1,    -1,    58,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    78,    -1,    -1,    81,
      82,    -1,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    93,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,   104,   105,    26,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   115,    -1,    -1,    -1,   119,   120,   121,
     122,    -1,   124,   125,    -1,    -1,    -1,    -1,    50,    -1,
      52,    -1,    -1,    55,    -1,    -1,    58,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    -1,    77,    78,    -1,    -1,    81,
      82,    -1,    84,    85,    86,    87,    -1,    -1,    90,    91,
      92,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,
      -1,    52,   104,   105,    55,    -1,    -1,    58,    -1,    -1,
      -1,    -1,    -1,   115,    -1,    -1,    -1,   119,    -1,   121,
     122,    -1,   124,   125,    -1,    -1,    77,    78,    -1,    -1,
      81,    82,    -1,    84,    85,    86,    87,    -1,    -1,    90,
      91,    92,    93,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,   104,   105,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   115,    -1,    -1,    -1,   119,    -1,
     121,   122,    -1,   124,   125,    -1,    -1,    -1,    -1,    50,
      -1,    52,    -1,    -1,    55,    -1,    -1,    58,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    77,    78,    -1,    -1,
      81,    82,    -1,    84,    85,    86,    87,    -1,    -1,    90,
      91,    92,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    -1,    16,   104,   105,    -1,    -1,    -1,    22,    23,
      -1,    -1,    -1,    27,   115,    -1,    -1,    -1,   119,    -1,
     121,   122,    -1,   124,   125,    39,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
       1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     104,   105,    -1,    -1,    -1,    16,    -1,    -1,    -1,    -1,
      -1,   115,    -1,    -1,    -1,   119,    27,   121,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    -1,    -1,    -1,     1,    88,    89,    90,
      91,    -1,    93,     8,    -1,    -1,    97,    -1,    13,    -1,
      -1,    16,    -1,    -1,    -1,    20,    -1,    -1,    -1,    -1,
      -1,    -1,    27,    28,    -1,    -1,    -1,    -1,    -1,    34,
      -1,    36,    -1,    -1,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    -1,
       1,    -1,    -1,    88,    89,    90,    91,     8,    93,    -1,
      -1,    -1,    13,    -1,    -1,    16,    -1,    -1,    -1,    20,
      -1,    -1,    -1,    -1,    -1,    -1,    27,    28,    -1,    -1,
      -1,    -1,    -1,    34,    -1,    36,    -1,    -1,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,     1,    -1,    -1,    -1,    88,    89,    90,
      91,    -1,    93,    -1,    -1,    13,    -1,    -1,    16,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,
      -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,    36,    -1,
      -1,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,     1,    -1,    -1,    -1,
      88,    89,    90,    91,    -1,    93,    -1,    -1,    13,    -1,
      -1,    16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,     1,
      -1,    -1,    -1,    88,    89,    90,    91,     9,    93,    -1,
      -1,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,     1,    -1,    -1,    -1,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    41,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,     1,    -1,    -1,    88,
      89,    90,    91,    -1,    93,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
       1,    -1,    -1,    88,    89,    90,    91,    -1,    93,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    42,    43,    44,    45,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,     1,    -1,    -1,    -1,    88,    89,    90,
      91,    -1,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,     1,    -1,    -1,    -1,
      88,    89,    90,    91,    -1,    93,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,     1,
      -1,    -1,    -1,    88,    89,    90,    91,    -1,    93,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,     1,    -1,    -1,    -1,    88,    89,    90,    91,
      -1,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    41,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,     1,    -1,    -1,    -1,    88,
      89,    90,    91,    -1,    93,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,     1,    -1,
      -1,    -1,    88,    89,    90,    91,    -1,    93,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,     1,    -1,    -1,    -1,    88,    89,    90,    91,    -1,
      93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,     1,    -1,    -1,    -1,    88,    89,
      90,    91,    -1,    93,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    41,    42,    43,    44,    45,    -1,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,     1,    -1,    -1,
      -1,    88,    89,    90,    91,    -1,    93,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
       1,    -1,    -1,    -1,    88,    89,    90,    91,    -1,    93,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    42,    43,    44,    45,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,     1,    -1,    -1,    -1,    88,    89,    90,
      91,    -1,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,     1,    -1,    -1,    -1,
      88,    89,    90,    91,    -1,    93,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,     1,
      -1,    -1,    -1,    88,    89,    90,    91,    -1,    93,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    -1,    -1,    -1,    88,    89,    90,    91,
      -1,    93,    39,    40,    41,    42,    43,    44,    45,    -1,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    -1,    -1,    -1,
      -1,    88,    89,    90,    91,     9,    93,    -1,    -1,    -1,
      -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,
      44,    45,   129,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      14,    -1,    16,    -1,    88,    89,    90,    91,    -1,    93,
      -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      14,    -1,    16,    -1,    88,    89,    90,    91,    -1,    93,
      -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      16,    -1,    -1,    -1,    88,    89,    90,    91,    -1,    93,
      -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    16,    -1,
      -1,    -1,    88,    89,    90,    91,    -1,    93,    -1,    27,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    -1,    -1,    -1,    -1,
      88,    89,    90,    91,    -1,    93,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    -1,    -1,    -1,    -1,    88,    89,    90,    91,    -1,
      93,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    -1,    -1,    -1,
      88,    89,    90,    91,    -1,    93,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    -1,    -1,    -1,    -1,    88,    89,    90,    91,    -1,
      93,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    -1,    -1,    -1,    -1,
      88,    89,    90,    91,    -1,    93,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    -1,    -1,    -1,    -1,    88,    89,    90,    91,    -1,
      93,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    -1,    -1,    -1,    -1,
      88,    89,    90,    91,    -1,    93,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    -1,    -1,    -1,    -1,    88,    89,    90,    91,    -1,
      93
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned short int yystos[] =
{
       0,    29,    69,    91,   134,   135,   138,   145,   150,   167,
     405,     1,    39,    40,    41,    42,    43,    44,    45,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    88,    89,    90,    91,
      93,   395,   396,   398,   399,   395,     0,   141,    44,   170,
     272,   410,   395,   115,   169,   410,   169,   114,   150,   405,
     115,   136,   114,    53,    91,   168,   169,   391,   392,   395,
     114,   114,   170,   395,    46,   273,   274,   395,   410,   177,
     178,   114,   146,   142,   144,   114,   116,     1,   117,    91,
     116,   117,    98,   115,   129,   408,   187,    54,   179,   151,
     168,    91,   148,   152,   153,   170,   395,     1,   395,   139,
     274,    14,    22,    23,    55,    77,    78,    81,    82,    84,
      85,    86,    87,    90,    92,   104,   105,   115,   119,   121,
     122,   124,   125,   339,   340,   342,   344,   345,   346,   348,
     349,   350,   355,   356,   362,   375,   378,   379,   397,   398,
     339,   398,    16,    20,    27,    47,    48,    61,    70,   137,
     188,   190,   191,   197,   261,   264,   265,   266,   180,   181,
     395,   152,   147,   149,   114,     1,   123,   409,   179,   177,
     395,   115,   115,   115,   115,   115,   357,   410,   339,   120,
     339,   376,   377,   345,    93,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   351,   116,    19,    25,    63,    73,    99,   100,
     101,   102,   104,   105,   106,   107,   108,   109,   124,   125,
     128,   129,   130,   131,   380,   381,   383,   387,     6,    10,
      21,    41,    67,    68,   110,   111,   112,   113,   126,   127,
     132,   382,   384,   388,    42,    57,   398,    64,   103,   350,
      92,   119,   121,   122,   123,   407,   115,   342,   345,   117,
     395,     1,    84,   205,   206,   390,   395,   395,   395,   395,
       6,    10,    19,    21,    25,    99,   100,   101,   102,   103,
     104,   105,   124,   125,   126,   127,   128,   130,   131,   132,
     276,   386,   387,   388,   395,   408,   198,   199,   395,     8,
     294,   201,   202,   114,     1,   114,    65,   182,   410,   409,
     148,     1,   171,   172,   395,   143,   194,   192,   355,   358,
     339,   360,   361,   355,   358,   116,    96,     1,   117,   120,
       5,   340,   342,   341,   342,    33,   344,   343,   344,   353,
     354,   398,   353,   345,   345,   345,     1,     9,    55,    62,
      77,    78,    81,    82,    90,   115,   119,   339,   363,   364,
     365,   366,   368,   369,   373,   374,   395,   398,   395,   116,
     358,   339,   115,   123,   278,   410,     1,   114,   117,   123,
     278,   123,   123,   278,     1,   114,   117,    19,   200,   410,
     400,   409,    34,    36,    46,   203,   268,   271,   410,   181,
     181,    60,   115,   183,   410,   409,     1,   114,   408,   152,
     154,   195,   196,   197,   261,    16,    27,   140,   193,   197,
     201,   260,   265,   116,   339,   118,     1,   116,   117,   116,
     117,     1,   339,   355,   359,   339,   377,     1,   377,   342,
     344,   123,   339,   395,   339,   369,   116,   339,   369,   370,
     372,   374,     1,   339,   363,   373,    96,   120,   114,   406,
       1,   117,   118,   120,   359,   116,     1,    16,    27,    46,
      91,    97,   116,   279,   280,   284,   391,   404,   410,   395,
     282,   283,   408,   410,   206,     1,   206,   395,   395,   395,
     277,   395,   408,   410,   199,   199,   339,    36,   295,   296,
     301,   302,   204,     1,   209,   210,   393,   395,     1,   207,
     208,   395,    49,    50,    52,    58,    74,    75,    76,   262,
     269,   272,   275,   115,     1,   184,   185,   395,   200,   172,
       1,   172,   177,    91,   115,   173,   174,   409,    28,   162,
     163,   165,   201,   395,   395,    53,   155,   114,   116,   339,
     361,     1,   361,   359,   395,   116,   116,   117,   398,    24,
     118,   114,   406,     1,   114,   116,   117,   371,   118,   120,
      96,   120,   339,   365,   366,    62,   368,   339,   374,     1,
     374,   369,   116,   116,   395,   395,   391,   116,     1,   114,
     116,    36,   118,   391,   278,     1,   118,   281,   300,   411,
     395,   278,   278,   278,   281,   395,   297,   114,   401,     6,
       9,    15,    17,    18,    23,    25,    31,    37,    38,    43,
      67,    68,    73,    79,    80,    83,    88,    89,   121,   294,
     303,   304,   316,   319,   330,   332,   355,   385,   389,   390,
     398,     1,   219,   220,   395,   210,   117,   402,   208,   402,
     408,   347,   348,   410,   114,   339,   114,   114,   179,   271,
     114,   114,   184,     1,   116,   117,    95,   186,   410,   192,
       1,   175,   176,   394,   395,   404,   115,     8,    13,    13,
      28,   165,   179,    13,   267,   268,   271,   118,   116,   357,
       1,   339,   119,   367,   339,   372,   372,   369,   339,   278,
     278,   118,   285,   280,     1,    97,   280,   391,     7,    26,
      34,   286,   287,   288,   289,   292,   293,   353,   362,   403,
     118,   282,   352,   353,   210,   296,    13,   339,   355,   389,
     398,   339,   309,   312,     1,   317,   318,   339,    91,   333,
     115,   115,   339,   115,   355,   304,     5,   305,   357,   118,
       1,   114,   115,   223,   402,   395,   118,   118,   338,   339,
      91,   114,   114,   189,   116,   185,     1,   185,   395,    13,
       1,   116,   117,    96,   186,   123,   394,   175,    11,    11,
     187,   409,   339,   116,   363,    24,   282,   286,   116,   285,
      24,   119,    24,     7,   286,   281,   298,    24,    19,    94,
     331,   408,    33,   400,   400,     1,    11,   117,   118,   115,
     339,    29,   398,   360,   306,   331,   220,     1,   220,     1,
     224,   225,   391,     1,   408,   408,   226,   227,   228,   226,
     114,   270,    74,    49,   190,   263,   176,     1,   176,   394,
     395,   186,   116,   164,   166,     8,    56,   156,   159,   162,
     120,   367,   281,   293,   290,   291,   395,   339,   119,   296,
     307,   339,   339,   320,   295,   339,   318,   400,     1,   318,
     395,   349,   116,   117,   116,   116,   116,   400,   339,   116,
       1,   114,   116,   118,   221,   222,   226,   211,   272,     7,
      14,    16,    27,    30,    32,    45,    66,    92,   115,   121,
     122,   229,   230,   233,   246,   247,   249,   250,   252,   287,
     339,   352,   353,   362,   398,   403,   407,   411,    98,   339,
     339,   347,   294,   299,   300,   301,   299,   157,   160,    51,
     406,     1,   114,   120,    96,   291,     1,   323,   324,   325,
     327,   328,   338,   315,     1,    12,    28,   329,   400,    35,
     313,   299,   116,   118,   359,   395,   299,   225,     1,   225,
     353,   226,    40,   254,   410,    71,    94,    98,   258,   259,
     410,    39,   217,   258,   119,   119,   234,   410,   278,   278,
       1,   237,   238,   239,   240,   391,   410,    24,   230,   352,
     251,   252,   362,   395,     1,   248,   395,   251,   362,    93,
     251,    96,   115,   119,   231,   233,   339,    46,   369,   114,
     114,   114,   114,   114,   114,   161,   295,   161,   158,   291,
       1,   291,    24,   395,   120,   308,     1,   114,   406,     1,
     117,   118,     1,    96,    11,   339,   299,   310,    11,   401,
     334,   335,   336,   348,   410,   116,   357,   401,   258,    59,
       1,   369,     1,   218,   212,   410,     1,   235,   236,   246,
     353,   403,   236,    24,   281,    13,    13,     9,     1,   114,
     406,   118,   227,   116,     1,   116,   117,   339,     1,   232,
     339,   339,    96,   251,   215,   410,   295,     7,   288,   118,
      24,     5,    62,   321,   322,   325,     1,   325,   328,     1,
     328,   326,   338,     1,   338,   400,   314,   401,   339,   299,
     116,   118,   117,   115,   116,   115,   253,   410,   339,   114,
       1,   117,   120,   120,   227,   242,   245,   246,   395,   398,
     240,     1,   240,   227,   395,     1,   395,     1,   116,   117,
     120,   339,   114,   353,   353,    13,   400,   400,   299,    11,
     311,   401,   334,   336,   339,     1,   353,     1,   255,   256,
     410,    49,    74,   213,   216,   272,   236,   236,    24,    24,
     118,   258,   339,     1,   339,   216,   295,   299,   401,   400,
     401,   116,   118,   116,   116,   116,    13,    16,    27,    40,
      44,    47,    48,    72,    91,   257,   272,   391,   347,   339,
     227,     1,   243,   244,   327,   245,   353,   401,   401,   299,
     337,   348,   395,   395,   395,   395,   339,   114,   118,    91,
       1,   114,   406,   118,   401,   116,   117,   278,   278,   278,
     278,   227,   214,   244,   244,   241,   322,   115,   348,   282,
     258,   339,   115,   237,   281,   237,   116,   116,   406
};


/* Prevent warning if -Wmissing-prototypes.  */
int yyparse (void);

/* Error token number */
#define YYTERROR 1

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */


#define YYRHSLOC(Rhs, K) ((Rhs)[K].yystate.yyloc)
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)

/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# define YY_LOCATION_PRINT(File, Loc)			\
    fprintf (File, "%d.%d-%d.%d",			\
             (Loc).first_line, (Loc).first_column,	\
             (Loc).last_line,  (Loc).last_column)
#endif


#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#define YYLEX yylex ()

YYSTYPE yylval;

YYLTYPE yylloc;

int yynerrs;
int yychar;

static const int YYEOF = 0;
static const int YYEMPTY = -2;

typedef enum { yyok, yyaccept, yyabort, yyerr } YYRESULTTAG;

#define YYCHK(YYE)							     \
   do { YYRESULTTAG yyflag = YYE; if (yyflag != yyok) return yyflag; }	     \
   while (0)

#if YYDEBUG

#if ! defined (YYFPRINTF)
#  define YYFPRINTF fprintf
#endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;
  (void) yylocationp;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  fprintf (yyoutput, ": ");

# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr,					\
                  Type, Value, Location);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;

#else /* !YYDEBUG */

# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)

#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYMAXDEPTH * sizeof (GLRStackItem)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

/* Minimum number of free items on the stack allowed after an
   allocation.  This is to allow allocation and initialization
   to be completed by functions that call expandGLRStack before the
   stack is expanded, thus insuring that all necessary pointers get
   properly redirected to new data. */
#define YYHEADROOM 2

#if (! defined (YYSTACKEXPANDABLE) \
     && (! defined (__cplusplus) \
	 || (defined (YYLTYPE_IS_TRIVIAL) && YYLTYPE_IS_TRIVIAL \
	     && defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))
#define YYSTACKEXPANDABLE 1
#else
#define YYSTACKEXPANDABLE 0
#endif

/** State numbers, as in LALR(1) machine */
typedef int yyStateNum;

/** Rule numbers, as in LALR(1) machine */
typedef int yyRuleNum;

/** Grammar symbol */
typedef short int yySymbol;

/** Item references, as in LALR(1) machine */
typedef short int yyItemNum;

typedef struct yyGLRState yyGLRState;
typedef struct yySemanticOption yySemanticOption;
typedef union yyGLRStackItem yyGLRStackItem;
typedef struct yyGLRStack yyGLRStack;
typedef struct yyGLRStateSet yyGLRStateSet;

struct yyGLRState {
  yybool yyisState;
  yybool yyresolved;
  yyStateNum yylrState;
  yyGLRState* yypred;
  size_t yyposn;
  union {
    yySemanticOption* yyfirstVal;
    YYSTYPE yysval;
  } yysemantics;
  YYLTYPE yyloc;
};

struct yyGLRStateSet {
  yyGLRState** yystates;
  size_t yysize, yycapacity;
};

struct yySemanticOption {
  yybool yyisState;
  yyRuleNum yyrule;
  yyGLRState* yystate;
  yySemanticOption* yynext;
};

union yyGLRStackItem {
  yyGLRState yystate;
  yySemanticOption yyoption;
};

struct yyGLRStack {
  int yyerrflag;
  int yyerrState;
  /* To compute the location of the error token.  */
  yyGLRStackItem yyerror_range[3];

  yySymbol* yytokenp;
  jmp_buf yyexception_buffer;
  yyGLRStackItem* yyitems;
  yyGLRStackItem* yynextFree;
  int yyspaceLeft;
  yyGLRState* yysplitPoint;
  yyGLRState* yylastDeleted;
  yyGLRStateSet yytops;
};

static void yyinitGLRStack (yyGLRStack* yystack, size_t yysize);
static void yyexpandGLRStack (yyGLRStack* yystack);
static void yyfreeGLRStack (yyGLRStack* yystack);

static void
yyFail (yyGLRStack* yystack, const char* yyformat, ...)
{
  yystack->yyerrflag = 1;
  if (yyformat != NULL)
    {
      char yymsg[256];
      va_list yyap;
      va_start (yyap, yyformat);
      vsprintf (yymsg, yyformat, yyap);
      yyerror (yymsg);
    }
  longjmp (yystack->yyexception_buffer, 1);
}

#if YYDEBUG || YYERROR_VERBOSE
/** A printable representation of TOKEN.  Valid until next call to
 *  tokenName. */
static inline const char*
yytokenName (yySymbol yytoken)
{
  if (yytoken == YYEMPTY)
    return "";

  return yytname[yytoken];
}
#endif

/** Fill in YYVSP[YYLOW1 .. YYLOW0-1] from the chain of states starting
 *  at YYVSP[YYLOW0].yystate.yypred.  Leaves YYVSP[YYLOW1].yystate.yypred
 *  containing the pointer to the next state in the chain. Assumes
 *  YYLOW1 < YYLOW0.  */
static void yyfillin (yyGLRStackItem *, int, int) ATTRIBUTE_UNUSED;
static void
yyfillin (yyGLRStackItem *yyvsp, int yylow0, int yylow1)
{
  yyGLRState* s;
  int i;
  s = yyvsp[yylow0].yystate.yypred;
  for (i = yylow0-1; i >= yylow1; i -= 1)
    {
      YYASSERT (s->yyresolved);
      yyvsp[i].yystate.yyresolved = yytrue;
      yyvsp[i].yystate.yysemantics.yysval = s->yysemantics.yysval;
      yyvsp[i].yystate.yyloc = s->yyloc;
      s = yyvsp[i].yystate.yypred = s->yypred;
    }
}

/* Do nothing if YYNORMAL or if *YYLOW <= YYLOW1.  Otherwise, fill in
   YYVSP[YYLOW1 .. *YYLOW-1] as in yyfillin and set *YYLOW = YYLOW1.
   For convenience, always return YYLOW1.  */
static inline int yyfill (yyGLRStackItem *, int *, int, yybool)
     ATTRIBUTE_UNUSED;
static inline int
yyfill (yyGLRStackItem *yyvsp, int *yylow, int yylow1, yybool yynormal)
{
  if (!yynormal && yylow1 < *yylow)
    {
      yyfillin (yyvsp, *yylow, yylow1);
      *yylow = yylow1;
    }
  return yylow1;
}

/** Perform user action for rule number YYN, with RHS length YYRHSLEN,
 *  and top stack item YYVSP.  YYLVALP points to place to put semantic
 *  value ($$), and yylocp points to place for location information
 *  (@$). Returns yyok for normal return, yyaccept for YYACCEPT,
 *  yyerr for YYERROR, yyabort for YYABORT. */
static YYRESULTTAG
yyuserAction (yyRuleNum yyn, int yyrhslen, yyGLRStackItem* yyvsp,
	      YYSTYPE* yyvalp,
	      YYLTYPE* yylocp,
	      yyGLRStack* yystack
              )
{
  yybool yynormal ATTRIBUTE_UNUSED = (yystack->yysplitPoint == NULL);
  int yylow;

# undef yyerrok
# define yyerrok (yystack->yyerrState = 0)
# undef YYACCEPT
# define YYACCEPT return yyaccept
# undef YYABORT
# define YYABORT return yyabort
# undef YYERROR
# define YYERROR return yyerrok, yyerr
# undef YYRECOVERING
# define YYRECOVERING (yystack->yyerrState != 0)
# undef yyclearin
# define yyclearin (yychar = *(yystack->yytokenp) = YYEMPTY)
# undef YYFILL
# define YYFILL(N) yyfill (yyvsp, &yylow, N, yynormal)
# undef YYBACKUP
# define YYBACKUP(Token, Value)						     \
  return yyerror ("syntax error: cannot back up"),	     \
	 yyerrok, yyerr

  yylow = 1;
  if (yyrhslen == 0)
    *yyvalp = yyval_default;
  else
    *yyvalp = yyvsp[YYFILL (1-yyrhslen)].yystate.yysemantics.yysval;
  YYLLOC_DEFAULT (*yylocp, yyvsp - yyrhslen, yyrhslen);

  switch (yyn)
    {
        case 2:
#line 210 "parse.y"
    { error ("empty input file"); ;}
    break;

  case 3:
#line 212 "parse.y"
    {
        if (co->ignore_garbage_after_dot)
          {
            discard_input ();
            YYACCEPT;
          }
      ;}
    break;

  case 4:
#line 223 "parse.y"
    { initialize_module (TREE_PURPOSE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)), build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype) ? TREE_PURPOSE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) : NULL_TREE, TREE_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))), 0); ;}
    break;

  case 5:
#line 225 "parse.y"
    { start_main_program (); ;}
    break;

  case 6:
#line 227 "parse.y"
    { finish_main_program (); ;}
    break;

  case 7:
#line 229 "parse.y"
    { finalize_module (0); ;}
    break;

  case 8:
#line 234 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_interface); initialize_module ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), 1); ;}
    break;

  case 9:
#line 236 "parse.y"
    { start_unit_implementation (); ;}
    break;

  case 10:
#line 238 "parse.y"
    { check_forward_decls (1); ;}
    break;

  case 13:
#line 242 "parse.y"
    { ((*yyvalp).ttype) = current_module->name; finalize_module (1); ;}
    break;

  case 14:
#line 244 "parse.y"
    {
        if ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype) && current_module->name != (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))
          error ("implementation of module `%s' following interface of module `%s'",
                 IDENTIFIER_NAME (current_module->name), IDENTIFIER_NAME ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)));
      ;}
    break;

  case 15:
#line 250 "parse.y"
    { initialize_module ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 2); ;}
    break;

  case 16:
#line 252 "parse.y"
    {
        if (co->interface_only)
          exit_compilation ();
      ;}
    break;

  case 18:
#line 258 "parse.y"
    { initialize_module ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 4); ;}
    break;

  case 20:
#line 264 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_interface); ;}
    break;

  case 21:
#line 266 "parse.y"
    { initialize_module ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 2); ;}
    break;

  case 22:
#line 268 "parse.y"
    { clear_forward_decls ();  /* don't complain in poplevel */ ;}
    break;

  case 23:
#line 273 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_export); start_module_interface (); ;}
    break;

  case 24:
#line 275 "parse.y"
    { create_gpi_files (); ;}
    break;

  case 25:
#line 280 "parse.y"
    { initialize_module ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), NULL_TREE, 3); ;}
    break;

  case 27:
#line 285 "parse.y"
    { current_module->implementation = 1; ;}
    break;

  case 28:
#line 287 "parse.y"
    { check_forward_decls (1); ;}
    break;

  case 30:
#line 292 "parse.y"
    { chk_dialect ("units without `implementation' part are", U_M_PASCAL); ;}
    break;

  case 32:
#line 298 "parse.y"
    { start_constructor (0); ;}
    break;

  case 35:
#line 302 "parse.y"
    { start_destructor (); ;}
    break;

  case 36:
#line 304 "parse.y"
    { finish_destructor (); ;}
    break;

  case 38:
#line 310 "parse.y"
    { start_constructor (0); ;}
    break;

  case 40:
#line 316 "parse.y"
    { finish_constructor (); ;}
    break;

  case 45:
#line 328 "parse.y"
    { chk_dialect_name ("to begin do", E_O_PASCAL); start_constructor (0); ;}
    break;

  case 46:
#line 330 "parse.y"
    { finish_constructor (); ;}
    break;

  case 47:
#line 335 "parse.y"
    { chk_dialect_name ("to end do", E_O_PASCAL); start_destructor (); ;}
    break;

  case 48:
#line 337 "parse.y"
    { finish_destructor (); ;}
    break;

  case 49:
#line 342 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, NULL_TREE); ;}
    break;

  case 50:
#line 344 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 51:
#line 346 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 52:
#line 351 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype) ? TREE_PURPOSE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) : NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 54:
#line 357 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 58:
#line 368 "parse.y"
    { yyerrok; ;}
    break;

  case 59:
#line 370 "parse.y"
    { error ("module specifications need an export part"); ;}
    break;

  case 60:
#line 372 "parse.y"
    { warning ("missing semicolon"); yyerrok; ;}
    break;

  case 61:
#line 374 "parse.y"
    { error ("extra semicolon"); ;}
    break;

  case 62:
#line 379 "parse.y"
    { export_interface ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 63:
#line 384 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 65:
#line 387 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 66:
#line 392 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_all); ((*yyvalp).ttype) = build_tree_list (NULL_TREE, NULL_TREE); ;}
    break;

  case 68:
#line 398 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 69:
#line 400 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 70:
#line 402 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 71:
#line 404 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 72:
#line 409 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 73:
#line 411 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 74:
#line 413 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); TREE_READONLY (((*yyvalp).ttype)) = 1; ;}
    break;

  case 75:
#line 417 "parse.y"
    { do_extra_import (); ;}
    break;

  case 81:
#line 430 "parse.y"
    { warning ("missing semicolon"); yyerrok; ;}
    break;

  case 82:
#line 435 "parse.y"
    { import_interface ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype) ? IMPORT_QUALIFIED : IMPORT_ISO, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 86:
#line 446 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 87:
#line 448 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 89:
#line 454 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 90:
#line 456 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 91:
#line 458 "parse.y"
    { error ("missing comma"); ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 92:
#line 460 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 93:
#line 465 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 95:
#line 471 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 96:
#line 476 "parse.y"
    { ((*yyvalp).itype) = 2 * od_none; ;}
    break;

  case 97:
#line 478 "parse.y"
    { ((*yyvalp).itype) = check_decl_order ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 100:
#line 488 "parse.y"
    { ((*yyvalp).itype) = 2 * od_none; ;}
    break;

  case 101:
#line 490 "parse.y"
    { ((*yyvalp).itype) = check_decl_order ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 102:
#line 494 "parse.y"
    { check_forward_decls (0); ;}
    break;

  case 103:
#line 496 "parse.y"
    { ((*yyvalp).itype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype); ;}
    break;

  case 104:
#line 498 "parse.y"
    { ((*yyvalp).itype) = od_label; ;}
    break;

  case 105:
#line 500 "parse.y"
    { ((*yyvalp).itype) = od_routine; ;}
    break;

  case 106:
#line 505 "parse.y"
    { ((*yyvalp).itype) = 2 * od_none; ;}
    break;

  case 107:
#line 507 "parse.y"
    { ((*yyvalp).itype) = check_decl_order ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 110:
#line 514 "parse.y"
    { ((*yyvalp).itype) = od_routine; ;}
    break;

  case 111:
#line 519 "parse.y"
    { ((*yyvalp).itype) = 2 * od_none; ;}
    break;

  case 112:
#line 521 "parse.y"
    { ((*yyvalp).itype) = check_decl_order ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 114:
#line 526 "parse.y"
    { check_forward_decls (0); ;}
    break;

  case 115:
#line 528 "parse.y"
    { ((*yyvalp).itype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype); ;}
    break;

  case 116:
#line 530 "parse.y"
    { ((*yyvalp).itype) = od_routine; ;}
    break;

  case 117:
#line 535 "parse.y"
    { ((*yyvalp).itype) = od_uses; ;}
    break;

  case 120:
#line 542 "parse.y"
    { warning ("missing comma"); yyerrok; ;}
    break;

  case 121:
#line 547 "parse.y"
    { import_interface ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE, IMPORT_USES, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 123:
#line 553 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); chk_dialect ("file name specification with `in' is", BORLAND_DELPHI); ;}
    break;

  case 124:
#line 557 "parse.y"
    {
#ifndef EGCS97
        push_obstacks_nochange ();
        end_temporary_allocation ();
#endif
      ;}
    break;

  case 125:
#line 564 "parse.y"
    {
#ifndef EGCS97
        pop_obstacks ();
#endif
        ((*yyvalp).itype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype);
      ;}
    break;

  case 126:
#line 574 "parse.y"
    { ((*yyvalp).itype) = od_const; ;}
    break;

  case 127:
#line 576 "parse.y"
    { current_type_list = build_tree_list (NULL_TREE, NULL_TREE); ;}
    break;

  case 128:
#line 578 "parse.y"
    { declare_types (); ((*yyvalp).itype) = od_type; ;}
    break;

  case 129:
#line 580 "parse.y"
    { ((*yyvalp).itype) = od_var; ;}
    break;

  case 130:
#line 587 "parse.y"
    { declare_label ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 131:
#line 589 "parse.y"
    { declare_label ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 132:
#line 591 "parse.y"
    { error ("non-label in label_list"); ;}
    break;

  case 133:
#line 593 "parse.y"
    { declare_label ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 134:
#line 595 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 137:
#line 602 "parse.y"
    { chk_dialect ("non-numeric labels are", B_D_M_PASCAL); ;}
    break;

  case 141:
#line 613 "parse.y"
    { declare_constant ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 142:
#line 616 "parse.y"
    {
        lex_const_equal = -1;
        declare_variables (build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)), VQ_BP_CONST, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype));
      ;}
    break;

  case 145:
#line 629 "parse.y"
    {
        tree t, ids = ((*yyvalp).ttype) = nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype));
        if ((TREE_CODE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) == POINTER_TYPE || TREE_CODE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) == REFERENCE_TYPE)
            && TREE_CODE (TREE_TYPE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) == FUNCTION_TYPE)
          TREE_PRIVATE (ids) = !!allow_function_calls (0);  /* kludge */
        /* With `begin var Foo: Integer; Foo := ...' where `Foo'
           is a built-in identifier, parser look-ahead would already get
           its special meaning before we get to declaring the variables.
           So mark the identifiers. (fjf791.pas) */
        for (t = ids; t; t = TREE_CHAIN (t))
          PASCAL_PENDING_DECLARATION (TREE_VALUE (t)) = 1;
      ;}
    break;

  case 146:
#line 642 "parse.y"
    {
        tree t, ids = (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype);
        for (t = ids; t; t = TREE_CHAIN (t))
          PASCAL_PENDING_DECLARATION (TREE_VALUE (t)) = 0;
        lex_const_equal = -1;
        ((*yyvalp).ttype) = declare_variables (ids, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), 0, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype));
        if ((TREE_CODE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype)) == POINTER_TYPE || TREE_CODE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype)) == REFERENCE_TYPE)
            && TREE_CODE (TREE_TYPE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype))) == FUNCTION_TYPE)
          allow_function_calls (TREE_PRIVATE (ids));
        yyerrok;
      ;}
    break;

  case 147:
#line 654 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; lex_const_equal = -1; ;}
    break;

  case 149:
#line 660 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 151:
#line 666 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 152:
#line 668 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_name); ;}
    break;

  case 153:
#line 670 "parse.y"
    { ((*yyvalp).ttype) = tree_cons ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 155:
#line 676 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 156:
#line 681 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 157:
#line 683 "parse.y"
    { ((*yyvalp).ttype) = TREE_PURPOSE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 159:
#line 689 "parse.y"
    { ((*yyvalp).itype) = allow_function_calls (0); lex_const_equal = -1; ;}
    break;

  case 160:
#line 691 "parse.y"
    {
        allow_function_calls ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype));
        ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype));
        PASCAL_ABSOLUTE_CLAUSE (((*yyvalp).ttype)) = 1;
      ;}
    break;

  case 161:
#line 697 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 163:
#line 703 "parse.y"
    { yyerrok; ;}
    break;

  case 165:
#line 706 "parse.y"
    { error ("missing semicolon"); yyerrok; ;}
    break;

  case 166:
#line 708 "parse.y"
    { error ("extra semicolon"); ;}
    break;

  case 168:
#line 714 "parse.y"
    {
        lex_const_equal = -1;
        if (!EM ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)))
          {
            if (PASCAL_TYPE_UNDISCRIMINATED_SCHEMA ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)))
              chk_dialect ("undiscriminated schemata on the right side of a type definition are", GNU_PASCAL);
            build_type_decl ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype));
          }
      ;}
    break;

  case 169:
#line 724 "parse.y"
    {
        ((*yyvalp).itype) = immediate_size_expand;
        immediate_size_expand = 0;
        size_volatile++;
      ;}
    break;

  case 170:
#line 730 "parse.y"
    {
        build_type_decl ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), build_schema_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)), NULL_TREE);
        immediate_size_expand = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.itype);
        size_volatile--;
      ;}
    break;

  case 171:
#line 736 "parse.y"
    { build_schema_type (error_mark_node, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 172:
#line 738 "parse.y"
    { ((*yyvalp).ttype) = start_object_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 173:
#line 740 "parse.y"
    { lex_const_equal = -1; finish_object_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype) != NULL_TREE); yyerrok; ;}
    break;

  case 174:
#line 745 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 175:
#line 747 "parse.y"
    { error ("invalid schema discriminants"); ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 177:
#line 753 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 178:
#line 755 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing semicolon"); yyerrok; ;}
    break;

  case 179:
#line 757 "parse.y"
    { error ("extra semicolon"); ;}
    break;

  case 181:
#line 763 "parse.y"
    { ((*yyvalp).ttype) = build_discriminants ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 183:
#line 769 "parse.y"
    { type_attributes (&((*yyvalp).ttype), TREE_PURPOSE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 184:
#line 774 "parse.y"
    {
#ifndef EGCS97
        push_obstacks_nochange ();
        end_temporary_allocation ();
#endif
      ;}
    break;

  case 185:
#line 781 "parse.y"
    {
#ifndef EGCS97
        pop_obstacks ();
#endif
        ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype);
      ;}
    break;

  case 187:
#line 792 "parse.y"
    { ((*yyvalp).ttype) = pascal_type_variant ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), TYPE_QUALIFIER_BINDABLE); ;}
    break;

  case 189:
#line 798 "parse.y"
    { ((*yyvalp).ttype) = pascal_type_variant ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), TYPE_QUALIFIER_RESTRICTED); ;}
    break;

  case 190:
#line 800 "parse.y"
    { ((*yyvalp).ttype) = build_discriminated_schema_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 194:
#line 805 "parse.y"
    { chk_dialect ("procedural variables and types are", B_D_M_PASCAL); ;}
    break;

  case 196:
#line 808 "parse.y"
    { defining_packed_type -= (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype); ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype) ? pack_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) : (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 197:
#line 813 "parse.y"
    { chk_dialect ("schema/string discriminants are", E_O_M_PASCAL); ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 198:
#line 815 "parse.y"
    {
        chk_dialect ("string capacity in brackets is", U_B_D_M_PASCAL);
        ((*yyvalp).ttype) = build_tree_list (NULL_TREE, maybe_schema_discriminant (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), 0)));
      ;}
    break;

  case 199:
#line 824 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, maybe_schema_discriminant (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0))); ;}
    break;

  case 200:
#line 826 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, maybe_schema_discriminant (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0)))); yyerrok; ;}
    break;

  case 201:
#line 828 "parse.y"
    { error ("missing expression"); ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 202:
#line 830 "parse.y"
    { error ("missing comma"); ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, maybe_schema_discriminant (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0)))); yyerrok; ;}
    break;

  case 203:
#line 832 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 204:
#line 837 "parse.y"
    { ((*yyvalp).ttype) = build_pascal_array_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 206:
#line 840 "parse.y"
    { ((*yyvalp).ttype) = build_file_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 207:
#line 842 "parse.y"
    { ((*yyvalp).ttype) = build_set_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 208:
#line 844 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); yyerrok; ;}
    break;

  case 209:
#line 846 "parse.y"
    { ((*yyvalp).ttype) = build_record (NULL_TREE, NULL_TREE, NULL_TREE); ;}
    break;

  case 212:
#line 853 "parse.y"
    { ((*yyvalp).ttype) = TREE_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 214:
#line 859 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 215:
#line 861 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 216:
#line 863 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (error_mark_node, error_mark_node); ;}
    break;

  case 217:
#line 865 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (error_mark_node, error_mark_node); ;}
    break;

  case 218:
#line 870 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 219:
#line 872 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 220:
#line 877 "parse.y"
    { ((*yyvalp).ttype) = build_record (NULL_TREE, NULL_TREE, NULL_TREE); ;}
    break;

  case 221:
#line 879 "parse.y"
    { ((*yyvalp).ttype) = build_record ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE, NULL_TREE); ;}
    break;

  case 222:
#line 881 "parse.y"
    { ((*yyvalp).ttype) = build_record ((((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 226:
#line 892 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 227:
#line 894 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing semicolon"); yyerrok; ;}
    break;

  case 228:
#line 896 "parse.y"
    { error ("extra semicolon"); ;}
    break;

  case 230:
#line 902 "parse.y"
    { ((*yyvalp).ttype) = build_fields ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 231:
#line 907 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 232:
#line 909 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, build_field (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 233:
#line 914 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), build_field ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 234:
#line 916 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), build_field ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 235:
#line 918 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 236:
#line 920 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 238:
#line 926 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 239:
#line 928 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing semicolon"); yyerrok; ;}
    break;

  case 240:
#line 930 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 242:
#line 936 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), build_field (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 243:
#line 941 "parse.y"
    { chk_dialect ("type denoters (no identifiers) as variant tag type are", U_B_D_M_PASCAL); ;}
    break;

  case 246:
#line 951 "parse.y"
    { ((*yyvalp).ttype) = build_enum_type (nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 247:
#line 953 "parse.y"
    { ((*yyvalp).ttype) = error_mark_node; ;}
    break;

  case 248:
#line 958 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 249:
#line 960 "parse.y"
    { ((*yyvalp).ttype) = tree_cons ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 250:
#line 962 "parse.y"
    { ((*yyvalp).ttype) = tree_cons ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 251:
#line 964 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 253:
#line 970 "parse.y"
    { ((*yyvalp).ttype) = build_pascal_subrange_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 254:
#line 972 "parse.y"
    {
        defining_packed_type -= (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype);
        chk_dialect ("packed subrange types are", B_D_PASCAL);
        ((*yyvalp).ttype) = build_pascal_subrange_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype));
      ;}
    break;

  case 255:
#line 981 "parse.y"
    { ((*yyvalp).ttype) = EM ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) ? error_mark_node : build_pascal_pointer_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 256:
#line 983 "parse.y"
    { ((*yyvalp).ttype) = EM ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) ? error_mark_node : build_pascal_pointer_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 257:
#line 985 "parse.y"
    { ((*yyvalp).ttype) = EM ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) ? error_mark_node : build_pascal_pointer_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 258:
#line 987 "parse.y"
    { ((*yyvalp).ttype) = EM ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) ? error_mark_node : build_pascal_pointer_type (p_build_type_variant ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1, TYPE_VOLATILE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)))); ;}
    break;

  case 259:
#line 992 "parse.y"
    { ((*yyvalp).ttype) = get_pointer_domain_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 260:
#line 994 "parse.y"
    {
        chk_dialect ("pointers to routines are", GNU_PASCAL);
        gcc_assert (EM ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) || (TREE_CODE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)) == REFERENCE_TYPE && TREE_TYPE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))));
        ((*yyvalp).ttype) = TREE_TYPE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype));
      ;}
    break;

  case 262:
#line 1004 "parse.y"
    { ((*yyvalp).ttype) = build_procedural_type (void_type_node, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 263:
#line 1006 "parse.y"
    { ((*yyvalp).ttype) = build_procedural_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 265:
#line 1012 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 266:
#line 1014 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 270:
#line 1025 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 271:
#line 1027 "parse.y"
    { ((*yyvalp).ttype) = error_mark_node; ;}
    break;

  case 273:
#line 1033 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), build_tree_list (void_type_node, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 274:
#line 1035 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 275:
#line 1040 "parse.y"
    { ((*yyvalp).ttype) = build_fields ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 276:
#line 1042 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, void_type_node, 0); ;}
    break;

  case 277:
#line 1044 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 278:
#line 1046 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, boolean_type_node, 1); ;}
    break;

  case 279:
#line 1048 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, void_type_node, 1); ;}
    break;

  case 280:
#line 1050 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 281:
#line 1052 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 282:
#line 1054 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 285:
#line 1061 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 286:
#line 1063 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 287:
#line 1067 "parse.y"
    { lex_const_equal = -1; ;}
    break;

  case 288:
#line 1069 "parse.y"
    { chk_dialect ("initialization with `:=' is", VAX_PASCAL); ;}
    break;

  case 289:
#line 1071 "parse.y"
    { chk_dialect ("initialization with `=' is", BORLAND_DELPHI); ;}
    break;

  case 290:
#line 1078 "parse.y"
    { declare_routine ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1); ;}
    break;

  case 291:
#line 1089 "parse.y"
    { declare_routine ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 292:
#line 1091 "parse.y"
    { ((*yyvalp).ttype) = start_routine ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 293:
#line 1093 "parse.y"
    {
        do_setjmp ();
        un_initialize_block (getdecls (), 0, 0);
      ;}
    break;

  case 294:
#line 1098 "parse.y"
    { finish_routine ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 297:
#line 1108 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, void_type_node, 0); ;}
    break;

  case 298:
#line 1110 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 299:
#line 1112 "parse.y"
    { ((*yyvalp).ttype) = build_operator_heading ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 300:
#line 1122 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, void_type_node, 0); ;}
    break;

  case 301:
#line 1124 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 302:
#line 1126 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, boolean_type_node, 1); ;}
    break;

  case 303:
#line 1128 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, void_type_node, 1); ;}
    break;

  case 306:
#line 1138 "parse.y"
    { ((*yyvalp).ttype) = chainon (chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 307:
#line 1143 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 308:
#line 1145 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 309:
#line 1147 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_name); ;}
    break;

  case 310:
#line 1149 "parse.y"
    { ((*yyvalp).ttype) = tree_cons ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 311:
#line 1151 "parse.y"
    { ((*yyvalp).ttype) = tree_cons ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 312:
#line 1153 "parse.y"
    { ((*yyvalp).ttype) = tree_cons ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 313:
#line 1155 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 314:
#line 1157 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 315:
#line 1159 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 317:
#line 1165 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 318:
#line 1167 "parse.y"
    { ((*yyvalp).ttype) = tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 319:
#line 1172 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 321:
#line 1178 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 323:
#line 1184 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 324:
#line 1186 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 325:
#line 1188 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 326:
#line 1190 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 327:
#line 1192 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 333:
#line 1208 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); chk_dialect ("operator result variables with `=' are", GNU_PASCAL); ;}
    break;

  case 334:
#line 1210 "parse.y"
    { error ("missing operator result variable"); ;}
    break;

  case 336:
#line 1216 "parse.y"
    { chk_dialect ("empty parentheses are", BORLAND_DELPHI); ((*yyvalp).ttype) = void_list_node; ;}
    break;

  case 337:
#line 1218 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 338:
#line 1220 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, NULL_TREE); ;}
    break;

  case 339:
#line 1222 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, NULL_TREE)); ;}
    break;

  case 340:
#line 1224 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 342:
#line 1230 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 343:
#line 1232 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing semicolon"); yyerrok; ;}
    break;

  case 345:
#line 1238 "parse.y"
    { ((*yyvalp).ttype) = build_formal_param ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0, 0); ;}
    break;

  case 346:
#line 1240 "parse.y"
    { ((*yyvalp).ttype) = build_formal_param ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0, 1); ;}
    break;

  case 347:
#line 1242 "parse.y"
    { ((*yyvalp).ttype) = build_formal_param ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1, !!(((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 348:
#line 1244 "parse.y"
    { ((*yyvalp).ttype) = build_formal_param ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 2, 1); ;}
    break;

  case 349:
#line 1246 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE, void_type_node, 0); ;}
    break;

  case 350:
#line 1248 "parse.y"
    { ((*yyvalp).ttype) = build_routine_heading (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 351:
#line 1253 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 352:
#line 1255 "parse.y"
    { ((*yyvalp).ttype) = check_result_type ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 355:
#line 1262 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); chk_dialect ("function result variable specifications are", E_O_PASCAL); ;}
    break;

  case 357:
#line 1268 "parse.y"
    { chk_dialect ("function result variables without `=' are", GNU_PASCAL); ;}
    break;

  case 360:
#line 1278 "parse.y"
    { ((*yyvalp).ttype) = void_type_node; chk_dialect ("untyped parameters are", U_B_D_M_PASCAL); ;}
    break;

  case 361:
#line 1280 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 365:
#line 1291 "parse.y"
    { ((*yyvalp).ttype) = build_type_of ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 368:
#line 1301 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 369:
#line 1303 "parse.y"
    {
        defining_packed_type -= (((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.itype);
        PASCAL_TREE_PACKED ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype)) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.itype);
        ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype));
      ;}
    break;

  case 371:
#line 1313 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 372:
#line 1315 "parse.y"
    { error ("missing semicolon"); yyerrok; ;}
    break;

  case 374:
#line 1321 "parse.y"
    { TREE_TYPE ((((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 375:
#line 1326 "parse.y"
    { TREE_TYPE ((((*yyvalp).ttype) = build_tree_list (NULL_TREE, NULL_TREE))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 378:
#line 1338 "parse.y"
    { yyerrok; ;}
    break;

  case 380:
#line 1344 "parse.y"
    { yyerrok; ;}
    break;

  case 383:
#line 1351 "parse.y"
    { chk_dialect ("variable declarations in the statement part are", GNU_PASCAL); pushlevel_expand (1); ;}
    break;

  case 384:
#line 1353 "parse.y"
    { un_initialize_block ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0, 0); ;}
    break;

  case 386:
#line 1359 "parse.y"
    { ((*yyvalp).itype) = 0; ;}
    break;

  case 387:
#line 1361 "parse.y"
    { ((*yyvalp).itype) = 1; ;}
    break;

  case 389:
#line 1369 "parse.y"
    { mark_temporary_levels (); ;}
    break;

  case 390:
#line 1371 "parse.y"
    { release_temporary_levels (); ;}
    break;

  case 395:
#line 1386 "parse.y"
    { expand_call_statement ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 396:
#line 1388 "parse.y"
    { ((*yyvalp).itype) = allow_function_calls (!PASCAL_PROCEDURAL_TYPE (TREE_TYPE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)))); ;}
    break;

  case 397:
#line 1390 "parse.y"
    { expand_pascal_assignment ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); allow_function_calls ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 398:
#line 1392 "parse.y"
    { build_predef_call (p_Return, NULL_TREE); ;}
    break;

  case 399:
#line 1394 "parse.y"
    { build_predef_call (p_Return, build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 400:
#line 1396 "parse.y"
    { build_predef_call (p_Exit, NULL_TREE); ;}
    break;

  case 401:
#line 1398 "parse.y"
    { build_predef_call (p_Exit, build_tree_list (NULL_TREE, void_type_node)); ;}
    break;

  case 402:
#line 1400 "parse.y"
    { build_predef_call (p_Exit, build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 404:
#line 1403 "parse.y"
    { restore_identifiers ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 405:
#line 1405 "parse.y"
    { expand_end_cond (); ;}
    break;

  case 406:
#line 1407 "parse.y"
    { expand_start_else (); ;}
    break;

  case 407:
#line 1409 "parse.y"
    {
        if (!(((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype) && extra_warnings)
          warning ("empty statement after `else'");
        expand_end_cond ();
      ;}
    break;

  case 408:
#line 1415 "parse.y"
    { ((*yyvalp).ttype) = pascal_expand_start_case ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 409:
#line 1417 "parse.y"
    {
        if (!EM (current_case_values))
          {
            tree duplicate;
            int res = pushcase (NULL_TREE, NULL, build_decl (LABEL_DECL, NULL_TREE, NULL_TREE), &duplicate);
            gcc_assert (!res);
          }
      ;}
    break;

  case 410:
#line 1426 "parse.y"
    {
        if (!(((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype) && !(((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype))
          chk_dialect ("empty `case' statements are", MAC_PASCAL);
        expand_exit_something ();
        if (!EM (current_case_values))
          expand_end_case ((((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.ttype));
        current_case_values = (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype);
        yyerrok;
      ;}
    break;

  case 411:
#line 1436 "parse.y"
    { emit_nop (); expand_start_loop_continue_elsewhere (1); ;}
    break;

  case 412:
#line 1438 "parse.y"
    { LOCATION_NOTE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); expand_loop_continue_here (); ;}
    break;

  case 413:
#line 1440 "parse.y"
    { LOCATION_NOTE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); expand_exit_loop_if_false (0, build_pascal_unary_op (TRUTH_NOT_EXPR, check_boolean ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)))); ;}
    break;

  case 414:
#line 1442 "parse.y"
    { expand_end_loop (); ;}
    break;

  case 415:
#line 1444 "parse.y"
    { expand_start_loop (1); ;}
    break;

  case 416:
#line 1446 "parse.y"
    { LOCATION_NOTE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); expand_exit_loop_if_false (0, check_boolean ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 417:
#line 1448 "parse.y"
    { expand_end_loop (); ;}
    break;

  case 418:
#line 1450 "parse.y"
    { ((*yyvalp).ttype) = start_for_loop ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code)); ;}
    break;

  case 419:
#line 1452 "parse.y"
    { LOCATION_NOTE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yyloc)); finish_for_loop ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.code)); ;}
    break;

  case 420:
#line 1454 "parse.y"
    { ((*yyvalp).ttype) = start_for_set_loop ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 421:
#line 1456 "parse.y"
    { LOCATION_NOTE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yyloc)); finish_for_set_loop ((((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 422:
#line 1458 "parse.y"
    { pascal_expand_goto ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 423:
#line 1463 "parse.y"
    { set_label ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 425:
#line 1469 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 426:
#line 1471 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 427:
#line 1473 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 428:
#line 1475 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 429:
#line 1480 "parse.y"
    { ((*yyvalp).ttype) = pascal_shadow_record_fields ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 430:
#line 1482 "parse.y"
    { ((*yyvalp).ttype) = pascal_shadow_record_fields ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 431:
#line 1487 "parse.y"
    { expand_start_cond (check_boolean ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)), 0); ;}
    break;

  case 432:
#line 1489 "parse.y"
    {
        if (!(((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype) && extra_warnings)
          warning ("empty statement after `then'");
      ;}
    break;

  case 433:
#line 1497 "parse.y"
    {
        /* Create an implicit `otherwise' (in the rule above) to avoid warnings
           about unhandled cases. In ISO Pascal, this is a run-time error. */
        if (co->case_value_checking)
          build_predef_call (p_CaseNoMatchError, NULL_TREE);
        ((*yyvalp).itype) = 0;
      ;}
    break;

  case 434:
#line 1505 "parse.y"
    { ((*yyvalp).itype) = 1; ;}
    break;

  case 435:
#line 1510 "parse.y"
    { chk_dialect ("`else' in `case' statements is", B_D_M_PASCAL); ;}
    break;

  case 437:
#line 1516 "parse.y"
    { ((*yyvalp).itype) = 0; ;}
    break;

  case 438:
#line 1518 "parse.y"
    { ((*yyvalp).itype) = 1; ;}
    break;

  case 440:
#line 1524 "parse.y"
    { yyerrok; ;}
    break;

  case 441:
#line 1526 "parse.y"
    { error ("case element expected"); ;}
    break;

  case 442:
#line 1528 "parse.y"
    { error ("missing semicolon"); yyerrok; ;}
    break;

  case 443:
#line 1530 "parse.y"
    { error ("extra semicolon"); ;}
    break;

  case 444:
#line 1535 "parse.y"
    { pascal_pushcase ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 445:
#line 1537 "parse.y"
    { expand_exit_something (); ;}
    break;

  case 447:
#line 1543 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 448:
#line 1545 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 449:
#line 1547 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 451:
#line 1553 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 452:
#line 1555 "parse.y"
    { chk_dialect ("`case' ranges are", NOT_CLASSIC_PASCAL); ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 453:
#line 1557 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); error ("missing `..'"); yyerrok; ;}
    break;

  case 454:
#line 1559 "parse.y"
    { error ("extra `..'"); ((*yyvalp).ttype) = build_tree_list (NULL_TREE, string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), 0)); ;}
    break;

  case 455:
#line 1564 "parse.y"
    { ((*yyvalp).code) = LE_EXPR; ;}
    break;

  case 456:
#line 1566 "parse.y"
    { ((*yyvalp).code) = GE_EXPR; ;}
    break;

  case 457:
#line 1568 "parse.y"
    { error ("missing `to' or `downto'"); ((*yyvalp).code) = LE_EXPR; ;}
    break;

  case 459:
#line 1574 "parse.y"
    { ((*yyvalp).ttype) = build_pascal_lvalue_address_expression ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 461:
#line 1580 "parse.y"
    { error ("using `=' instead of `:=' in assignment"); ;}
    break;

  case 462:
#line 1585 "parse.y"
    { build_predef_call ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.itype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 463:
#line 1587 "parse.y"
    { build_predef_call (IDENTIFIER_BUILT_IN_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))->symbol, NULL_TREE); ;}
    break;

  case 464:
#line 1589 "parse.y"
    { build_predef_call (IDENTIFIER_BUILT_IN_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype))->symbol, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 465:
#line 1591 "parse.y"
    { build_new_dispose (p_Dispose, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE, NULL_TREE); ;}
    break;

  case 466:
#line 1593 "parse.y"
    { build_new_dispose (p_Dispose, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 467:
#line 1595 "parse.y"
    { build_new_dispose (p_Dispose, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 468:
#line 1597 "parse.y"
    { pascal_expand_asm_operands ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE, NULL_TREE, NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 469:
#line 1599 "parse.y"
    { pascal_expand_asm_operands ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE, NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 470:
#line 1601 "parse.y"
    { pascal_expand_asm_operands ((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 471:
#line 1603 "parse.y"
    { pascal_expand_asm_operands ((((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-9)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 472:
#line 1608 "parse.y"
    { ((*yyvalp).itype) = 0; ;}
    break;

  case 473:
#line 1610 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_volatile); ((*yyvalp).itype) = 1; ;}
    break;

  case 477:
#line 1621 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 478:
#line 1626 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 479:
#line 1631 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 480:
#line 1633 "parse.y"
    { ((*yyvalp).ttype) = tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 481:
#line 1640 "parse.y"
    {
        ((*yyvalp).ttype) = string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0);
        if (PEDANTIC (NOT_CLASSIC_PASCAL)
            && (TREE_CODE_CLASS (TREE_CODE (((*yyvalp).ttype))) != 'c'
                || TREE_CODE (((*yyvalp).ttype)) == STRING_CST
                || !PASCAL_CST_FRESH (((*yyvalp).ttype))
                || PASCAL_CST_PARENTHESES (((*yyvalp).ttype))))
          error ("ISO 7185 Pascal allows only simple constants");
      ;}
    break;

  case 482:
#line 1653 "parse.y"
    { ((*yyvalp).ttype) = fold ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 483:
#line 1655 "parse.y"
    { ((*yyvalp).ttype) = fold (parser_build_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 485:
#line 1661 "parse.y"
    { ((*yyvalp).ttype) = build_pascal_unary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 486:
#line 1663 "parse.y"
    { ((*yyvalp).ttype) = parser_build_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 487:
#line 1665 "parse.y"
    { ((*yyvalp).ttype) = build_operator_call ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1); ;}
    break;

  case 488:
#line 1667 "parse.y"
    { ((*yyvalp).ttype) = start_boolean_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 489:
#line 1669 "parse.y"
    { if ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)) LOCATION_NOTE (COPYLOC ((*yylocp), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc))); ((*yyvalp).ttype) = finish_boolean_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 491:
#line 1675 "parse.y"
    { ((*yyvalp).ttype) = parser_build_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 492:
#line 1677 "parse.y"
    { ((*yyvalp).ttype) = build_operator_call ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1); ;}
    break;

  case 493:
#line 1679 "parse.y"
    { ((*yyvalp).ttype) = start_boolean_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 494:
#line 1681 "parse.y"
    { if ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)) LOCATION_NOTE (COPYLOC ((*yylocp), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc))); ((*yyvalp).ttype) = finish_boolean_binary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 496:
#line 1687 "parse.y"
    { ((*yyvalp).ttype) = build_operator_call ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 0); ;}
    break;

  case 497:
#line 1689 "parse.y"
    { ((*yyvalp).ttype) = parser_build_binary_op (POW_EXPR, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 498:
#line 1691 "parse.y"
    { ((*yyvalp).ttype) = parser_build_binary_op (POWER_EXPR, (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 499:
#line 1693 "parse.y"
    { ((*yyvalp).ttype) = build_is_as ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), p_is); ;}
    break;

  case 500:
#line 1695 "parse.y"
    { ((*yyvalp).ttype) = build_is_as ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), p_as); ;}
    break;

  case 501:
#line 1700 "parse.y"
    { ((*yyvalp).ttype) = set_exp_original_code (build_pascal_unary_op ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.code)); ;}
    break;

  case 502:
#line 1702 "parse.y"
    { chk_dialect ("the address operator is", B_D_M_PASCAL); ((*yyvalp).ttype) = build_pascal_address_expression ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), !co->typed_address); ;}
    break;

  case 505:
#line 1706 "parse.y"
    { ((*yyvalp).ttype) = null_pointer_node; ;}
    break;

  case 507:
#line 1709 "parse.y"
    { ((*yyvalp).ttype) = build_variable_or_routine_access ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 513:
#line 1725 "parse.y"
    { ((*yyvalp).ttype) = combine_strings ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1); ;}
    break;

  case 514:
#line 1730 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 515:
#line 1732 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 518:
#line 1739 "parse.y"
    { ((*yyvalp).ttype) = build_caret_string_constant ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 537:
#line 1750 "parse.y"
    {
        if (PASCAL_TYPE_UNDISCRIMINATED_STRING (((*yyvalp).ttype)))
          {
            if (!(co->pascal_dialect & B_D_M_PASCAL))
              error_or_warning (co->pascal_dialect & E_O_PASCAL, "missing string capacity -- assuming 255");
            ((*yyvalp).ttype) = string255_type_node;
          }
      ;}
    break;

  case 538:
#line 1762 "parse.y"
    {
        tree decl = lookup_name ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype));
        ((*yyvalp).ttype) = error_mark_node;
        if (!decl)
          error ("unknown identifier `%s'", IDENTIFIER_NAME ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)));
        else if (TREE_CODE (decl) != TYPE_DECL)
          error ("type name expected, `%s' given", IDENTIFIER_NAME ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)));
        else
          ((*yyvalp).ttype) = TREE_TYPE (decl);
      ;}
    break;

  case 540:
#line 1777 "parse.y"
    { ((*yyvalp).ttype) = build_qualified_id ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 541:
#line 1782 "parse.y"
    { ((*yyvalp).ttype) = build_predef_call (IDENTIFIER_BUILT_IN_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))->symbol, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 544:
#line 1789 "parse.y"
    { ((*yyvalp).ttype) = TYPE_NAME ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 545:
#line 1791 "parse.y"
    { ((*yyvalp).ttype) = set_exp_original_code ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NOP_EXPR); ;}
    break;

  case 546:
#line 1793 "parse.y"
    { ((*yyvalp).ttype) = build_qualified_or_component_access ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 547:
#line 1795 "parse.y"
    { ((*yyvalp).ttype) = build_pascal_pointer_reference ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 548:
#line 1797 "parse.y"
    { ((*yyvalp).ttype) = build_array_ref_or_constructor ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 549:
#line 1799 "parse.y"
    { ((*yyvalp).ttype) = build_iso_constructor ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 550:
#line 1801 "parse.y"
    { chk_dialect ("empty parentheses are", BORLAND_DELPHI | MAC_PASCAL); ((*yyvalp).ttype) = build_call_or_cast ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 551:
#line 1803 "parse.y"
    { allow_function_calls ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.itype)); ((*yyvalp).ttype) = build_call_or_cast ((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 552:
#line 1805 "parse.y"
    { ((*yyvalp).ttype) = build_inherited_method ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 553:
#line 1807 "parse.y"
    { ((*yyvalp).ttype) = build_predef_call (p_FormatString, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 554:
#line 1809 "parse.y"
    { ((*yyvalp).ttype) = build_predef_call (p_Assigned, build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); allow_function_calls ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype)); ;}
    break;

  case 555:
#line 1811 "parse.y"
    { ((*yyvalp).ttype) = build_pascal_address_expression ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), co->pascal_dialect & B_D_M_PASCAL); ;}
    break;

  case 556:
#line 1813 "parse.y"
    { ((*yyvalp).ttype) = build_new_dispose (p_New, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype), NULL_TREE, NULL_TREE); ;}
    break;

  case 557:
#line 1815 "parse.y"
    { ((*yyvalp).ttype) = build_new_dispose (p_New, (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.ttype), NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 558:
#line 1817 "parse.y"
    { ((*yyvalp).ttype) = build_new_dispose (p_New, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 560:
#line 1823 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype); allow_function_calls ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype)); yyerrok; ;}
    break;

  case 561:
#line 1825 "parse.y"
    {
        ((*yyvalp).ttype) = build_tree_list (NULL_TREE, TREE_CODE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)) == TYPE_DECL ? (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype) : build_variable_or_routine_access ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)));
        allow_function_calls ((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.itype));
        yyerrok;
      ;}
    break;

  case 562:
#line 1833 "parse.y"
    { ((*yyvalp).itype) = allow_function_calls (0); ;}
    break;

  case 563:
#line 1838 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 564:
#line 1840 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))); yyerrok; ;}
    break;

  case 565:
#line 1842 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, error_mark_node); ;}
    break;

  case 566:
#line 1844 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, error_mark_node); error ("extra comma"); ;}
    break;

  case 568:
#line 1850 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 569:
#line 1852 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 570:
#line 1854 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 571:
#line 1860 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 572:
#line 1862 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 573:
#line 1864 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 574:
#line 1869 "parse.y"
    { chk_dialect ("untyped files are", U_B_D_M_PASCAL); ((*yyvalp).ttype) = untyped_file_type_node; ;}
    break;

  case 576:
#line 1875 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 577:
#line 1877 "parse.y"
    { TREE_CHAIN ((((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 581:
#line 1885 "parse.y"
    { TREE_CHAIN ((((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 582:
#line 1890 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 583:
#line 1892 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 584:
#line 1897 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), build_tree_list (build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.ttype)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 585:
#line 1899 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), build_tree_list (build_tree_list (NULL_TREE, integer_zero_node), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 586:
#line 1904 "parse.y"
    { ((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 587:
#line 1909 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (build_tree_list (NULL_TREE, NULL_TREE), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 588:
#line 1914 "parse.y"
    { ((*yyvalp).ttype) = maybe_schema_discriminant ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 589:
#line 1916 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 590:
#line 1918 "parse.y"
    { PASCAL_BP_INITIALIZER_LIST ((((*yyvalp).ttype) = nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)))) = 1; ;}
    break;

  case 591:
#line 1920 "parse.y"
    { chk_dialect ("constructors in `[]' are", E_O_PASCAL); ((*yyvalp).ttype) = nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 592:
#line 1922 "parse.y"
    { error ("invalid component value"); ((*yyvalp).ttype) = error_mark_node; ;}
    break;

  case 594:
#line 1928 "parse.y"
    { TREE_CHAIN ((((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); ;}
    break;

  case 595:
#line 1930 "parse.y"
    { TREE_CHAIN ((((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); error ("missing separator"); ;}
    break;

  case 597:
#line 1936 "parse.y"
    { chk_dialect ("initializers separated with `,' are", B_D_M_PASCAL); ;}
    break;

  case 598:
#line 1941 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 599:
#line 1943 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 601:
#line 1949 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); yyerrok; ;}
    break;

  case 602:
#line 1951 "parse.y"
    { error ("missing index expression"); ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 603:
#line 1953 "parse.y"
    { ((*yyvalp).ttype) = chainon ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); error ("missing comma"); yyerrok; ;}
    break;

  case 604:
#line 1955 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 605:
#line 1960 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 606:
#line 1962 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1), NULL_TREE); ;}
    break;

  case 607:
#line 1964 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), 1), string_may_be_char ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), 1)); ;}
    break;

  case 608:
#line 1969 "parse.y"
    { ((*yyvalp).ttype) = build_set_constructor (NULL_TREE); ;}
    break;

  case 609:
#line 1971 "parse.y"
    { ((*yyvalp).ttype) = build_set_constructor (nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ttype))); ;}
    break;

  case 611:
#line 1977 "parse.y"
    { TREE_CHAIN ((((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); yyerrok; ;}
    break;

  case 612:
#line 1979 "parse.y"
    { TREE_CHAIN ((((*yyvalp).ttype) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype); error ("missing comma"); yyerrok; ;}
    break;

  case 613:
#line 1981 "parse.y"
    { error ("extra comma"); ;}
    break;

  case 614:
#line 1986 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), NULL_TREE); ;}
    break;

  case 615:
#line 1988 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 616:
#line 1994 "parse.y"
    { ((*yyvalp).code) = CONVERT_EXPR; ;}
    break;

  case 617:
#line 1995 "parse.y"
    { ((*yyvalp).code) = NEGATE_EXPR; ;}
    break;

  case 618:
#line 1999 "parse.y"
    { ((*yyvalp).code) = CONVERT_EXPR; ;}
    break;

  case 619:
#line 2000 "parse.y"
    { ((*yyvalp).code) = NEGATE_EXPR; ;}
    break;

  case 620:
#line 2001 "parse.y"
    { ((*yyvalp).code) = TRUTH_NOT_EXPR; ;}
    break;

  case 621:
#line 2005 "parse.y"
    { ((*yyvalp).code) = NE_EXPR; ;}
    break;

  case 622:
#line 2006 "parse.y"
    { ((*yyvalp).code) = LE_EXPR; ;}
    break;

  case 623:
#line 2007 "parse.y"
    { ((*yyvalp).code) = GE_EXPR; ;}
    break;

  case 624:
#line 2008 "parse.y"
    { ((*yyvalp).code) = EQ_EXPR; ;}
    break;

  case 625:
#line 2009 "parse.y"
    { ((*yyvalp).code) = LT_EXPR; ;}
    break;

  case 626:
#line 2010 "parse.y"
    { ((*yyvalp).code) = GT_EXPR; ;}
    break;

  case 627:
#line 2011 "parse.y"
    { ((*yyvalp).code) = IN_EXPR; ;}
    break;

  case 628:
#line 2015 "parse.y"
    { ((*yyvalp).code) = PLUS_EXPR; ;}
    break;

  case 629:
#line 2016 "parse.y"
    { ((*yyvalp).code) = PLUS_EXPR; ;}
    break;

  case 630:
#line 2017 "parse.y"
    { ((*yyvalp).code) = MINUS_EXPR; ;}
    break;

  case 631:
#line 2018 "parse.y"
    { ((*yyvalp).code) = MINUS_EXPR; ;}
    break;

  case 632:
#line 2019 "parse.y"
    { ((*yyvalp).code) = TRUTH_XOR_EXPR; ;}
    break;

  case 633:
#line 2020 "parse.y"
    { ((*yyvalp).code) = SYMDIFF_EXPR; ;}
    break;

  case 634:
#line 2024 "parse.y"
    { ((*yyvalp).code) = MULT_EXPR; ;}
    break;

  case 635:
#line 2025 "parse.y"
    { ((*yyvalp).code) = RDIV_EXPR; ;}
    break;

  case 636:
#line 2026 "parse.y"
    { ((*yyvalp).code) = TRUNC_DIV_EXPR; ;}
    break;

  case 637:
#line 2027 "parse.y"
    { ((*yyvalp).code) = (co->pascal_dialect & B_D_M_PASCAL) ? TRUNC_MOD_EXPR : FLOOR_MOD_EXPR; ;}
    break;

  case 638:
#line 2028 "parse.y"
    { ((*yyvalp).code) = LSHIFT_EXPR; ;}
    break;

  case 639:
#line 2029 "parse.y"
    { ((*yyvalp).code) = RSHIFT_EXPR; ;}
    break;

  case 640:
#line 2033 "parse.y"
    { ((*yyvalp).code) = TRUTH_OR_EXPR; ;}
    break;

  case 641:
#line 2034 "parse.y"
    { ((*yyvalp).code) = TRUTH_ORIF_EXPR; chk_dialect ("`or else' (without underscore) is", GNU_PASCAL); ;}
    break;

  case 642:
#line 2035 "parse.y"
    { ((*yyvalp).code) = TRUTH_ORIF_EXPR; ;}
    break;

  case 643:
#line 2036 "parse.y"
    { ((*yyvalp).code) = TRUTH_ORIF_EXPR; chk_dialect ("`|' is", MAC_PASCAL); ;}
    break;

  case 644:
#line 2040 "parse.y"
    { ((*yyvalp).code) = TRUTH_AND_EXPR; ;}
    break;

  case 645:
#line 2041 "parse.y"
    { ((*yyvalp).code) = TRUTH_ANDIF_EXPR; chk_dialect ("`and then' (without underscore) is", GNU_PASCAL); ;}
    break;

  case 646:
#line 2042 "parse.y"
    { ((*yyvalp).code) = TRUTH_ANDIF_EXPR; ;}
    break;

  case 647:
#line 2043 "parse.y"
    { ((*yyvalp).code) = TRUTH_ANDIF_EXPR; chk_dialect ("`&' is", MAC_PASCAL); ;}
    break;

  case 648:
#line 2048 "parse.y"
    { ((*yyvalp).itype) = IDENTIFIER_BUILT_IN_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype))->symbol; ;}
    break;

  case 649:
#line 2050 "parse.y"
    { ((*yyvalp).itype) = p_and; ;}
    break;

  case 650:
#line 2051 "parse.y"
    { ((*yyvalp).itype) = p_or; ;}
    break;

  case 651:
#line 2052 "parse.y"
    { ((*yyvalp).itype) = p_not; ;}
    break;

  case 652:
#line 2053 "parse.y"
    { ((*yyvalp).itype) = p_xor; ;}
    break;

  case 653:
#line 2054 "parse.y"
    { ((*yyvalp).itype) = p_shl; ;}
    break;

  case 654:
#line 2055 "parse.y"
    { ((*yyvalp).itype) = p_shr; ;}
    break;

  case 655:
#line 2061 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("BPlus", "+"); ;}
    break;

  case 656:
#line 2062 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("BPlus", "+"); ;}
    break;

  case 657:
#line 2063 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("BMinus", "-"); ;}
    break;

  case 658:
#line 2064 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("BMinus", "-"); ;}
    break;

  case 659:
#line 2065 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("BMult", "*"); ;}
    break;

  case 660:
#line 2066 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("RDiv", "/"); ;}
    break;

  case 661:
#line 2067 "parse.y"
    { ((*yyvalp).ttype) = get_identifier ("Div"); ;}
    break;

  case 662:
#line 2068 "parse.y"
    { ((*yyvalp).ttype) = get_identifier ("Mod"); ;}
    break;

  case 663:
#line 2069 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("RPower", "**"); ;}
    break;

  case 664:
#line 2070 "parse.y"
    { ((*yyvalp).ttype) = get_identifier ("In"); ;}
    break;

  case 665:
#line 2071 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("LT", "<"); ;}
    break;

  case 666:
#line 2072 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("EQ", "="); ;}
    break;

  case 667:
#line 2073 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("GT", ">"); ;}
    break;

  case 668:
#line 2074 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("NE", "<>"); ;}
    break;

  case 669:
#line 2075 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("GE", ">="); ;}
    break;

  case 670:
#line 2076 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("LE", "<="); ;}
    break;

  case 671:
#line 2077 "parse.y"
    { ((*yyvalp).ttype) = get_identifier ("And"); ;}
    break;

  case 672:
#line 2078 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("SAnd", "&"); ;}
    break;

  case 673:
#line 2079 "parse.y"
    { ((*yyvalp).ttype) = get_identifier ("Or"); ;}
    break;

  case 674:
#line 2080 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("SOr", "|"); ;}
    break;

  case 675:
#line 2081 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("SymDiff", "<>"); ;}
    break;

  case 678:
#line 2087 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("CeilPlus", "+>"); ;}
    break;

  case 679:
#line 2088 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("CeilMinus", "->"); ;}
    break;

  case 680:
#line 2089 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("FloorPlus", "+<"); ;}
    break;

  case 681:
#line 2090 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("FloorMinus", "-<"); ;}
    break;

  case 682:
#line 2094 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("CeilMult", "*>"); ;}
    break;

  case 683:
#line 2095 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("CeilRDiv", "/>"); ;}
    break;

  case 684:
#line 2096 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("FloorMult", "*<"); ;}
    break;

  case 685:
#line 2097 "parse.y"
    { ((*yyvalp).ttype) = get_identifier_with_spelling ("FloorRDiv", "/<"); ;}
    break;

  case 688:
#line 2109 "parse.y"
    { ((*yyvalp).ttype) = numeric_label ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 689:
#line 2114 "parse.y"
    { ((*yyvalp).ttype) = nreverse ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 690:
#line 2119 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 691:
#line 2121 "parse.y"
    { ((*yyvalp).ttype) = tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 692:
#line 2123 "parse.y"
    {
        ((*yyvalp).ttype) = tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype));
        error ("comma missing after `%s'", IDENTIFIER_NAME (TREE_VALUE ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype))));
        yyerrok;
      ;}
    break;

  case 693:
#line 2129 "parse.y"
    { error ("extra comma following identifier list"); ;}
    break;

  case 695:
#line 2135 "parse.y"
    { ((*yyvalp).ttype) = build_tree_list (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 696:
#line 2137 "parse.y"
    { ((*yyvalp).ttype) = tree_cons (NULL_TREE, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 698:
#line 2143 "parse.y"
    { ((*yyvalp).ttype) = build_qualified_id ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 699:
#line 2148 "parse.y"
    { warn_about_keyword_redeclaration (((*yyvalp).ttype), 1); ;}
    break;

  case 745:
#line 2201 "parse.y"
    { ((*yyvalp).ttype) = check_identifier ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype)); ;}
    break;

  case 751:
#line 2214 "parse.y"
    { char c = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.itype); ((*yyvalp).ttype) = make_identifier (&c, 1); ;}
    break;

  case 752:
#line 2221 "parse.y"
    { pushlevel_expand (0); ;}
    break;

  case 753:
#line 2226 "parse.y"
    { poplevel_expand (0, 1); ;}
    break;

  case 754:
#line 2231 "parse.y"
    { lex_const_equal = 0; ;}
    break;

  case 755:
#line 2236 "parse.y"
    { defining_packed_type += ((*yyvalp).itype) = !co->ignore_packed;  /* can be nested */ ;}
    break;

  case 756:
#line 2241 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_protected); ;}
    break;

  case 757:
#line 2246 "parse.y"
    { ASSERT_ID ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ttype), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc), p_module); ;}
    break;

  case 758:
#line 2251 "parse.y"
    { yyerrok; ;}
    break;

  case 759:
#line 2253 "parse.y"
    { yyerrok; ;}
    break;

  case 766:
#line 2270 "parse.y"
    { warning ("missing `.' at the end of program/unit/module"); ;}
    break;

  case 767:
#line 2275 "parse.y"
    { ((*yyvalp).ttype) = NULL_TREE; ;}
    break;

  case 768:
#line 2280 "parse.y"
    { ((*yyvalp).ttype) = error_mark_node; ;}
    break;


    }

  return yyok;
# undef yyerrok
# undef YYABORT
# undef YYACCEPT
# undef YYERROR
# undef YYBACKUP
# undef yyclearin
# undef YYRECOVERING
/* Line 750 of glr.c.  */
#line 7411 "parse.c"
}


static void
yyuserMerge (int yyn, YYSTYPE* yy0, YYSTYPE* yy1)
{
  /* `Use' the arguments.  */
  (void) yy0;
  (void) yy1;

  switch (yyn)
    {
      
    }
}

			      /* Bison grammar-table manipulation.  */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;
  (void) yylocationp;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}

/** Number of symbols composing the right hand side of rule #RULE. */
static inline int
yyrhsLength (yyRuleNum yyrule)
{
  return yyr2[yyrule];
}

/** Left-hand-side symbol for rule #RULE. */
static inline yySymbol
yylhsNonterm (yyRuleNum yyrule)
{
  return yyr1[yyrule];
}

#define yyis_pact_ninf(yystate) \
  ((yystate) == YYPACT_NINF)

/** True iff LR state STATE has only a default reduction (regardless
 *  of token). */
static inline yybool
yyisDefaultedState (yyStateNum yystate)
{
  return yyis_pact_ninf (yypact[yystate]);
}

/** The default reduction for STATE, assuming it has one. */
static inline yyRuleNum
yydefaultAction (yyStateNum yystate)
{
  return yydefact[yystate];
}

#define yyis_table_ninf(yytable_value) \
  0

/** Set *YYACTION to the action to take in YYSTATE on seeing YYTOKEN.
 *  Result R means
 *    R < 0:  Reduce on rule -R.
 *    R = 0:  Error.
 *    R > 0:  Shift to state R.
 *  Set *CONFLICTS to a pointer into yyconfl to 0-terminated list of
 *  conflicting reductions.
 */
static inline void
yygetLRActions (yyStateNum yystate, int yytoken,
	        int* yyaction, const short int** yyconflicts)
{
  int yyindex = yypact[yystate] + yytoken;
  if (yyindex < 0 || YYLAST < yyindex || yycheck[yyindex] != yytoken)
    {
      *yyaction = -yydefact[yystate];
      *yyconflicts = yyconfl;
    }
  else if (! yyis_table_ninf (yytable[yyindex]))
    {
      *yyaction = yytable[yyindex];
      *yyconflicts = yyconfl + yyconflp[yyindex];
    }
  else
    {
      *yyaction = 0;
      *yyconflicts = yyconfl + yyconflp[yyindex];
    }
}

static inline yyStateNum
yyLRgotoState (yyStateNum yystate, yySymbol yylhs)
{
  int yyr;
  yyr = yypgoto[yylhs - YYNTOKENS] + yystate;
  if (0 <= yyr && yyr <= YYLAST && yycheck[yyr] == yystate)
    return yytable[yyr];
  else
    return yydefgoto[yylhs - YYNTOKENS];
}

static inline yybool
yyisShiftAction (int yyaction)
{
  return 0 < yyaction;
}

static inline yybool
yyisErrorAction (int yyaction)
{
  return yyaction == 0;
}

				/* GLRStates */

static void
yyaddDeferredAction (yyGLRStack* yystack, yyGLRState* yystate,
		     yyGLRState* rhs, yyRuleNum yyrule)
{
  yySemanticOption* yynewItem;
  yynewItem = &yystack->yynextFree->yyoption;
  yystack->yyspaceLeft -= 1;
  yystack->yynextFree += 1;
  yynewItem->yyisState = yyfalse;
  yynewItem->yystate = rhs;
  yynewItem->yyrule = yyrule;
  yynewItem->yynext = yystate->yysemantics.yyfirstVal;
  yystate->yysemantics.yyfirstVal = yynewItem;
  if (yystack->yyspaceLeft < YYHEADROOM)
    yyexpandGLRStack (yystack);
}

				/* GLRStacks */

/** Initialize SET to a singleton set containing an empty stack. */
static void
yyinitStateSet (yyGLRStateSet* yyset)
{
  yyset->yysize = 1;
  yyset->yycapacity = 16;
  yyset->yystates = (yyGLRState**) YYMALLOC (16 * sizeof yyset->yystates[0]);
  yyset->yystates[0] = NULL;
}

static void yyfreeStateSet (yyGLRStateSet* yyset)
{
  YYFREE (yyset->yystates);
}

/** Initialize STACK to a single empty stack, with total maximum
 *  capacity for all stacks of SIZE. */
static void
yyinitGLRStack (yyGLRStack* yystack, size_t yysize)
{
  yystack->yyerrflag = 0;
  yystack->yyerrState = 0;
  yynerrs = 0;
  yystack->yyspaceLeft = yysize;
  yystack->yynextFree = yystack->yyitems =
    (yyGLRStackItem*) YYMALLOC (yysize * sizeof yystack->yynextFree[0]);
  yystack->yysplitPoint = NULL;
  yystack->yylastDeleted = NULL;
  yyinitStateSet (&yystack->yytops);
}

#define YYRELOC(YYFROMITEMS,YYTOITEMS,YYX,YYTYPE) \
  &((YYTOITEMS) - ((YYFROMITEMS) - (yyGLRStackItem*) (YYX)))->YYTYPE

/** If STACK is expandable, extend it.  WARNING: Pointers into the
    stack from outside should be considered invalid after this call.
    We always expand when there are 1 or fewer items left AFTER an
    allocation, so that we can avoid having external pointers exist
    across an allocation. */
static void
yyexpandGLRStack (yyGLRStack* yystack)
{
#if YYSTACKEXPANDABLE
  yyGLRStack yynewStack;
  yyGLRStackItem* yyp0, *yyp1;
  size_t yysize, yynewSize;
  size_t yyn;
  yysize = yystack->yynextFree - yystack->yyitems;
  if (YYMAXDEPTH <= yysize)
    yyFail (yystack, "parser stack overflow");
  yynewSize = 2*yysize;
  if (YYMAXDEPTH < yynewSize)
    yynewSize = YYMAXDEPTH;
  yyinitGLRStack (&yynewStack, yynewSize);
  for (yyp0 = yystack->yyitems, yyp1 = yynewStack.yyitems, yyn = yysize;
       0 < yyn;
       yyn -= 1, yyp0 += 1, yyp1 += 1)
    {
      *yyp1 = *yyp0;
      if (*(yybool *) yyp0)
	{
	  yyGLRState* yys0 = &yyp0->yystate;
	  yyGLRState* yys1 = &yyp1->yystate;
	  if (yys0->yypred != NULL)
	    yys1->yypred =
	      YYRELOC (yyp0, yyp1, yys0->yypred, yystate);
	  if (! yys0->yyresolved && yys0->yysemantics.yyfirstVal != NULL)
	    yys1->yysemantics.yyfirstVal =
	      YYRELOC(yyp0, yyp1, yys0->yysemantics.yyfirstVal, yyoption);
	}
      else
	{
	  yySemanticOption* yyv0 = &yyp0->yyoption;
	  yySemanticOption* yyv1 = &yyp1->yyoption;
	  if (yyv0->yystate != NULL)
	    yyv1->yystate = YYRELOC (yyp0, yyp1, yyv0->yystate, yystate);
	  if (yyv0->yynext != NULL)
	    yyv1->yynext = YYRELOC (yyp0, yyp1, yyv0->yynext, yyoption);
	}
    }
  if (yystack->yysplitPoint != NULL)
    yystack->yysplitPoint = YYRELOC (yystack->yyitems, yynewStack.yyitems,
				 yystack->yysplitPoint, yystate);

  for (yyn = 0; yyn < yystack->yytops.yysize; yyn += 1)
    if (yystack->yytops.yystates[yyn] != NULL)
      yystack->yytops.yystates[yyn] =
	YYRELOC (yystack->yyitems, yynewStack.yyitems,
		 yystack->yytops.yystates[yyn], yystate);
  YYFREE (yystack->yyitems);
  yystack->yyitems = yynewStack.yyitems;
  yystack->yynextFree = yynewStack.yynextFree + yysize;
  yystack->yyspaceLeft = yynewStack.yyspaceLeft - yysize;

#else

  yyFail (yystack, "parser stack overflow");
#endif
}

static void
yyfreeGLRStack (yyGLRStack* yystack)
{
  YYFREE (yystack->yyitems);
  yyfreeStateSet (&yystack->yytops);
}

/** Assuming that S is a GLRState somewhere on STACK, update the
 *  splitpoint of STACK, if needed, so that it is at least as deep as
 *  S. */
static inline void
yyupdateSplit (yyGLRStack* yystack, yyGLRState* yys)
{
  if (yystack->yysplitPoint != NULL && yystack->yysplitPoint > yys)
    yystack->yysplitPoint = yys;
}

/** Invalidate stack #K in STACK. */
static inline void
yymarkStackDeleted (yyGLRStack* yystack, int yyk)
{
  if (yystack->yytops.yystates[yyk] != NULL)
    yystack->yylastDeleted = yystack->yytops.yystates[yyk];
  yystack->yytops.yystates[yyk] = NULL;
}

/** Undelete the last stack that was marked as deleted.  Can only be
    done once after a deletion, and only when all other stacks have
    been deleted. */
static void
yyundeleteLastStack (yyGLRStack* yystack)
{
  if (yystack->yylastDeleted == NULL || yystack->yytops.yysize != 0)
    return;
  yystack->yytops.yystates[0] = yystack->yylastDeleted;
  yystack->yytops.yysize = 1;
  YYDPRINTF ((stderr, "Restoring last deleted stack as stack #0.\n"));
  yystack->yylastDeleted = NULL;
}

static inline void
yyremoveDeletes (yyGLRStack* yystack)
{
  size_t yyi, yyj;
  yyi = yyj = 0;
  while (yyj < yystack->yytops.yysize)
    {
      if (yystack->yytops.yystates[yyi] == NULL)
	{
	  if (yyi == yyj)
	    {
	      YYDPRINTF ((stderr, "Removing dead stacks.\n"));
	    }
	  yystack->yytops.yysize -= 1;
	}
      else
	{
	  yystack->yytops.yystates[yyj] = yystack->yytops.yystates[yyi];
	  if (yyj != yyi)
	    {
	      YYDPRINTF ((stderr, "Rename stack %lu -> %lu.\n",
			  (unsigned long int) yyi, (unsigned long int) yyj));
	    }
	  yyj += 1;
	}
      yyi += 1;
    }
}

/** Shift to a new state on stack #K of STACK, corresponding to LR state
 * LRSTATE, at input position POSN, with (resolved) semantic value SVAL. */
static inline void
yyglrShift (yyGLRStack* yystack, int yyk, yyStateNum yylrState, size_t yyposn,
	    YYSTYPE yysval, YYLTYPE* yylocp)
{
  yyGLRStackItem* yynewItem;

  yynewItem = yystack->yynextFree;
  yystack->yynextFree += 1;
  yystack->yyspaceLeft -= 1;
  yynewItem->yystate.yyisState = yytrue;
  yynewItem->yystate.yylrState = yylrState;
  yynewItem->yystate.yyposn = yyposn;
  yynewItem->yystate.yyresolved = yytrue;
  yynewItem->yystate.yypred = yystack->yytops.yystates[yyk];
  yystack->yytops.yystates[yyk] = &yynewItem->yystate;
  yynewItem->yystate.yysemantics.yysval = yysval;
  yynewItem->yystate.yyloc = *yylocp;
  if (yystack->yyspaceLeft < YYHEADROOM)
    yyexpandGLRStack (yystack);
}

/** Shift stack #K of YYSTACK, to a new state corresponding to LR
 *  state YYLRSTATE, at input position YYPOSN, with the (unresolved)
 *  semantic value of YYRHS under the action for YYRULE. */
static inline void
yyglrShiftDefer (yyGLRStack* yystack, int yyk, yyStateNum yylrState,
		 size_t yyposn, yyGLRState* rhs, yyRuleNum yyrule)
{
  yyGLRStackItem* yynewItem;

  yynewItem = yystack->yynextFree;
  yynewItem->yystate.yyisState = yytrue;
  yynewItem->yystate.yylrState = yylrState;
  yynewItem->yystate.yyposn = yyposn;
  yynewItem->yystate.yyresolved = yyfalse;
  yynewItem->yystate.yypred = yystack->yytops.yystates[yyk];
  yynewItem->yystate.yysemantics.yyfirstVal = NULL;
  yystack->yytops.yystates[yyk] = &yynewItem->yystate;
  yystack->yynextFree += 1;
  yystack->yyspaceLeft -= 1;
  yyaddDeferredAction (yystack, &yynewItem->yystate, rhs, yyrule);
}

/** Pop the symbols consumed by reduction #RULE from the top of stack
 *  #K of STACK, and perform the appropriate semantic action on their
 *  semantic values.  Assumes that all ambiguities in semantic values
 *  have been previously resolved. Set *VALP to the resulting value,
 *  and *LOCP to the computed location (if any).  Return value is as
 *  for userAction. */
static inline YYRESULTTAG
yydoAction (yyGLRStack* yystack, int yyk, yyRuleNum yyrule,
	    YYSTYPE* yyvalp, YYLTYPE* yylocp)
{
  int yynrhs = yyrhsLength (yyrule);

  if (yystack->yysplitPoint == NULL)
    {
      /* Standard special case: single stack. */
      yyGLRStackItem* rhs = (yyGLRStackItem*) yystack->yytops.yystates[yyk];
      YYASSERT (yyk == 0);
      yystack->yynextFree -= yynrhs;
      yystack->yyspaceLeft += yynrhs;
      yystack->yytops.yystates[0] = & yystack->yynextFree[-1].yystate;
      return yyuserAction (yyrule, yynrhs, rhs,
			   yyvalp, yylocp, yystack);
    }
  else
    {
      int yyi;
      yyGLRState* yys;
      yyGLRStackItem yyrhsVals[YYMAXRHS + YYMAXLEFT + 1];
      yys = yyrhsVals[YYMAXRHS + YYMAXLEFT].yystate.yypred
	= yystack->yytops.yystates[yyk];
      for (yyi = 0; yyi < yynrhs; yyi += 1)
	{
	  yys = yys->yypred;
	  YYASSERT (yys);
	}
      yyupdateSplit (yystack, yys);
      yystack->yytops.yystates[yyk] = yys;
      return yyuserAction (yyrule, yynrhs, yyrhsVals + YYMAXRHS + YYMAXLEFT - 1,
			   yyvalp, yylocp, yystack);
    }
}

#if !YYDEBUG
# define YY_REDUCE_PRINT(K, Rule)
#else
# define YY_REDUCE_PRINT(K, Rule)	\
do {					\
  if (yydebug)				\
    yy_reduce_print (K, Rule);		\
} while (0)

/*----------------------------------------------------------.
| Report that the RULE is going to be reduced on stack #K.  |
`----------------------------------------------------------*/

static inline void
yy_reduce_print (size_t yyk, yyRuleNum yyrule)
{
  int yyi;
  YYFPRINTF (stderr, "Reducing stack %lu by rule %d (line %lu), ",
	     (unsigned long int) yyk, yyrule - 1,
	     (unsigned long int) yyrline[yyrule]);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytokenName (yyrhs[yyi]));
  YYFPRINTF (stderr, "-> %s\n", yytokenName (yyr1[yyrule]));
}
#endif

/** Pop items off stack #K of STACK according to grammar rule RULE,
 *  and push back on the resulting nonterminal symbol.  Perform the
 *  semantic action associated with RULE and store its value with the
 *  newly pushed state, if FORCEEVAL or if STACK is currently
 *  unambiguous.  Otherwise, store the deferred semantic action with
 *  the new state.  If the new state would have an identical input
 *  position, LR state, and predecessor to an existing state on the stack,
 *  it is identified with that existing state, eliminating stack #K from
 *  the STACK. In this case, the (necessarily deferred) semantic value is
 *  added to the options for the existing state's semantic value.
 */
static inline YYRESULTTAG
yyglrReduce (yyGLRStack* yystack, size_t yyk, yyRuleNum yyrule,
             yybool yyforceEval)
{
  size_t yyposn = yystack->yytops.yystates[yyk]->yyposn;

  if (yyforceEval || yystack->yysplitPoint == NULL)
    {
      YYSTYPE yysval;
      YYLTYPE yyloc;

      YY_REDUCE_PRINT (yyk, yyrule);
      YYCHK (yydoAction (yystack, yyk, yyrule, &yysval, &yyloc));
      yyglrShift (yystack, yyk,
		  yyLRgotoState (yystack->yytops.yystates[yyk]->yylrState,
				 yylhsNonterm (yyrule)),
		  yyposn, yysval, &yyloc);
    }
  else
    {
      size_t yyi;
      int yyn;
      yyGLRState* yys, *yys0 = yystack->yytops.yystates[yyk];
      yyStateNum yynewLRState;

      for (yys = yystack->yytops.yystates[yyk], yyn = yyrhsLength (yyrule);
	   0 < yyn; yyn -= 1)
	{
	  yys = yys->yypred;
	  YYASSERT (yys);
	}
      yyupdateSplit (yystack, yys);
      yynewLRState = yyLRgotoState (yys->yylrState, yylhsNonterm (yyrule));
      YYDPRINTF ((stderr,
		  "Reduced stack %lu by rule #%d; action deferred. Now in state %d.\n",
		  (unsigned long int) yyk, yyrule - 1, yynewLRState));
      for (yyi = 0; yyi < yystack->yytops.yysize; yyi += 1)
	if (yyi != yyk && yystack->yytops.yystates[yyi] != NULL)
	  {
	    yyGLRState* yyp, *yysplit = yystack->yysplitPoint;
	    yyp = yystack->yytops.yystates[yyi];
	    while (yyp != yys && yyp != yysplit && yyp->yyposn >= yyposn)
	      {
		if (yyp->yylrState == yynewLRState && yyp->yypred == yys)
		  {
		    yyaddDeferredAction (yystack, yyp, yys0, yyrule);
		    yymarkStackDeleted (yystack, yyk);
		    YYDPRINTF ((stderr, "Merging stack %lu into stack %lu.\n",
				(unsigned long int) yyk,
				(unsigned long int) yyi));
		    return yyok;
		  }
		yyp = yyp->yypred;
	      }
	  }
      yystack->yytops.yystates[yyk] = yys;
      yyglrShiftDefer (yystack, yyk, yynewLRState, yyposn, yys0, yyrule);
    }
  return yyok;
}

static int
yysplitStack (yyGLRStack* yystack, int yyk)
{
  if (yystack->yysplitPoint == NULL)
    {
      YYASSERT (yyk == 0);
      yystack->yysplitPoint = yystack->yytops.yystates[yyk];
    }
  if (yystack->yytops.yysize >= yystack->yytops.yycapacity)
    {
      yystack->yytops.yycapacity *= 2;
      yystack->yytops.yystates =
	(yyGLRState**) YYREALLOC (yystack->yytops.yystates,
				  (yystack->yytops.yycapacity
				   * sizeof yystack->yytops.yystates[0]));
    }
  yystack->yytops.yystates[yystack->yytops.yysize]
    = yystack->yytops.yystates[yyk];
  yystack->yytops.yysize += 1;
  return yystack->yytops.yysize-1;
}

/** True iff Y0 and Y1 represent identical options at the top level.
 *  That is, they represent the same rule applied to RHS symbols
 *  that produce the same terminal symbols. */
static yybool
yyidenticalOptions (yySemanticOption* yyy0, yySemanticOption* yyy1)
{
  if (yyy0->yyrule == yyy1->yyrule)
    {
      yyGLRState *yys0, *yys1;
      int yyn;
      for (yys0 = yyy0->yystate, yys1 = yyy1->yystate,
	   yyn = yyrhsLength (yyy0->yyrule);
	   yyn > 0;
	   yys0 = yys0->yypred, yys1 = yys1->yypred, yyn -= 1)
	if (yys0->yyposn != yys1->yyposn)
	  return yyfalse;
      return yytrue;
    }
  else
    return yyfalse;
}

/** Assuming identicalOptions (Y0,Y1), (destructively) merge the
 *  alternative semantic values for the RHS-symbols of Y1 into the
 *  corresponding semantic value sets of the symbols of Y0. */
static void
yymergeOptionSets (yySemanticOption* yyy0, yySemanticOption* yyy1)
{
  yyGLRState *yys0, *yys1;
  int yyn;
  for (yys0 = yyy0->yystate, yys1 = yyy1->yystate,
       yyn = yyrhsLength (yyy0->yyrule);
       yyn > 0;
       yys0 = yys0->yypred, yys1 = yys1->yypred, yyn -= 1)
    if (yys0 == yys1)
      break;
    else if (! yys0->yyresolved && ! yys1->yyresolved)
      {
	yySemanticOption* yyz;
	for (yyz = yys0->yysemantics.yyfirstVal; yyz->yynext != NULL;
	     yyz = yyz->yynext)
	  continue;
	yyz->yynext = yys1->yysemantics.yyfirstVal;
      }
}

/** Y0 and Y1 represent two possible actions to take in a given
 *  parsing state; return 0 if no combination is possible,
 *  1 if user-mergeable, 2 if Y0 is preferred, 3 if Y1 is preferred. */
static int
yypreference (yySemanticOption* y0, yySemanticOption* y1)
{
  yyRuleNum r0 = y0->yyrule, r1 = y1->yyrule;
  int p0 = yydprec[r0], p1 = yydprec[r1];

  if (p0 == p1)
    {
      if (yymerger[r0] == 0 || yymerger[r0] != yymerger[r1])
	return 0;
      else
	return 1;
    }
  if (p0 == 0 || p1 == 0)
    return 0;
  if (p0 < p1)
    return 3;
  if (p1 < p0)
    return 2;
  return 0;
}

static YYRESULTTAG yyresolveValue (yySemanticOption* yyoptionList,
				   yyGLRStack* yystack, YYSTYPE* yyvalp,
				   YYLTYPE* yylocp);

static YYRESULTTAG
yyresolveStates (yyGLRState* yys, int yyn, yyGLRStack* yystack)
{
  YYRESULTTAG yyflag;
  if (0 < yyn)
    {
      YYASSERT (yys->yypred);
      yyflag = yyresolveStates (yys->yypred, yyn-1, yystack);
      if (yyflag != yyok)
	return yyflag;
      if (! yys->yyresolved)
	{
	  yyflag = yyresolveValue (yys->yysemantics.yyfirstVal, yystack,
				   &yys->yysemantics.yysval, &yys->yyloc
				  );
	  if (yyflag != yyok)
	    return yyflag;
	  yys->yyresolved = yytrue;
	}
    }
  return yyok;
}

static YYRESULTTAG
yyresolveAction (yySemanticOption* yyopt, yyGLRStack* yystack,
	         YYSTYPE* yyvalp, YYLTYPE* yylocp)
{
  yyGLRStackItem yyrhsVals[YYMAXRHS + YYMAXLEFT + 1];
  int yynrhs;

  yynrhs = yyrhsLength (yyopt->yyrule);
  YYCHK (yyresolveStates (yyopt->yystate, yynrhs, yystack));
  yyrhsVals[YYMAXRHS + YYMAXLEFT].yystate.yypred = yyopt->yystate;
  return yyuserAction (yyopt->yyrule, yynrhs,
		       yyrhsVals + YYMAXRHS + YYMAXLEFT - 1,
		       yyvalp, yylocp, yystack);
}

#if YYDEBUG
static void
yyreportTree (yySemanticOption* yyx, int yyindent)
{
  int yynrhs = yyrhsLength (yyx->yyrule);
  int yyi;
  yyGLRState* yys;
  yyGLRState* yystates[YYMAXRHS];
  yyGLRState yyleftmost_state;

  for (yyi = yynrhs, yys = yyx->yystate; 0 < yyi; yyi -= 1, yys = yys->yypred)
    yystates[yyi] = yys;
  if (yys == NULL)
    {
      yyleftmost_state.yyposn = 0;
      yystates[0] = &yyleftmost_state;
    }
  else
    yystates[0] = yys;

  if (yyx->yystate->yyposn < yys->yyposn + 1)
    YYFPRINTF (stderr, "%*s%s -> <Rule %d, empty>\n",
	       yyindent, "", yytokenName (yylhsNonterm (yyx->yyrule)),
	       yyx->yyrule);
  else
    YYFPRINTF (stderr, "%*s%s -> <Rule %d, tokens %lu .. %lu>\n",
	       yyindent, "", yytokenName (yylhsNonterm (yyx->yyrule)),
	       yyx->yyrule, (unsigned long int) (yys->yyposn + 1),
	       (unsigned long int) yyx->yystate->yyposn);
  for (yyi = 1; yyi <= yynrhs; yyi += 1)
    {
      if (yystates[yyi]->yyresolved)
	{
	  if (yystates[yyi-1]->yyposn+1 > yystates[yyi]->yyposn)
	    YYFPRINTF (stderr, "%*s%s <empty>\n", yyindent+2, "",
		       yytokenName (yyrhs[yyprhs[yyx->yyrule]+yyi-1]));
	  else
	    YYFPRINTF (stderr, "%*s%s <tokens %lu .. %lu>\n", yyindent+2, "",
		       yytokenName (yyrhs[yyprhs[yyx->yyrule]+yyi-1]),
		       (unsigned long int) (yystates[yyi - 1]->yyposn + 1),
		       (unsigned long int) yystates[yyi]->yyposn);
	}
      else
	yyreportTree (yystates[yyi]->yysemantics.yyfirstVal, yyindent+2);
    }
}
#endif

static void
yyreportAmbiguity (yySemanticOption* yyx0, yySemanticOption* yyx1,
		   yyGLRStack* yystack)
{
  /* `Unused' warnings.  */
  (void) yyx0;
  (void) yyx1;

#if YYDEBUG
  YYFPRINTF (stderr, "Ambiguity detected.\n");
  YYFPRINTF (stderr, "Option 1,\n");
  yyreportTree (yyx0, 2);
  YYFPRINTF (stderr, "\nOption 2,\n");
  yyreportTree (yyx1, 2);
  YYFPRINTF (stderr, "\n");
#endif
  yyFail (yystack, "ambiguity detected");
}


/** Resolve the ambiguity represented by OPTIONLIST, perform the indicated
 *  actions, and return the result. */
static YYRESULTTAG
yyresolveValue (yySemanticOption* yyoptionList, yyGLRStack* yystack,
		YYSTYPE* yyvalp, YYLTYPE* yylocp)
{
  yySemanticOption* yybest;
  yySemanticOption* yyp;
  int yymerge;

  yybest = yyoptionList;
  yymerge = 0;
  for (yyp = yyoptionList->yynext; yyp != NULL; yyp = yyp->yynext)
    {
      if (yyidenticalOptions (yybest, yyp))
	yymergeOptionSets (yybest, yyp);
      else
	switch (yypreference (yybest, yyp))
	  {
	  case 0:
	    yyreportAmbiguity (yybest, yyp, yystack);
	    break;
	  case 1:
	    yymerge = 1;
	    break;
	  case 2:
	    break;
	  case 3:
	    yybest = yyp;
	    yymerge = 0;
	    break;
	  }
    }

  if (yymerge)
    {
      int yyprec = yydprec[yybest->yyrule];
      YYCHK (yyresolveAction (yybest, yystack, yyvalp, yylocp));
      for (yyp = yybest->yynext; yyp != NULL; yyp = yyp->yynext)
	{
	  if (yyprec == yydprec[yyp->yyrule])
	    {
	      YYSTYPE yyval1;
	      YYLTYPE yydummy;
	      YYCHK (yyresolveAction (yyp, yystack, &yyval1, &yydummy));
	      yyuserMerge (yymerger[yyp->yyrule], yyvalp, &yyval1);
	    }
	}
      return yyok;
    }
  else
    return yyresolveAction (yybest, yystack, yyvalp, yylocp);
}

static YYRESULTTAG
yyresolveStack (yyGLRStack* yystack)
{
  if (yystack->yysplitPoint != NULL)
    {
      yyGLRState* yys;
      int yyn;

      for (yyn = 0, yys = yystack->yytops.yystates[0];
	   yys != yystack->yysplitPoint;
	   yys = yys->yypred, yyn += 1)
	continue;
      YYCHK (yyresolveStates (yystack->yytops.yystates[0], yyn, yystack
			     ));
    }
  return yyok;
}

static void
yycompressStack (yyGLRStack* yystack)
{
  yyGLRState* yyp, *yyq, *yyr;

  if (yystack->yytops.yysize != 1 || yystack->yysplitPoint == NULL)
    return;

  for (yyp = yystack->yytops.yystates[0], yyq = yyp->yypred, yyr = NULL;
       yyp != yystack->yysplitPoint;
       yyr = yyp, yyp = yyq, yyq = yyp->yypred)
    yyp->yypred = yyr;

  yystack->yyspaceLeft += yystack->yynextFree - yystack->yyitems;
  yystack->yynextFree = ((yyGLRStackItem*) yystack->yysplitPoint) + 1;
  yystack->yyspaceLeft -= yystack->yynextFree - yystack->yyitems;
  yystack->yysplitPoint = NULL;
  yystack->yylastDeleted = NULL;

  while (yyr != NULL)
    {
      yystack->yynextFree->yystate = *yyr;
      yyr = yyr->yypred;
      yystack->yynextFree->yystate.yypred = & yystack->yynextFree[-1].yystate;
      yystack->yytops.yystates[0] = &yystack->yynextFree->yystate;
      yystack->yynextFree += 1;
      yystack->yyspaceLeft -= 1;
    }
}

static YYRESULTTAG
yyprocessOneStack (yyGLRStack* yystack, int yyk,
	           size_t yyposn, YYSTYPE* yylvalp, YYLTYPE* yyllocp
		  )
{
  int yyaction;
  const short int* yyconflicts;
  yyRuleNum yyrule;
  yySymbol* const yytokenp = yystack->yytokenp;

  while (yystack->yytops.yystates[yyk] != NULL)
    {
      yyStateNum yystate = yystack->yytops.yystates[yyk]->yylrState;
      YYDPRINTF ((stderr, "Stack %d Entering state %d\n", yyk, yystate));

      YYASSERT (yystate != YYFINAL);

      if (yyisDefaultedState (yystate))
	{
	  yyrule = yydefaultAction (yystate);
	  if (yyrule == 0)
	    {
	      YYDPRINTF ((stderr, "Stack %d dies.\n", yyk));
	      yymarkStackDeleted (yystack, yyk);
	      return yyok;
	    }
	  YYCHK (yyglrReduce (yystack, yyk, yyrule, yyfalse));
	}
      else
	{
	  if (*yytokenp == YYEMPTY)
	    {
	      YYDPRINTF ((stderr, "Reading a token: "));
	      yychar = YYLEX;
	      *yytokenp = YYTRANSLATE (yychar);
	      YY_SYMBOL_PRINT ("Next token is", *yytokenp, yylvalp, yyllocp);
	    }
	  yygetLRActions (yystate, *yytokenp, &yyaction, &yyconflicts);

	  while (*yyconflicts != 0)
	    {
	      int yynewStack = yysplitStack (yystack, yyk);
	      YYDPRINTF ((stderr, "Splitting off stack %d from %d.\n",
			  yynewStack, yyk));
	      YYCHK (yyglrReduce (yystack, yynewStack,
				  *yyconflicts, yyfalse));
	      YYCHK (yyprocessOneStack (yystack, yynewStack, yyposn,
					yylvalp, yyllocp));
	      yyconflicts += 1;
	    }

	  if (yyisShiftAction (yyaction))
	    {
	      YYDPRINTF ((stderr, "On stack %d, ", yyk));
	      YY_SYMBOL_PRINT ("shifting", *yytokenp, yylvalp, yyllocp);
	      yyglrShift (yystack, yyk, yyaction, yyposn+1,
			  *yylvalp, yyllocp);
	      YYDPRINTF ((stderr, ", now in state #%d\n",
			  yystack->yytops.yystates[yyk]->yylrState));
	      break;
	    }
	  else if (yyisErrorAction (yyaction))
	    {
	      YYDPRINTF ((stderr, "Stack %d dies.\n", yyk));
	      yymarkStackDeleted (yystack, yyk);
	      break;
	    }
	  else
	    YYCHK (yyglrReduce (yystack, yyk, -yyaction, yyfalse));
	}
    }
  return yyok;
}

static void
yyreportSyntaxError (yyGLRStack* yystack,
		     YYSTYPE* yylvalp, YYLTYPE* yyllocp)
{
  /* `Unused' warnings. */
  (void) yylvalp;
  (void) yyllocp;

  if (yystack->yyerrState == 0)
    {
#if YYERROR_VERBOSE
      yySymbol* const yytokenp = yystack->yytokenp;
      int yyn;
      yyn = yypact[yystack->yytops.yystates[0]->yylrState];
      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  size_t yysize = 0;
	  const char* yyprefix;
	  char* yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += strlen (yyprefix) + strlen (yytokenName (yyx));
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
		yyprefix = " or ";
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + strlen (yytokenName (*yytokenp)));
	  yymsg = (char*) YYMALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char* yyp = yymsg;
	      sprintf (yyp, "syntax error%s%s",
		       (*yytokenp == YYEMPTY ? "" : ", unexpected "),
		       yytokenName (*yytokenp));
	      yyp += strlen (yyp);
	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			sprintf (yyp, "%s%s", yyprefix, yytokenName (yyx));
			yyp += strlen (yyp);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYFREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
      yynerrs += 1;
    }
}

/* Recover from a syntax error on YYSTACK, assuming that YYTOKENP,
   YYLVALP, and YYLLOCP point to the syntactic category, semantic
   value, and location of the look-ahead.  */
static void
yyrecoverSyntaxError (yyGLRStack* yystack,
		      YYSTYPE* yylvalp,
		      YYLTYPE* yyllocp
		      )
{
  yySymbol* const yytokenp = yystack->yytokenp;
  size_t yyk;
  int yyj;

  if (yystack->yyerrState == 3)
    /* We just shifted the error token and (perhaps) took some
       reductions.  Skip tokens until we can proceed.  */
    while (yytrue)
      {
	if (*yytokenp == YYEOF)
	  {
	    /* Now pop stack until empty and fail. */
	    while (yystack->yytops.yystates[0] != NULL)
	      {
		yyGLRState *yys = yystack->yytops.yystates[0];
		yystack->yyerror_range[1].yystate.yyloc = yys->yyloc;
		yydestruct ("Error: popping",
                            yystos[yys->yylrState],
			    &yys->yysemantics.yysval, &yys->yyloc);
		yystack->yytops.yystates[0] = yys->yypred;
		yystack->yynextFree -= 1;
		yystack->yyspaceLeft += 1;
	      }
	    yyFail (yystack, NULL);
	  }
	if (*yytokenp != YYEMPTY)
	  {
	    /* We throw away the lookahead, but the error range
	       of the shifted error token must take it into account. */
	    yyGLRState *yys = yystack->yytops.yystates[0];
	    yyGLRStackItem yyerror_range[3];
	    yyerror_range[1].yystate.yyloc = yys->yyloc;
	    yyerror_range[2].yystate.yyloc = *yyllocp;
	    YYLLOC_DEFAULT (yys->yyloc, yyerror_range, 2);
	    yydestruct ("Error: discarding",
			*yytokenp, yylvalp, yyllocp);
	  }
	YYDPRINTF ((stderr, "Reading a token: "));
	yychar = YYLEX;
	*yytokenp = YYTRANSLATE (yychar);
	YY_SYMBOL_PRINT ("Next token is", *yytokenp, yylvalp, yyllocp);
	yyj = yypact[yystack->yytops.yystates[0]->yylrState];
	if (yyis_pact_ninf (yyj))
	  return;
	yyj += *yytokenp;
	if (yyj < 0 || YYLAST < yyj || yycheck[yyj] != *yytokenp)
	  {
	    if (yydefact[yystack->yytops.yystates[0]->yylrState] != 0)
	      return;
	  }
	else if (yytable[yyj] != 0 && ! yyis_table_ninf (yytable[yyj]))
	  return;
      }

  /* Reduce to one stack.  */
  for (yyk = 0; yyk < yystack->yytops.yysize; yyk += 1)
    if (yystack->yytops.yystates[yyk] != NULL)
      break;
  if (yyk >= yystack->yytops.yysize)
    yyFail (yystack, NULL);
  for (yyk += 1; yyk < yystack->yytops.yysize; yyk += 1)
    yymarkStackDeleted (yystack, yyk);
  yyremoveDeletes (yystack);
  yycompressStack (yystack);

  /* Now pop stack until we find a state that shifts the error token. */
  yystack->yyerrState = 3;
  while (yystack->yytops.yystates[0] != NULL)
    {
      yyGLRState *yys = yystack->yytops.yystates[0];
      yyj = yypact[yys->yylrState];
      if (! yyis_pact_ninf (yyj))
	{
	  yyj += YYTERROR;
	  if (0 <= yyj && yyj <= YYLAST && yycheck[yyj] == YYTERROR
	      && yyisShiftAction (yytable[yyj]))
	    {
	      /* Shift the error token having adjusted its location.  */
	      YYLTYPE yyerrloc;
	      yystack->yyerror_range[2].yystate.yyloc = *yyllocp;
	      YYLLOC_DEFAULT (yyerrloc, yystack->yyerror_range, 2);
	      YY_SYMBOL_PRINT ("Shifting", yystos[yytable[yyj]],
			       yylvalp, &yyerrloc);
	      yyglrShift (yystack, 0, yytable[yyj],
			  yys->yyposn, *yylvalp, &yyerrloc);
	      yys = yystack->yytops.yystates[0];
	      break;
	    }
	}
      yystack->yyerror_range[1].yystate.yyloc = yys->yyloc;
      yydestruct ("Error: popping",
		  yystos[yys->yylrState],
	          &yys->yysemantics.yysval, &yys->yyloc);
      yystack->yytops.yystates[0] = yys->yypred;
      yystack->yynextFree -= 1;
      yystack->yyspaceLeft += 1;
    }
  if (yystack->yytops.yystates[0] == NULL)
    yyFail (yystack, NULL);
}

#define YYCHK1(YYE)							     \
  do {									     \
    switch (YYE) {							     \
    default:								     \
      break;								     \
    case yyabort:							     \
      yystack.yyerrflag = 1;						     \
      goto yyDone;							     \
    case yyaccept:							     \
      yystack.yyerrflag = 0;						     \
      goto yyDone;							     \
    case yyerr:								     \
      goto yyuser_error;						     \
    }									     \
  } while (0)


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
  yySymbol yytoken;
  yyGLRStack yystack;
  size_t yyposn;


  YYSTYPE* const yylvalp = &yylval;
  YYLTYPE* const yyllocp = &yylloc;

  yyinitGLRStack (&yystack, YYINITDEPTH);
  yystack.yytokenp = &yytoken;

  YYDPRINTF ((stderr, "Starting parse\n"));

  if (setjmp (yystack.yyexception_buffer) != 0)
    goto yyDone;

  yylval = yyval_default;

#if YYLTYPE_IS_TRIVIAL
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 0;
#endif


  yyglrShift (&yystack, 0, 0, 0, yylval, &yylloc);
  yytoken = YYEMPTY;
  yyposn = 0;

  while (yytrue)
    {
      /* For efficiency, we have two loops, the first of which is
	 specialized to deterministic operation (single stack, no
	 potential ambiguity).  */
      /* Standard mode */
      while (yytrue)
	{
	  yyRuleNum yyrule;
	  int yyaction;
	  const short int* yyconflicts;

	  yyStateNum yystate = yystack.yytops.yystates[0]->yylrState;
          YYDPRINTF ((stderr, "Entering state %d\n", yystate));
	  if (yystate == YYFINAL)
	    goto yyDone;
	  if (yyisDefaultedState (yystate))
	    {
	      yyrule = yydefaultAction (yystate);
	      if (yyrule == 0)
		{
		  yystack.yyerror_range[1].yystate.yyloc = *yyllocp;
		  yyreportSyntaxError (&yystack, yylvalp, yyllocp);
		  goto yyuser_error;
		}
	      YYCHK1 (yyglrReduce (&yystack, 0, yyrule, yytrue));
	    }
	  else
	    {
	      if (yytoken == YYEMPTY)
		{
		  YYDPRINTF ((stderr, "Reading a token: "));
		  yychar = YYLEX;
		  yytoken = YYTRANSLATE (yychar);
                  YY_SYMBOL_PRINT ("Next token is", yytoken, yylvalp, yyllocp);
		}
	      yygetLRActions (yystate, yytoken, &yyaction, &yyconflicts);
	      if (*yyconflicts != 0)
		break;
	      if (yyisShiftAction (yyaction))
		{
		  YY_SYMBOL_PRINT ("Shifting", yytoken, yylvalp, yyllocp);
		  if (yytoken != YYEOF)
		    yytoken = YYEMPTY;
		  yyposn += 1;
		  yyglrShift (&yystack, 0, yyaction, yyposn,
		              yylval, yyllocp);
		  if (0 < yystack.yyerrState)
		    yystack.yyerrState -= 1;
		}
	      else if (yyisErrorAction (yyaction))
		{
		  yystack.yyerror_range[1].yystate.yyloc = *yyllocp;
		  yyreportSyntaxError (&yystack, yylvalp, yyllocp);
		  goto yyuser_error;
		}
	      else
		YYCHK1 (yyglrReduce (&yystack, 0, -yyaction, yytrue));
	    }
	}

      while (yytrue)
	{
	  int yys;
	  int yyn = yystack.yytops.yysize;
	  for (yys = 0; yys < yyn; yys += 1)
	    YYCHK1 (yyprocessOneStack (&yystack, yys, yyposn,
				       yylvalp, yyllocp));
	  yytoken = YYEMPTY;
	  yyposn += 1;
	  yyremoveDeletes (&yystack);
	  if (yystack.yytops.yysize == 0)
	    {
	      yyundeleteLastStack (&yystack);
	      if (yystack.yytops.yysize == 0)
		yyFail (&yystack, "syntax error");
	      YYCHK1 (yyresolveStack (&yystack));
	      YYDPRINTF ((stderr, "Returning to deterministic operation.\n"));
	      yystack.yyerror_range[1].yystate.yyloc = *yyllocp;
	      yyreportSyntaxError (&yystack, yylvalp, yyllocp);
	      goto yyuser_error;
	    }
	  else if (yystack.yytops.yysize == 1)
	    {
	      YYCHK1 (yyresolveStack (&yystack));
	      YYDPRINTF ((stderr, "Returning to deterministic operation.\n"));
	      yycompressStack (&yystack);
	      break;
	    }
	}
      continue;
    yyuser_error:
      yyrecoverSyntaxError (&yystack, yylvalp, yyllocp);
      yyposn = yystack.yytops.yystates[0]->yyposn;
    }
 yyDone:
  /* On YYABORT, free the lookahead. */
  if (yystack.yyerrflag == 1 && yytoken != YYEMPTY)
    yydestruct ("Error: discarding lookahead",
                yytoken, yylvalp, yyllocp);

  yyfreeGLRStack (&yystack);
  return yystack.yyerrflag;
}

/* DEBUGGING ONLY */
#ifdef YYDEBUG
static void yypstack (yyGLRStack* yystack, int yyk) ATTRIBUTE_UNUSED;
static void yypdumpstack (yyGLRStack* yystack) ATTRIBUTE_UNUSED;

static void
yy_yypstack (yyGLRState* yys)
{
  if (yys->yypred)
    {
      yy_yypstack (yys->yypred);
      fprintf (stderr, " -> ");
    }
  fprintf (stderr, "%d@%lu", yys->yylrState, (unsigned long int) yys->yyposn);
}

static void
yypstates (yyGLRState* yyst)
{
  if (yyst == NULL)
    fprintf (stderr, "<null>");
  else
    yy_yypstack (yyst);
  fprintf (stderr, "\n");
}

static void
yypstack (yyGLRStack* yystack, int yyk)
{
  yypstates (yystack->yytops.yystates[yyk]);
}

#define YYINDEX(YYX)							     \
    ((YYX) == NULL ? -1 : (yyGLRStackItem*) (YYX) - yystack->yyitems)


static void
yypdumpstack (yyGLRStack* yystack)
{
  yyGLRStackItem* yyp;
  size_t yyi;
  for (yyp = yystack->yyitems; yyp < yystack->yynextFree; yyp += 1)
    {
      fprintf (stderr, "%3lu. ", (unsigned long int) (yyp - yystack->yyitems));
      if (*(yybool *) yyp)
	{
	  fprintf (stderr, "Res: %d, LR State: %d, posn: %lu, pred: %ld",
		   yyp->yystate.yyresolved, yyp->yystate.yylrState,
		   (unsigned long int) yyp->yystate.yyposn,
		   (long int) YYINDEX (yyp->yystate.yypred));
	  if (! yyp->yystate.yyresolved)
	    fprintf (stderr, ", firstVal: %ld",
		     (long int) YYINDEX (yyp->yystate.yysemantics.yyfirstVal));
	}
      else
	{
	  fprintf (stderr, "Option. rule: %d, state: %ld, next: %ld",
		   yyp->yyoption.yyrule,
		   (long int) YYINDEX (yyp->yyoption.yystate),
		   (long int) YYINDEX (yyp->yyoption.yynext));
	}
      fprintf (stderr, "\n");
    }
  fprintf (stderr, "Tops:");
  for (yyi = 0; yyi < yystack->yytops.yysize; yyi += 1)
    fprintf (stderr, "%lu: %ld; ", (unsigned long int) yyi,
	     (long int) YYINDEX (yystack->yytops.yystates[yyi]));
  fprintf (stderr, "\n");
}
#endif


#line 2283 "parse.y"


/* Check the order of declarations for various standards */
static int
check_decl_order (int prev, int new)
{
  int prev_decl_order = prev / 2, prev_import = prev & 1;
  if (new == od_none)
    return prev;
  if (new <= prev_decl_order && new < od_routine)
    chk_dialect ("mixed order of declaration parts is", NOT_CLASSIC_PASCAL);
  if (new == od_uses)
    {
      if (prev_import)
        chk_dialect ("multiple `uses' parts are", GNU_PASCAL);
      if (prev_decl_order > od_uses)
        chk_dialect ("`uses' after other declarations is", GNU_PASCAL);
      prev_import = 1;
    }
  return (2 * new) | prev_import;
}

static void
locations (YYLTYPE *dest, const /*YYLTYPE*/ union yyGLRStackItem *src, int n)
{
  int i;
  for (i = n; i > 0 && !YYRHSLOC (src, i).first_line; i--) ;
  if (i == 0)
    {
      input_filename = compiler_filename;
      lineno = compiler_lineno;
      column = compiler_column;
      dest->first_file = dest->last_file = NULL;
      dest->first_line = dest->last_line = dest->first_column = dest->last_column = 0;
    }
  else
    {
      input_filename = compiler_filename = dest->last_file = YYRHSLOC (src, i).last_file;
      lineno = compiler_lineno = dest->last_line = YYRHSLOC (src, i).last_line;
      column = compiler_column = dest->last_column = YYRHSLOC (src, i).last_column;
      for (i = 1; i <= n && !YYRHSLOC (src, i).first_line; i++) ;
      dest->first_file = YYRHSLOC (src, i).first_file;
      dest->first_line = YYRHSLOC (src, i).first_line;
      dest->first_column = YYRHSLOC (src, i).first_column;
      /* This does emit a few line notes too many. But putting line notes in the
         parser in the right places causes some conflicts (especially
         assignments with nontrivial expressions on their left side are
         problematic). A better solution might be possible when we don't emit
         things so early. */
      if (current_function_decl)
#ifndef GCC_3_4
        emit_line_note (dest->first_file, dest->first_line);
#else
        {
          location_t loc_aux;
          loc_aux.file = dest->first_file;
          loc_aux.line = dest->first_line;
          emit_line_note (loc_aux);
        }
#endif
    }
  dest->option_id = 0;
  for (i = 1; i <= n; i++)
    while (YYRHSLOC (src, i).option_id > compiler_options->counter)
      {
        struct options *tmp = compiler_options;
        compiler_options = tmp->next;
        free (tmp);
      }
  if (compiler_options != co)
    activate_options (compiler_options, 0);
}

/* Set the value of the 'yydebug' variable to VALUE. This is a function
   so we don't have to have YYDEBUG defined in order to build the compiler. */
void
set_yydebug (int value)
{
#if YYDEBUG != 0
  yydebug = value;
#else
  warning ("YYDEBUG not defined.");
#endif
}

#undef yyparse
int
yyparse (void)
{
  init_predef ();
  return main_yyparse ();
}

